-- name=common_impl
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Init()

  ----------------------------------------------------------------------------------
  private.LoadStandardCursors();
  ----------------------------------------------------------------------------------
  common.SetCheaterKeyF( 1, "level1" );
  common.SetCheaterKeyF( 2, "level2" );
  common.SetCheaterKeyF( 3, "level3" );
  common.SetCheaterKeyF( 4, "levelext" );
  common.SetCheaterKeyF( 5, "levelscr" );
  public.subscribers_included = true;
  private.timers = {};
  ----------------------------------------------------------------------------------
  -- Инициализация хаба
  cmn.audio = {};
  private.audio = {};
  private.audio[ "sfx" ] = {};
  private.audio[ "env" ] = {};
  private.audio[ "mus" ] = {};
  private.audio[ "voc" ] = {};
  private.audio[ "mus_env" ] = {};
  private.AudioInit();
  ----------------------------------------------------------------------------------
  -- открытие записок
  private.note = {};
  private.note.scale = {};
  private.note.scale.pos_x = 0;
  private.note.scale.pos_y = 0;
  cmn.NoteScale = private.NoteScale;
  cmn.NoteScaleEnd = private.NoteScaleEnd;
  ----------------------------------------------------------------------------------
  private.is_openbrowser_enabled = true; --разрешение открытия браузера
  ----------------------------------------------------------------------------------
  ----------------------------------------------------------------------------------
  public.animtime = 0.3;  
 -------------------hint-----------------------------------------------------------
  public.show_hint = {};
  public.save_autohide = 1;
  ----------------------------------------------------------------------------------
  public.hint ={};
  public.hint.secret ={};
  public.hint.res = "assets/interface/resources/fx/hint/fx_hint01";
  public.hint.res_center = "assets/interface/resources/fx/hint/fx_hint_ring"; -- ресурс на дополнительный эффект хинта
  public.hint.res_inv = "assets/interface/resources/fx/hint/fx_hint_inventory"; -- ресурс для хинта на инвентарь
  public.hint.big_R = 500;
  public.hint.big_R_zz = 500;
  public.hint.small_R = 40;
  public.hint.partsys_count = 6; -- количество систем частиц
  public.hint.time_fly = 1.0;    -- время, за которое частицы долетят до цели
  public.hint.time_fly_zz = 0.8; -- время для зум-зоны
  public.hint.time_circle = 3.0; -- время на один сдвиг по кругу
  public.hint.circle_cnt = 0.5;     -- количество сдвигов частиц по кругу
  public.hint.tme_show = 0.4;
  public.hint.tme_hide = 0.4;
  public.hint.tme_circle_fx = 1.0 --время показа центральной частицы
  public.hint.sinus_offset = 70 --амплитуда синусоиды
  public.hint.sinus_points_cnt = 50 --количество точек синусоиды
  public.hint.sinus_points_extrems = 2; --количество экстремумов синусоиды
  public.hint.play_sfx=true; --звук хинта в сложном объекте
  public.hint.target = {}
  public.hint.position_zz = {}
  ----------------------------------------------------------------------------------
  public.dialog_pos = {}; --массив позиций для грида диалогов
  public.dialog_character_loc = "";
  public.dialog_env_after = {};
  public.dial_icons = {};
  public.is_in_map = 0;
  ----------------------------------------------------------------------------------
  
  cmn.SetEventDone        = public.SetEventDone;
  cmn.IsEventDone         = public.IsEventDone;
  cmn.SetEventStart       = public.SetEventStart;
  cmn.IsEventStart        = public.IsEventStart;
  cmn.HoTaskFind          = public.HoTaskFind;
  cmn.HoItemFind          = public.HoItemFind;
  cmn.HoItemOff           = public.HoItemOff;
  cmn.MiniGameHide        = public.MiniGameHide;
  cmn.MiniGameShow        = public.MiniGameShow;
  cmn.SetMarkedTask       = public.SetMarkedTask;
  cmn.UnmarkTask          = public.UnmarkTask;
  cmn.IsUnmarkedTask      = public.IsUnmarkedTask;
  cmn.InitHo              = public.InitHo;
  cmn.GotoRoom            = common.GotoRoom;
  cmn.GotoSubRoom         = common.GotoSubRoom;
  cmn.ApplyObj            = private.ApplyObj;
  cmn.WrongApply          = private.WrongApply;
  cmn.UseItem             = public.UseItem;
  cmn.CloseSubRoom        = common.CloseSubRoom;
  cmn.ShowBbt             = public.ShowBbt;
  cmn.PopupShow           = public.PopupShow;
  cmn.PopupHide           = public.PopupHide;
  cmn.ShowDeployInv       = public.ShowDeployInv;
  cmn.GateMouseEnter      = public.GateMouseEnter;
  cmn.GateMouseLeave      = public.GateMouseLeave;
  cmn.TutorialShow        = public.TutorialShow;
  cmn.TutorialSetShown    = public.TutorialSetShown;
  cmn.GetInvObjectSfx     = private.GetInvObjectSfx;
  cmn.GetObjectSfx        = private.GetObjectSfx;
  cmn.InterfaceSetVisible = public.InterfaceSetVisible; 
  cmn.InterfaceSetInput   = public.InterfaceSetInput;
  cmn.SetCursor           = private.SetCursor;
  cmn.AddPageDiary        = private.AddPageDiary;
  cmn.DialogWindowShow    = common.DialogWindowShow;
  cmn.SecretroomInit      = private.SecretroomInit;
  cmn.SecretroomhAddObj       = public.SecretroomhAddObj;
  cmn.SrartMorphItemSecret    = public.SrartMorphItemSecret;
  cmn.MorphingSecretLoad      = public.MorphingSecretLoad;
  cmn.StartMorhpTask          = public.StartMorhpTask;
  cmn.ResetSecretroom         = public.ResetSecretroom;
  cmn.DefaultMorphItemSecret  = public.DefaultMorphItemSecret;
  cmn.CheckGiveCustomAchiev   = public.CheckGiveCustomAchiev
  ----------------------------------------------------------------------------------
  private.volume_fade = false;
  private.dialog_voice = 0;
  private.dialog_soundtrack = 0;
  private.dialog_env = 0;
  ----------------------------------------------------------------------------------
  private.AchievementsInit();
  ----------------------------------------------------------------------------------
  private.print = {};
  ----------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--***function *** CURSOR *** () end************************************************************************************
--*********************************************************************************************************************
  function private.LoadStandardCursors()

    --[[
    case 0:  pWinCursor = NULL; break;
    case 1:  pWinCursor = IDC_APPSTARTING; break;
    case 2:  pWinCursor = IDC_ARROW; break;
    case 3:  pWinCursor = IDC_CROSS; break;
    case 4:  pWinCursor = IDC_HAND; break;
    case 5:  pWinCursor = IDC_HELP; break;
    case 6:  pWinCursor = IDC_IBEAM; break;
    case 7:  pWinCursor = IDC_ICON; break;
    case 8:  pWinCursor = IDC_NO; break;
    case 9:  pWinCursor = IDC_SIZE; break;
    case 10: pWinCursor = IDC_SIZEALL; break;
    case 11: pWinCursor = IDC_SIZENESW; break;
    case 12: pWinCursor = IDC_SIZENS; break;
    case 13: pWinCursor = IDC_SIZEWE; break;
    case 14: pWinCursor = IDC_UPARROW; break;
    case 15: pWinCursor = IDC_WAIT; break;
    ]]

    common.CursorLoad( "CURSOR_NULL",    "",                            0  );
    common.CursorLoad( "CURSOR_DEFAULT", "assets/cursors/cursor",       2  );
    common.CursorLoad( "CURSOR_LOUPE",   "assets/cursors/cursor_loupe", 10 );
    common.CursorLoad( "CURSOR_GET",     "assets/cursors/cursor_get",   4  );
    common.CursorLoad( "CURSOR_HAND",    "assets/cursors/cursor_hand",  4  );
    common.CursorLoad( "CURSOR_USE",     "assets/cursors/cursor_use",   4  );
    common.CursorLoad( "CURSOR_DOWN",    "assets/cursors/cursor_down",  14 );
    common.CursorLoad( "CURSOR_UP",      "assets/cursors/cursor_up",    14 );
    common.CursorLoad( "CURSOR_LEFT",    "assets/cursors/cursor_left",  14 );
    common.CursorLoad( "CURSOR_RIGHT",   "assets/cursors/cursor_right", 14 );
    common.CursorLoad( "CURSOR_FINGER",  "assets/cursors/cursor_finger",4 );
    common.CursorLoad( "CURSOR_DIALOG_CHARACTER",  "assets/cursors/cursor_dialog_character",5 );

  end;

  function public.IsSubscribersIncluded ()

    return public.subscribers_included;

  end;
--*********************************************************************************************************************
--***function *** HINT *** () end************************************************************************************
--*********************************************************************************************************************
  function private.CreateSinglePartySys( i, target_name, hint_pos_beg, hint_pos_end, tme, obj_name )

    local hint_name  = "pfx_hint_"..target_name.."_"..i;
    local obj_hint_name  = obj_name or "obj_hint_"..target_name;
    local index_anim_array = {};
    index_anim_array["x"] = {};
    index_anim_array["y"] = {};
    
    if ObjGet( hint_name ) then

      public.DeleteHintFx();
      
    end;

    ObjCreate( hint_name, "partsys" );

    ObjSet( hint_name,
    {
      res = public.hint.res;
      pos_x = hint_pos_beg[i][ "x" ], pos_y = hint_pos_beg[i][ "y" ], alp = 1
    } );
    if not( public.hint.target[1] == 0 ) then

      public.hint.target[1] = obj_hint_name;

    else

      public.hint.target[2] = obj_hint_name;

    end;

    ObjAttach( hint_name, obj_hint_name );
    ObjAnimate( hint_name, "pos_xy",0,0, "*ObjDelete('"..hint_name.."');", { 0,0,hint_pos_beg[i][ "x" ],hint_pos_beg[i][ "y" ],
                          tme,2,hint_pos_end[i][ "x" ],hint_pos_end[i][ "y" ] } );

  end;
  --*********************************************************************************************************************
  function public.CreateCenterPartSys( target_name, attach_name )

    local hint_name  = "pfx_hint_"..target_name.."_center";

    ObjCreate( hint_name, "partsys" );

    ObjSet( hint_name,
    {
      res = public.hint.res_center,
      pos_x = 0, pos_y = 0,
      scale_x = 1.6, scale_y = 1.6
    } );

    ObjAttach( hint_name, attach_name );

  end;
  --*********************************************************************************************************************
  function private.GetCircleCoord( number, radius, ang_shift )

    local ang = 360 / number;
    local R  = radius or 70;
    local ang_num = ang_shift or 0;
    local pos = {};

    for i=1,number,1 do

      local cur_ang = math.rad(ang * ( i + ang_num ));   

      pos[ i ] = {}
      pos[ i ][ "x" ] = math.cos( cur_ang ) * R ;--math.ceil(
      pos[ i ][ "y" ] = math.sin( cur_ang ) * R ;

    end;

    return pos;

  end;
  --*********************************************************************************************************************
  function private.CreateHintObj( target_name, room )        
    
    local obj_hint_name  = "obj_hint_"..target_name;
    local pos = GetObjPosByObj(target_name, room);
    local hint_pos_beg = {};
    local hint_pos_end = {}; 
    local partsys_R = public.hint.big_R;
    local tme = public.hint.time_fly;
    local timer_name = "tmr_"..target_name;

    if common.GetObjectPrefix( room ) == "zz" and target_name ~= "obj_int_frame_subroom_button" then

      partsys_R = public.hint.big_R_zz;
      tme = public.hint.time_fly_zz;

    end;

    hint_pos_beg = private.GetCircleCoord( public.hint.partsys_count, partsys_R, -1 );

    hint_pos_end = private.GetCircleCoord( public.hint.partsys_count, public.hint.small_R );

    public.show_hint[ room ] = target_name;

    if ( ObjGet(obj_hint_name) ) then
      public.DeleteHintFx();
    end;
    
    --if not ( ObjGet(obj_hint_name) ) then    
    ObjCreate( obj_hint_name, "obj" );      
  

    ObjSet( obj_hint_name,
    {
      pos_x = pos[1], pos_y = pos[2], pos_z = 1000,
      active = 1, visible = 1, input = 0, alp = 0
    } );
    
    

    for i=1,public.hint.partsys_count,1 do

      private.CreateSinglePartySys( i, target_name, hint_pos_beg, hint_pos_end, tme );

    end;
      
    --end;

    if target_name == "obj_int_frame_subroom_button" then

     ObjSet( obj_hint_name,
     {
       pos_x = 0, pos_y = 0
     } );

     ObjAttach( obj_hint_name, target_name );

    elseif ( target_name == "right" or target_name == "left" ) then

     ObjAttach( obj_hint_name, "spr_focus_arrow_"..target_name );

    else

     ObjAttach( obj_hint_name, room );

    end;

    local alp_tme = tme + public.hint.time_circle*public.hint.circle_cnt;

    ObjAnimate(obj_hint_name, "alp",0,0, "common_impl.HintShowAnimEnd( '"..target_name.."','"..room.."');", 
      {
      0.0,0,0, 
      public.hint.tme_show,0,1,
      alp_tme,0,1,
      (alp_tme + public.hint.tme_hide),0,0
      });

    ObjCreate( timer_name, "timer" );
    ObjAttach( timer_name, obj_hint_name );

    ObjSet( timer_name, 
    {
      endtrig = "common_impl.CreateCenterPartSys( '"..target_name.."','"..obj_hint_name.."');",
      time    = public.hint.time_fly,
      playing = 1
    } );  


    ObjAnimate( obj_hint_name, "ang",0,0, "", {0,0,0,    
                          tme,0,-6.28*public.hint.circle_cnt});

  end;
  --*********************************************************************************************************************
  function public.DeleteHintFx()

    for i = 1,#public.hint.target do

      ObjDelete( public.hint.target[i] );

      if ( common.GetObjectPrefix( GetCurrentRoom() ) == "ho" ) and ( GetCurrentRoom() ~= currentroom ) then

        local target = string.sub( public.hint.target[i], 24,string.len( public.hint.target[i] ));
        interface.effects.ho_hint[target] = nil;

      else

        local target = string.sub( public.hint.target[i], 10,string.len( public.hint.target[i] ));
        public.show_hint[ target ] = nil;

        if string.find( public.hint.target[i], "inv_" ) then
          ObjDelete( "tmr_inv_"..target );
        else
          ObjDelete( "tmr_"..target );
        end;

      end;

    end;  

    public.hint.target = {}

  end;
  --*********************************************************************************************************************
  function private.CreateInvHintPartSys( target_name, room )    

    local obj_hint_name  = "obj_hint_"..target_name;
    local hint_name  = "pfx_hint_"..target_name;
    local timer_inv_name = "tmr_inv_"..target_name;

    interface.InventoryOpen();

    if ObjGet( hint_name ) then

      public.DeleteHintFx()

    end;
    
    if not( public.hint.target[1] == 0 ) then

      public.hint.target[1] = obj_hint_name;

    else

      public.hint.target[2] = obj_hint_name;

    end;

    interface.InventoryShowObject( target_name );

    ObjCreate( obj_hint_name, "obj" );

    ObjSet( obj_hint_name,
    {
      pos_x = 0, pos_y = 0
    } );

    ObjAttach( obj_hint_name, target_name );

    ObjCreate( hint_name, "partsys" );

    ObjSet( hint_name,
    {
      res = public.hint.res_inv,
      pos_x = 0, pos_y = 0,
      scale_x = 1.6, scale_y = 1.6
    } );

    ObjAttach( hint_name, obj_hint_name );

    ObjCreate( timer_inv_name, "timer" );
    ObjAttach( timer_inv_name, InterfaceWidget_Top_Name );


    ObjAnimate( obj_hint_name, "alp",0 ,0 , "", { 0,0,1,  2.5,0,1,  2.8,0,0 }  );

    ObjSet( timer_inv_name, 
    {
      endtrig = "common_impl.HintHideInventoryEnd( '"..target_name.."');common_impl.HintShowAnimEnd( '"..target_name.."','"..room.."');",
      time    = 2.8,
      playing = 1
    } ); 


    if public.hint.play_sfx==true and int_deploy_inv.show == 0 then
      PlaySfx( "assets/audio/aud_teleport", 0, 0 );
    end; 

  end;
  --*********************************************************************************************************************
  function private.HintShowAnim( target_name, deploy, prg_name )
    
    --if ( public.show_hint[ target_name ] == target_name ) then
    if ( public.show_hint[ target_name ] ) then
      --return;
      public.show_hint[ target_name ] = nil;
    end;


    local room = common.GetCurrentRoom();

    if deploy then

      room = target_name;

    elseif ObjGet(room).input == false and common.GetCurrentSubRoom() and ObjGet(common.GetCurrentSubRoom()).input == true then

      room = common.GetCurrentSubRoom();

    elseif prg_name then

      room = public.hint[ prg_name ].room;

    end;
    --DbgTrace( room );
    --common.LogTrace( common.logtrace_message, "[ H ] Hint object < "..target_name.." >." );
--DbgTrace( "target_name = "..tostring( target_name ) );
    if ( not public.show_hint[ target_name ] ) then            

      if ObjGet( target_name ).name then

        public.show_hint[ target_name ] = 1;

        if string.match(target_name, "^in._") then

          private.CreateInvHintPartSys( target_name, room );

        else

          private.CreateHintObj( target_name, room );

        end;

      end;

    else


      --common.LogTrace( ld.logtrace_message, "[ H ] No object < "..target_name.." >!" );    

    end;

  end;
  --*********************************************************************************************************************
  function public.HintShowAnimEnd( target_name, room )

    local obj_hint_name  = "obj_hint_"..target_name;

    ObjDelete( obj_hint_name );

    public.show_hint[ target_name ] = nil;
    public.show_hint[ room ] = nil;

  end;
  --*********************************************************************************************************************
  function public.HintHideInventoryEnd( target_name )

    local inv_timer_name = "tmr_inv_"..target_name;

    ObjDelete( inv_timer_name );

    if string.find(target_name, "inv") and public.save_autohide == 1 and ng_global.progress[ ng_global.currentprogress ].common.buttonlock ~= 1 then

      --interface.InventoryAutoHideSet( 1 );
      public.save_autohide = 0;
      
    end;

    public.hint.play_sfx=true;

  end;
  --*********************************************************************************************************************
  function private.CheckHintType(prg_name, deploy)

    if public.hint[ prg_name ].type == "use" then

      -- показать инвентарь
      if interface.InventoryAutoHideGet() == 1 and not( string.find(prg_name, "isis") ) then

        public.save_autohide = 1;
        interface.InventoryAutoHideSet( 0 );

      else
      
        public.save_autohide = 0;

      end;

      public.hint.play_sfx = false;  
      private.HintShowAnim(public.hint[ prg_name ].use_obj );
      private.HintShowAnim(public.hint[ prg_name ].use_place, deploy);

    elseif public.hint[ prg_name ].type == "get" then
      -- показать на подбираемый предмет

      private.HintShowAnim(public.hint[ prg_name ].get_obj, deploy);

    elseif public.hint[ prg_name ].type == "get_scr" then

      ng_global.secret.achiev_temp[ "no_hint" ] = false;
      int_taskpanel_scr.UpdateAchievpanel();
      private.HintShowAnim( public.hint[ prg_name ].get_obj, deploy);
      
    elseif public.hint[ prg_name ].type == "click" then

      --показать на место клика
      --DbgTrace( prg_name );
      private.HintShowAnim(public.hint[ prg_name ].clk_obj, deploy, prg_name);

    elseif public.hint[ prg_name ].type == "win" then

    -- показать на место клика

      private.HintShowAnim(public.hint[ prg_name ].use_place, deploy);

    end; 

    int_button_hint_impl.StartAnimReloadBegin();
    interface.ButtonHintReload( 1 );



  end;
  --*********************************************************************************************************************
  function private.CheckRoomState(prg_name, currentroom)

    if ObjGet(currentroom).input == false and public.hint[ prg_name ].zz == common.GetCurrentSubRoom() then
      --DbgTrace("1show_action_subroom");
      private.CheckHintType(prg_name);
      PlaySfx( "assets/audio/aud_hint_sfx", 0, 0 );

    elseif ObjGet(currentroom).input == false and public.hint[ prg_name ].zz ~= common.GetCurrentSubRoom() then

      --DbgTrace("1show_close_subroom");                    
      private.HintShowAnim("obj_int_frame_subroom_button");                 
      PlaySfx( "assets/audio/aud_teleport", 0, 0 );             

    else

      --DbgTrace("1show_gate_subroom");
      local new_place = private.CheckPositionZzHint( public.hint[ prg_name ].zz_gate )

      private.HintShowAnim( new_place );
      PlaySfx( "assets/audio/aud_teleport", 0, 0 );

    end;

  end;
  --*********************************************************************************************************************
  function private.CheckPositionZzHint( place )

    local position = place;

    return position;

  end;
  --*********************************************************************************************************************
  function common.HintAdditionalFunc( room_current )

    if public.show_hint[ room_current ] then

      local hint_name  = "pfx_hint_"..public.show_hint[ room_current ];

      ObjDelete( hint_name );

      public.show_hint[ public.show_hint[ room_current ] ] = nil;
      public.show_hint[ room_current ] = nil;

    end;

    if interface.effects.ho_hint[room_current] then

      for key, value in pairs( interface.effects.ho_hint ) do

      local obj_hint_name  = "obj_int_effects_ho_hint_"..key;

      ObjDelete( obj_hint_name );
      interface.effects.ho_hint[ key ] = nil;
      interface.effects.ho_hint[room_current] = nil;

      end;

    end;

  end;
--*********************************************************************************************************************
--***function *** DIALOG *** () end************************************************************************************
--*********************************************************************************************************************
  function public.DialogButtonMouseDown( dialog_name, dialog_button, param )

  cmn.PlayAudio("sfx", "audio/aud_click_menu");
    --DbgTrace( "[ EXAMPLE ] Проигран звук клика для диалога < "..dialog_name.." > по кнопке < "..dialog_button.." >." );

  end;
  --------------------------------------------------------------------
  function public.DialogButtonMouseEnter( but_name, but_pos )
    
    SetCursor( CURSOR_HAND );

    local focus_name = "";

    if ( GetPerformanceMode() == 0 ) then

      if but_pos then

        focus_name = "pfx_dialog_"..but_name.."_button_"..but_pos.."_focus";

      else

        focus_name = "pfx_"..but_name.."_focus";

      end;

    else

      if but_pos then

        focus_name = "spr_dialog_"..but_name.."_button_"..but_pos.."_focus";

      else

        focus_name = "spr_"..but_name.."_focus";

      end;

    end;

    if ( ObjGet( focus_name ) ) then

      ObjSet( focus_name, { visible = true, active = true} ); 

      local focus_alp = ObjGet( focus_name ).alp;

      ObjAnimate( focus_name, "alp", 0, 0, "", 
      { 

        0, 0, focus_alp, 
        ( public.animtime * ( 1 - focus_alp ) ), 0, 1 
      
      });

    end;

  end;
  --------------------------------------------------------------------
  function public.DialogButtonMouseLeave( but_name, but_pos )

    SetCursor( CURSOR_DEFAULT );

    local focus_name = "";

    if ( GetPerformanceMode() == 0 ) then

      if but_pos then

        focus_name = "pfx_dialog_"..but_name.."_button_"..but_pos.."_focus";

      else

        focus_name = "pfx_"..but_name.."_focus";

      end;

    else

      if but_pos then

        focus_name = "spr_dialog_"..but_name.."_button_"..but_pos.."_focus";

      else

        focus_name = "spr_"..but_name.."_focus";

      end;

    end;

    if ( ObjGet( focus_name ) ) then

      ObjSet( focus_name, { visible = true, active = true} ); 

      local focus_alp = ObjGet( focus_name ).alp;

      ObjAnimate( focus_name, "alp", 0, 0, function() ObjSet( focus_name, { visible = false, active = false } ) end, 
      {

       0, 0, focus_alp, 
       ( public.animtime * focus_alp ), 0, 0 

      } );

    end;

  end;
  --------------------------------------------------------------------
  function public.DialogCheckMouseEnter( sender_name )

    local txt_name = "txt_dialog_"..sender_name ;
    
    if ( string.find( sender_name, "gamemode") ) then

      ObjSet( txt_name, { fontcolor_r = 1, fontcolor_g = 1, fontcolor_b = 1 } );

    else

      ObjSet( txt_name, { fontcolor_r = 0.906, fontcolor_g = 0.875, fontcolor_b = 0.808 } );

    end;
    SetCursor( CURSOR_HAND );   
   
    local but_name = "spr_dialog_"..sender_name.."_check_focus";
    if ( GetPerformanceMode() == 0 ) then
      but_name = "pfx_dialog_"..sender_name.."_check_focus";
    end;

    local but_alp = ObjGet( but_name ).alp;
    ObjAnimate( but_name, "alp", 0, 0, "", { 0, 0, but_alp, ( public.animtime * ( 1 - but_alp ) ), 0, 1 } );

  end;
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  --------------------------------------------------------------------
  function public.DialogCheckMouseLeave( sender_name )

    local txt_name = "txt_dialog_"..sender_name ;
    if ( string.find( sender_name, "gamemode") ) then

      ObjSet( txt_name, { fontcolor_r = 1, fontcolor_g = 0.815, fontcolor_b = 0.596 } );

    else

    ObjSet( txt_name, { fontcolor_r = 0.56, fontcolor_g = 0.776, fontcolor_b = 0.913 } );

    end;

    SetCursor( CURSOR_DEFAULT );
    local but_name = "spr_dialog_"..sender_name.."_check_focus";
    if ( GetPerformanceMode() == 0 ) then
      but_name = "pfx_dialog_"..sender_name.."_check_focus";
    end;
    local but_alp = ObjGet( but_name ).alp;
    ObjAnimate( "spr_dialog_"..sender_name.."_check_focus", "alp", 0, 0, "", { 0, 0, ObjGet( "spr_dialog_"..sender_name.."_check_focus" ).alp, ( public.animtime * but_alp ), 0, 0 } );
    ObjAnimate( but_name, "alp", 0, 0, "", { 0, 0, but_alp, ( public.animtime * but_alp ), 0, 0 } );

  end;
  --------------------------------------------------------------------
  function public.DialogOptionsScrollMouseEnter( scroll_name )
    
    SetCursor( CURSOR_HAND );    
    local but_name = "spr_dialog_options_"..scroll_name.."_scroll_slider_focus";
    local but_alp = ObjGet( but_name ).alp;
    ObjAnimate( but_name, "alp", 0, 0, "", { 0, 0, but_alp, ( public.animtime * ( 1 - but_alp ) ), 0, 1 } );
    
    local txt_name = "txt_dialog_options_"..scroll_name.."_percent";
    local txt_name2 = "txt_dialog_options_"..scroll_name.."_header";
    local txt_name3 = "txt_dialog_options_"..scroll_name;
    ObjSet( txt_name,  { fontcolor_r = 0.906, fontcolor_g = 0.875, fontcolor_b = 0.808 } );
    ObjSet( txt_name2, { fontcolor_r = 0.906, fontcolor_g = 0.875, fontcolor_b = 0.808 } );
    ObjSet( txt_name3, { fontcolor_r = 0.906, fontcolor_g = 0.875, fontcolor_b = 0.808 } );

  end;
  --------------------------------------------------------------------

  function public.DialogOptionsScrollMouseLeave( scroll_name )

    SetCursor( CURSOR_DEFAULT );
    local but_name = "spr_dialog_options_"..scroll_name.."_scroll_slider_focus";
    local but_alp = ObjGet( but_name ).alp;
    ObjAnimate( but_name, "alp", 0, 0, "", { 0, 0, but_alp, ( public.animtime * but_alp ), 0, 0 } );
    

    local txt_name = "txt_dialog_options_"..scroll_name.."_percent";
    local txt_name2 = "txt_dialog_options_"..scroll_name.."_header";
    local txt_name3 = "txt_dialog_options_"..scroll_name;
    ObjSet( txt_name,  { fontcolor_r = 0.56, fontcolor_g = 0.776, fontcolor_b = 0.913 } );
    ObjSet( txt_name2, { fontcolor_r = 0.56, fontcolor_g = 0.776, fontcolor_b = 0.913 } );
    ObjSet( txt_name3, { fontcolor_r = 0.56, fontcolor_g = 0.776, fontcolor_b = 0.913 } );

  end;
  
  --------------------------------------------------------------------
  function public.DialogScrollMouseEnter( sender_name, scroll_name )
    
    SetCursor( CURSOR_HAND );    
    local but_name = "spr_dialog_"..sender_name.."_"..scroll_name.."_scroll_slider_focus";
    local but_alp = ObjGet( but_name ).alp;
    ObjAnimate( but_name, "alp", 0, 0, "", { 0, 0, but_alp, ( public.animtime * ( 1 - but_alp ) ), 0, 1 } );
    
    local txt_name = "txt_dialog_"..sender_name.."_"..scroll_name.."_percent";
    local txt_name2 = "txt_dialog_"..sender_name.."_"..scroll_name.."_header";
    local txt_name3 = "txt_dialog_"..sender_name.."_"..scroll_name;
    ObjSet( txt_name, { fontcolor_r = 1, fontcolor_g = 1, fontcolor_b = 1 } );
    ObjSet( txt_name2, { fontcolor_r = 1, fontcolor_g = 1, fontcolor_b = 1 } );
    ObjSet( txt_name3, { fontcolor_r = 1, fontcolor_g = 1, fontcolor_b = 1 } );

  end;
  --------------------------------------------------------------------

  function public.DialogScrollMouseLeave( sender_name, scroll_name )

    SetCursor( CURSOR_DEFAULT );
    local but_name = "spr_dialog_"..sender_name.."_"..scroll_name.."_scroll_slider_focus";
    local but_alp = ObjGet( but_name ).alp;
    ObjAnimate( but_name, "alp", 0, 0, "", { 0, 0, but_alp, ( public.animtime * but_alp ), 0, 0 } );
    
    local txt_name = "txt_dialog_"..sender_name.."_"..scroll_name.."_percent";
    local txt_name2 = "txt_dialog_"..sender_name.."_"..scroll_name.."_header";
    local txt_name3 = "txt_dialog_"..sender_name.."_"..scroll_name;
    ObjSet( txt_name,  { fontcolor_r = 0.6902, fontcolor_g = 0.6156, fontcolor_b = 0.7529 } );
    ObjSet( txt_name2, { fontcolor_r = 0.6902, fontcolor_g = 0.6156, fontcolor_b = 0.7529 } );
    ObjSet( txt_name3, { fontcolor_r = 0.6902, fontcolor_g = 0.6156, fontcolor_b = 0.7529 } );

  end;
  
  ----------------------------------------------------------------------------
  function public.DialogProfileMouseEnter(number)

    SetCursor( CURSOR_HAND );
    local name = "spr_dialog_profile_names_"..number.."_focus";

    --local alp = ObjGet( name ).alp;

    local trg_after = function ()


    end;


    --ObjSet( name, { scale_x = 0, pos_x = -195, alp = 1 } );


--    ObjAnimate( name, "scale_x", 0, 0, "", 
--    { 
--      0.0, 0, 0,
--      0.5, 0, 1 
--    } );
--
--    ObjAnimate( name, "pos_x", 0, 0, trg_after, 
--    { 
--      0.0, 0, -195, 
--      0.5, 0, 0 
--    } );
     ObjSet(name, { alp = 1 });
--    ObjAnimate( name, "alp", 0, 0, trg_after, 
--    { 
--      0.0, 0, 0, 
--      0.3, 0, 1 
--    } );
--


  end;
  ---------------------------------------------------------------------------------
  ----------------------------------------------------------------------------
  function public.DialogProfileMouseLeave(number)

    SetCursor( CURSOR_DEFAULT );
    local name = "spr_dialog_profile_names_"..number.."_focus";
    
     ObjSet(name, { alp = 0});
    
  --
  --  ObjAnimate( name, "alp", 0, 0, "", 
  --  { 
  --    1.0, 0, 0,
  --    0.3, 0, 0 
  --  } );

  end;
---------------------------------------------------------------------------------
--*********************************************************************************************************************
--***function *** PROFILE *** () end***********************************************************************************
--*********************************************************************************************************************
  function public.ProgressReset( prg, save )

    if ( prg == "std" ) then

      ng_global.progress[ prg ].common.chapter = "level1";

    elseif( prg == "ext" ) then

      ng_global.progress[ prg ].common.chapter = "levelext";
      
    elseif( prg == "scr" ) then

      ng_global.progress[ prg ].common.chapter = "levelscr";      
      
    elseif( prg == "rpl" ) then

      ng_global.progress[ prg ].common.chapter = "levelrpl";      

    end;

  end;
  --*********************************************************************************************************************
  function public.ProfileInit()
    
    private.AchievementsInit();
    private.SecretroomInit();
    
  end;
--*********************************************************************************************************************
--***function *** ROOM - SUBROOM *** () end****************************************************************************
--*********************************************************************************************************************
  function public.GotoRoom( room_object, need_fade, dontsave )

     public.DeleteHintFx()

     if ( room_object ~= "rm_menu" and
          room_object ~= "rm_intro" and
          room_object ~= "rm_credits" and
          room_object ~= "rm_achievements" and
          room_object ~= "rm_extra" and
          room_object ~= "rm_moregames" and
          room_object ~= "rm_unlock" and
          room_object ~= "rm_sequel" and
          room_object ~= "rm_collectibles" and
          not string.find( room_object, "_scr" ) and
          room_object ~= "rm_diary" ) then

        local prefix = common.GetObjectPrefix( room_object );

        if ( prefix ~= "mg" and prefix ~= "ho" ) then

            int.VisitMapRoom( room_object );

        end;

     end;

  end; 
  --------------------------------------------------------------------
  function public.GotoSubRoom( zz_object, pos_beg, pos_end )

      local room_current = GetCurrentRoom();

      public.DeleteHintFx()
      ObjDelete( "obj_hint_obj_int_frame_subroom_button" );

      if ( "zz" == common.GetObjectPrefix( room_current ) ) then
        
        common.previouszz = room_current;

      end;

      common.currentzz = zz_object;

      interface.CheaterUpdateSubroom( zz_object );

      local zz_params = ObjGet( zz_object );

      pos_beg = pos_beg or GetZoomCursorPos();

      pos_end = pos_end or { zz_params.pos_x, zz_params.pos_y };

      subroom.Open( zz_object, { x = pos_beg[ 1 ], y = pos_beg[ 2 ] }, { x = pos_end[ 1 ], y = pos_end[ 2 ] } );

  end;
--*********************************************************************************************************************
--***function *** SETTINGS *** () end**********************************************************************************
--*********************************************************************************************************************
  function public.UpdateGameMode( gamemode )

--    local current_room = GetCurrentRoom();
--    if ( current_room == "" or current_room == nil ) then
--    current_room = ng_global.progress[ ng_global.currentprogress ].common.currentroom or "rm_bypolicestation";
--    end;
--
--    if ( common.GetObjectPrefix( current_room ) == "rm" ) then
--    cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( current_room ) );
--    end;
    if game then

      if game.room_names then
      
        for i = 1, #game.room_names do
            cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( game.room_names[i] ) );

        end;

        local prg = ng_global.currentprogress;
        cmn.CallEventHandler( "update_game_mode_"..ng_global.progress[ prg ].common.chapter.."_inv_deploy" );

      end;

    end;
    ------------------------------------------------------------------------------------
    local visible = true;
    if ( ( ng_global.gamemode == 3 ) and ( not ng_global.gamemode_custom[ "plus_inv" ] ) ) then
    visible = false;
    end;  
    local parent = ng_global.progress[ ng_global.currentprogress ].common.chapter.."_inv_deploy";
    if ( not ObjGet( parent ) ) then
    return;
    end;
    local relations = ObjGetRelations( parent );
    local table_multiset = {};

    local now_deploy_obj = int_deploy_inv.GetCurrentName()

    if now_deploy_obj then

      table.insert( relations.childs, now_deploy_obj );

    end;

    for i = 1, #relations.childs do

    local obj = common.GetObjectName( relations.childs[ i ] ).."_plus_focus";   

    table.insert( table_multiset, { obj, { visible = visible } } );
    table.insert( table_multiset, { obj.."_light", { visible = visible } } );

    end;
    ObjMultiSet( table_multiset ); 

  end;
  --------------------------------------------------------------------
  function public.SaveInterfaceTimers()

  end;
--*********************************************************************************************************************
--***function *** MINIGAME *** () end**********************************************************************************
--*********************************************************************************************************************
  function public.MiniGameShow( minigame_name, skip_multiplier )

    if ( skip_multiplier ) then

      if ( common.GetGamemode() == 0 ) then

        skip_multiplier = 3.333333;

      elseif ( common.GetGamemode() > 0 ) then

        skip_multiplier = 3.5;

      end;

    end;

    minigame_name = minigame_name or common.GetObjectName( GetCurrentRoom() );

    local result = false;

    local event_name = "win_"..minigame_name;
    if port.isPortable() == 1 then
      port.LogEvent(event_name, "open");
    end;
    
    if ( not cmn.IsEventStart( event_name ) ) then

      cmn.SetEventStart( event_name );
      private.SetSkipTimer( minigame_name, 1 );

      result = true;

    end;

    PlaySfx( "assets/audio/aud_mgenter_sfx", 0, 0 );

    interface.ButtonHintHide();

    interface.ButtonInfoShow();
    interface.ButtonResetShow();
    interface.ButtonSkipShow();

    interface.ButtonSkipReload( private.GetSkipTimer( minigame_name ), skip_multiplier or 1 );

    return result;

  end;
  -------------------------------------------------------------------------------------
  function public.MiniGameHide( minigame_name )

    minigame_name = minigame_name or common.GetObjectName( GetCurrentRoom() );

    local result = false;

    local event_name = "win_"..minigame_name;

    if  (     cmn.IsEventStart( event_name ) )
    and ( not cmn.IsEventDone( event_name )  )
    then

      private.SetSkipTimer( minigame_name, interface.ButtonSkipGetTime() );
      --DbgTrace( "save skip for &lt; "..prg_name.." &gt; =  "..current_progress[ prg_name ].skiptimer );

      interface.ButtonInfoHide();
      interface.ButtonResetHide();
      interface.ButtonSkipHide();

      interface.ButtonHintShow();

      result = true;

    end;

    return result;

  end;
  --------------------------------------------------------------------------------------
  function private.GetSkipTimer( minigame_name )

    local prg = prg.current;
    local event_name = "win_"..minigame_name;
    return ng_global.progress[ prg ][ event_name ].skiptimer;

  end;
  --------------------------------------------------------------------------------------
  function private.SetSkipTimer( minigame_name, time_relative )

    local prg = prg.current;
    local event_name = "win_"..minigame_name;
    ng_global.progress[ prg ][ event_name ].skiptimer = time_relative;

  end;
--*********************************************************************************************************************
--***function *** EFFECT HO *** () end*****************************************************************************
--*********************************************************************************************************************
  function public.PlayEffectHO ( object_name, func_end )
    
    ObjSet( object_name, { input = false } );
    local pos = GetObjPosByObj( object_name, InterfaceWidget_Top_Name );
    local drawoff_x = ObjGet( object_name ).drawoff_x;
    local drawoff_y = ObjGet( object_name ).drawoff_y;
    
    local partsys_name  = "pfx_effect_ho_"..object_name;

    ObjAttach( object_name, InterfaceWidget_Top_Name );
    ObjSet( object_name, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } );
    
    ObjCreate( partsys_name, "partsys" );
    
    ObjSet( partsys_name,
    {
      res = "assets/interface/resources/effects_ho",
      pos_x = drawoff_x, pos_y = drawoff_y,
      input = false, pos_z = 10
    } );
    
    ObjAttach( partsys_name, InterfaceWidget_Top_Name );
    
    ObjSet( partsys_name, { blendmode = 2 } );
    PartSysSetMaskObj( partsys_name, object_name ); 

    local func = function()

      if ( func_end ) then
        func_end();
      end;
      ObjDelete( partsys_name );
      ObjDelete( object_name );

    end; 

    ObjAnimate( object_name, "alp", 0, 0, func,
    { 
        0.0, 0, 1,
        1.0, 0, 0      
    } );
    ObjAnimate( partsys_name, "alp", 0, 0, "",
    { 
        0.0, 0, 1,
        0.7, 0, 1,
        1.0, 0, 0      
    } );
    
  end;
--*********************************************************************************************************************
--***function *** HO *** () end****************************************************************************************
--*********************************************************************************************************************
  function public.ProcessHoStart( ho_name )

    local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found;

    for i = 1, #ho_found, 1 do

      if ( ho_found[ i ][ "task" ] ) then

        ObjDelete( ho_found[ i ][ "object" ] );

      end;

      if ( ho_found[ i ][ "item" ] ) then

        ObjDelete( ho_found[ i ][ "item" ] );

      end;

    end;

  end;
  -----------------------------------------------------------------------------------
  function public.HoItemFind( sender )

    local ho_name          = common.GetObjectName( GetCurrentRoom() );
    local item_name        = sender;
    local item_object_name = "obj_"..common.GetObjectName( item_name );

    if ( ApplyObj( item_name, item_object_name ) ) then

      ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].start = 1;

      local item_found = { item = item_name, object = item_object_name };

      table.insert( ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found, item_found );

      interface.ItemPanelItemRemove( item_name );
      ObjSet( item_object_name, { input = false } );

      _G[ "ho_"..ho_name ].ItemFound( item_name );

    end;

    ObjSet( "itm_"..common.GetObjectName( item_name ), 
    { 
    inputrect_init  = true,
    inputrect_x     = -50,
    inputrect_y     = -50,
    inputrect_w     = 100,
    inputrect_h     = 100,
    });

  end;
  -----------------------------------------------------------------------------------
  function public.HoItemOff( sender )

    local ho_name          = common.GetObjectName( GetCurrentRoom() );
    local item_name        = sender;
    local item_object_name = "itm_"..common.GetObjectName( item_name );

    ObjSet( item_object_name, 
      { 
      inputrect_init  = false
      });

    cmn.PlayAudio( "sfx", "audio/aud_take_inventory" );

  end;
  -----------------------------------------------------------------------------------
  function public.HoTaskFind( sender, task )

    local ho_name          = common.GetObjectName( GetCurrentRoom() );
    local task_name        = task;
    local task_object_name = sender;

    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].start = 1;

    local task_found = { task = task_name, object = task_object_name };

    table.insert( ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found, task_found );

    interface.TaskPanelTaskComplete( ho_name, task_name, task_object_name );

  end;
  --------------------------------------------------------------------
  function public.SetMarkedTask( ho_name, task )

    local prg = prg.current;

    local event_win_ho = "win_"..ho_name;

    ng_global.progress[ prg ][ event_win_ho ].unmark[ task ] = {};
    ng_global.progress[ prg ][ event_win_ho ].unmark[ task ].done = 0;

  end;
  --------------------------------------------------------------------------------------
  function public.UnmarkTask( ho_name, task )

    local prg = prg.current;

    local event_win_ho = "win_"..ho_name;

    ng_global.progress[ prg ][ event_win_ho ].unmark[ task ].done = 1;
    ng_global.progress[ prg ][ event_win_ho ].start = 1;

    interface.TaskPanelTaskUnmark( ho_name, task );

  end;
  --------------------------------------------------------------------------------------
  function public.IsUnmarkedTask( ho_name, task )

    local prg = prg.current;

    local event_win_ho = "win_"..ho_name;

    if ( ng_global.progress[ prg ][ event_win_ho ].unmark[ task ].done == 1 ) then

      return true;

    else

      return false;

    end;

  end;
  --------------------------------------------------------------------------------------
  function public.InitHo( ho_name )

    local prg = prg.current;

    local event_win_ho = "win_"..ho_name;
    if port.isPortable() == 1 then
      port.LogEvent(event_win_ho, "open");
    end;
    ng_global.progress[ prg ][ event_win_ho ].start = 1;
    ng_global.progress[ prg ][ event_win_ho ].unmark = {};
    ng_global.progress[ prg ][ event_win_ho ].found = {};
    ng_global.progress[ prg ][ event_win_ho ].hint_clk = false;

  end;
--*********************************************************************************************************************
--***function *** DEPLOY INV *** () end**********************************************************************************
--*********************************************************************************************************************
  function public.ShowDeployInv( inv_obj )

    if ( int.GetCurrentInv() == "" ) then

      int_dialog_hint.Hide();
      
      public.DeleteHintFx();
      common.CallRoomEventHandlers( inv_obj );
      int.DeployInvShow( inv_obj );

      local name_obj_dep= string.sub( inv_obj, 5, string.len( inv_obj ) );

      if ( ng_global.progress[ ng_global.currentprogress ][ "win_"..name_obj_dep ] ) then

        if ( ng_global.progress[ ng_global.currentprogress ][ "win_"..name_obj_dep ].start == 1 ) and
           ( ng_global.progress[ ng_global.currentprogress ][ "win_"..name_obj_dep ].done == 0 ) then

          cmn.MiniGameShow( name_obj_dep );
          common_impl.PassingMgStart( name_obj_dep );

        end;    
  
      end;

      private.GetInvObjectSfx();

    else

      int.DeployInvHide();

    end;

  end;
--*********************************************************************************************************************
--***function *** SET CURSOR *** () end**********************************************************************************
--*********************************************************************************************************************
  function private.SetCursor( cursor_name )

    if ( not ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "cursor" ] ) ) then
      SetCursor( cursor_name );
    end;

  end;  
--*********************************************************************************************************************
--***function *** PROGRESS *** () end**********************************************************************************
--*********************************************************************************************************************
  function public.SetEventDone( event_name )

    ng_global.progress[ prg.current ][ event_name ].done = 1;

  end;
  --------------------------------------------------------------------------------------
  function public.IsEventDone( event_name )

    return ng_global.progress[ prg.current ][ event_name ].done == 1;

  end;
  --------------------------------------------------------------------------------------
  function public.SetEventStart( event_name )

    ng_global.progress[ prg.current ][ event_name ].start = 1;

  end;
  --------------------------------------------------------------------------------------
  function public.IsEventStart( event_name )

    return ng_global.progress[ prg.current ][ event_name ].start > 0;

  end;
--*********************************************************************************************************************
--***function *** EVENTS *** () end************************************************************************************
--*********************************************************************************************************************
  function public.CheaterKeyPress( keycode )

    keycode = keycode - 111;
    local MAX_LEVEL_STD = 3;
    local current_room = GetCurrentRoom();
    ng_global.task_current = nil;
    if (IsSurveyEdition() == 1 or IsDemoEdition() == 1  ) then

      MAX_LEVEL_STD = 1;

    end;

--    if current_room == "rm_intro" then
--
--      return;
--
--    ----hotkey "U"-----
--    else
    if ( current_room == "rm_menu" ) and  
            ( IsCollectorsEdition() ) and
             ( keycode == -26 ) then

      local prg = "std";

      ng_global.progress[ prg ].common.gamestart = false;
      ng_global.progress[ prg ].common.gamewin = true;

      prg = "ext";
      ng_global.currentprogress = prg;

      ng_global.progress[ prg ] = {};
      ng_global.progress[ prg ].common = {};
      ng_global.progress[ prg ].common.gamestart = false;
      ng_global.progress[ prg ].common.gamewin = false;

      ng_global.progress[ prg ].common.chapter = "levelext";
      ng_global.progress[ prg ].common.currentroom = "rm_nearcar"; -- первая комната доп лвла
      ng_global.progress[ prg ].common.hinttimer = 0;  
      ng_global.progress[ prg ].common.maplock = {};
      ng_global.progress[ prg ].common.map = {};
      ng_global.progress[ prg ].common.diary = {};
      ng_global.progress[ prg ].common.diary.pages = 
      {
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0, 0
      };
      ng_global.progress[ prg ].common.diary.last_page = 0;
      ng_global.progress[ prg ].common.diary.current = 1;
      ng_global.progress[ prg ].common.diary.show = false;
      ng_global.progress[ prg ].common.buttonlock = 0;  

      ng_global.bonusunlock = true;

    ----hotkey "WIN ALL GAME"-----" ] "
    elseif ( current_room == "rm_menu" ) and  
            ( IsCollectorsEdition() ) and
             ( keycode == 110 ) then
  
      ng_global.progress[ "std" ].common.gamestart = false;
      ng_global.progress[ "std" ].common.gamewin = true;    

      ng_global.progress[ "ext" ].common.gamestart = false;
      ng_global.progress[ "ext" ].common.gamewin = true;   

    end;

    if keycode > 0 and keycode <= MAX_LEVEL_STD then

      local prg = "std";
      ng_global.currentprogress = prg;

      ng_global.progress[ prg ] = {};
      ng_global.progress[ prg ].common = {};
      ng_global.progress[ prg ].common.gamestart = true;
      ng_global.progress[ prg ].common.gamewin = false;
      ng_global.progress[ prg ].common.chapter = "level"..keycode;
      ng_global.progress[ prg ].common.currentroom = nil;
      ng_global.progress[ prg ].common.hinttimer = 0;  
      ng_global.progress[ prg ].common.maplock = {};
      ng_global.progress[ prg ].common.map = {};
      ng_global.progress[ prg ].common.diary = {};
      ng_global.progress[ prg ].common.diary.pages = 
      {
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0, 0
      };
      ng_global.progress[ prg ].common.diary.last_page = 0;
      ng_global.progress[ prg ].common.diary.current = 1;
      ng_global.progress[ prg ].common.diary.show = false;
      ng_global.progress[ prg ].common.buttonlock = 0;

      ng_global.bonusunlock = false;
      ng_global.scrwin = false;
      ng_global.open_collect = false;
      ng_global.open_paint = false;

      ng_global.starpart = 0;
      ng_global.morphings = {};
      ng_global.collect = {};

      private.AchievementsInit();

    elseif keycode == 4 and ( IsCollectorsEdition() ) then

      local prg = "std";

      ng_global.progress[ prg ] = {};
      ng_global.progress[ prg ].common = {};
      ng_global.progress[ prg ].common.gamestart = false;
      ng_global.progress[ prg ].common.gamewin = true;
      ng_global.progress[ prg ].common.chapter = "level1";

      prg = "ext";
      ng_global.currentprogress = prg;
      ng_global.morphings = {};
      ng_global.collect = {};

      ng_global.progress[ prg ] = {};
      ng_global.progress[ prg ].common = {};
      ng_global.progress[ prg ].common.gamestart = true;
      ng_global.progress[ prg ].common.gamewin = false;
      ng_global.progress[ prg ].common.chapter = "levelext";
      ng_global.progress[ prg ].common.currentroom = "rm_nearcar";-- первая комната доп лвла
      ng_global.progress[ prg ].common.hinttimer = 0;  
      ng_global.progress[ prg ].common.maplock = {};
      ng_global.progress[ prg ].common.map = {};
      ng_global.progress[ prg ].common.diary = {};
      ng_global.progress[ prg ].common.diary.pages = 
      {
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0,
        0, 0, 0, 0, 0
      };
      ng_global.progress[ prg ].common.diary.last_page = 0;
      ng_global.progress[ prg ].common.diary.current = 1;
      ng_global.progress[ prg ].common.diary.show = false;
      ng_global.progress[ prg ].common.buttonlock = 0;
      ng_global.progress[ prg ].common.show_evidence = 0;

      ng_global.bonusunlock = true;

    elseif keycode == 5 and ( IsCollectorsEdition() ) then

      local prg = "ext";
      ng_global.progress[ prg ].common.gamewin = true;  
   
      prg = "scr";
      ng_global.currentprogress = prg;
      
      --public.ResetSecretroomAll();

      ng_global.progress[ prg ] = {};
      ng_global.progress[ prg ].common = {};
      ng_global.progress[ prg ].common.gamestart = false;
      ng_global.progress[ prg ].common.gamewin = false;
      ng_global.progress[ prg ].common.chapter = "";
      ng_global.progress[ prg ].common.currentroom = "rm_waitinghall_scr";
      ng_global.progress[ prg ].common.hinttimer = 0;
      ng_global.progress[ prg ].common.btntimer = 0;  
      ng_global.progress[ prg ].common.map = {};
      ng_global.progress[ prg ].common.buttonlock = 0;
      ng_global.scrunlock = true;
      --ng_var.resetprogress = "secretroom";                  

      --ld.scrRoomPlay() ;
      
    end;

  end;
  --------------------------------------------------------------------------------------
  function public.Application_Closing()

    if ( IsSurveyEdition() and private.is_openbrowser_enabled ) then

      local url = GetUrl();
      OpenBrowser( url );

    end;

  end; 
  --------------------------------------------------------------------------------------
  function public.PanelNotification_Click( notification_type )

    DbgTrace( "Notification Panel Clicked. Notification type: "..notification_type );

  end;
  --------------------------------------------------------------------------------------
  function public.ButtonGuide_Click()

  end;  
  --------------------------------------------------------------------------------------
  function public.ButtonHint_Click( hint_state )

    local type = ng_global.currentprogress;

    if ( ( ng_global.gamemode < 2 ) or ( ng_global.gamemode == 3 and ng_global.gamemode_custom[ "hint" ] ) ) then

      if ( hint_state ) then

        local is_ho_hint = false;

        local currentroom = GetCurrentRoom();
        
        if ( ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( currentroom ) ] ) then
          ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( currentroom ) ].hint_clk = true;
        end; 
        
        if  ( common.GetObjectPrefix( currentroom ) == "ho") and 
            ( ng_global.progress[ type ][ "win_"..common.GetObjectName( currentroom ) ].use_object == nil )  then

          if ( GetCurrentRoom() == currentroom ) then

            interface.TaskPanelHoHintShow();
            interface.ItemPanelHoHintShow();          

          end;

          int_button_hint_impl.StartAnimReloadBegin();
          interface.ButtonHintReload( 1 );

          PlaySfx( "assets/audio/aud_teleport", 0, 0 );

        else

            for i = 1, #game.progress_names, 1 do

              local prg_name = game.progress_names[ i ];

              if ( not cmn.IsEventDone( prg_name ) ) and ( public.hint[ prg_name ] ) then

                --реализация хинта для локации, отличная от стандартной
                common.LogTrace( common.LogTrace_message, "[ H ] Hint show for < "..prg_name.." >." );

                if common.GetCurrentRoom() == public.hint[ prg_name ].room or 
                   common.GetCurrentRoom() == public.hint[ prg_name ].zz then

                    if public.hint[ prg_name ].zz then

                      private.CheckRoomState( prg_name, currentroom );

                    elseif ( common_impl.hint.position_zz[ public.hint[ prg_name ].use_place ] ) then

                      if ( common.IsInSubRoom() ) then

                        private.CheckRoomState( prg_name, currentroom );

                        return;

                      end;

                      local new_place = private.CheckPositionZzHint( public.hint[ prg_name ].use_place )

                      if ( new_place == public.hint[ prg_name ].use_place ) then

                        private.CheckHintType( prg_name );

                      else 

                        private.HintShowAnim( new_place );

                      end;

                      PlaySfx( "assets/audio/aud_teleport", 0, 0 );

                    else
                       
                      if currentroom == public.hint[ prg_name ].room and ObjGet( currentroom ).input == true then

                        --DbgTrace("show_action_rm");
                        private.CheckHintType(prg_name); 
                        PlaySfx( "assets/audio/aud_teleport", 0, 0 );

                      else

                        --DbgTrace("show_close_subroom");                    
                        private.HintShowAnim("obj_int_frame_subroom_button");

                      end;
                
                    end;

                    int.DeployInvHide();

                   ---------------для активных инв предметов
                elseif public.hint[ prg_name ].room == "int_deploy_inv" then                

                    if public.hint[ prg_name ].zz == int_deploy_inv.GetCurrentName() then

                        if not int_deploy_inv.IsOnScreen() then

                           int_inventory_impl.ShowAnim("show")
                           int.InventoryItemAdd( public.hint[ prg_name ].zz_gate,"" );
                           private.HintShowAnim( public.hint[ prg_name ].zz_gate );  
                           PlaySfx( "assets/audio/aud_teleport", 0, 0 );
       
                        else 

                           private.CheckHintType(prg_name, true); 
                           PlaySfx( "assets/audio/aud_hint_sfx", 0, 0 );

                        end;

                    else 

                      int.DeployInvHide();
                      int_inventory_impl.ShowAnim("show")
                      int.InventoryItemAdd( public.hint[ prg_name ].zz_gate,"" );
                      private.HintShowAnim( public.hint[ prg_name ].zz_gate ); 

                      PlaySfx( "assets/audio/aud_teleport", 0, 0 );

                    end;

                else

                    if ( not public.show_hint.dialog ) then 

                      public.show_hint.dialog = prg_name;
                      --показать диалог со ссылкой
                      int.DeployInvHide();
                      cmn.CloseSubRoom();
                      int.DialogHintShow( public.hint[ prg_name ].room );
                      PlaySfx( "assets/audio/aud_hint_txt_sfx", 0, 0 );

                    end;

                end;

                break;

             end;

           end;

        end;

      else

        --DbgTrace( "Hint is not ready now." );
        interface.DialogShow( "hnt_not_ready", 512, 384 );

      end;

    elseif ( ng_global.gamemode == 2 ) then

      interface.DialogShow( "hnt_hardcore", 512, 384 );

    else

      interface.DialogShow( "hnt_custommode", 512, 384 );

    end;

  end;
  --------------------------------------------------------------------------------------
  function public.ButtonInfo_Click()

    local mg_name = common.GetObjectName( GetCurrentRoom() );
    local prefix = common.GetObjectPrefix(  GetCurrentRoom() );
    
    if prefix ~= "mg" then
      if ( common.IsInSubRoom() ) then

        mg_name = common.GetObjectName( common.GetCurrentSubRoom() );

      elseif ( int.GetCurrentInv() ~= "" ) then

        local inv = string.sub( int.GetCurrentInv(), 12, string.len( int.GetCurrentInv() ) );

        mg_name = inv;

      end;
    
    end;

    interface.DialogShow( "ifo_"..mg_name );

     PlaySfx( "assets/audio/aud_hint_txt_sfx", 0, 0 );

  end;
  --------------------------------------------------------------------------------------
  function public.ButtonLock_Click()

    local autohide = interface.InventoryAutoHideGet();

    if autohide then

     PlaySfx( "assets/audio/aud_inv_lock", 0, 0 );

    else

     PlaySfx( "assets/audio/aud_inv_unlock", 0, 0 );

    end;

  end;
  --------------------------------------------------------------------------------------
  function public.ButtonMap_Click()

    cmn.PlayAudio( "sfx", "audio/aud_openmap", 0, "", 0 );

--    if ( IsDemoEdition() ) then
--
--      cmn.ShowBbt( "bbt_map_disabled" );
--    
--    else

      int.DeployInvHide();
      cmn.CloseSubRoom();
      int_dialog_hint.Hide();

      local prg  = ng_global.currentprogress;
      local room = GetCurrentRoom();

      local level = ng_global.progress[ prg ].common.chapter;

      local lvl   = string.sub( level, 6 );


      if ( lvl == "ext" ) then

          lvl = 4;

      end;

      lvl         = tonumber( lvl );

      int_map_impl.Screen( lvl );
      int_map_impl.InitTask( lvl );

      interface.MapShow();

    --end;
    
  end;
  --------------------------------------------------------------------------------------
  function public.ButtonMenu_Click()

  end;
  --------------------------------------------------------------------------------------
  function public.ButtonReset_Click()

    PlaySfx( "assets/audio/aud_mgreset", 0, 0 );
    local mg_name = GetCurrentRoom();

    if ( common.IsInSubRoom() ) then

      mg_name = common.GetCurrentSubRoom();

    elseif ( int.GetCurrentInv() ~= "" ) then

      local inv = string.sub( int.GetCurrentInv(), 12, string.len( int.GetCurrentInv() ) );

      mg_name = inv;

    end;

    _G[ mg_name ].Reset();

  end;
  --------------------------------------------------------------------------------------
  function public.ButtonSkip_Click( skip_ready )

    if ( ( ng_global.gamemode < 2 ) or ( ng_global.gamemode == 3 and ng_global.gamemode_custom[ "skip" ] ) ) then

      if ( skip_ready ) then

        PlaySfx( "assets/audio/aud_skip", 0, 0 );

        local mg_name = GetCurrentRoom();

        local minigame = private.current_mg_name or common.GetObjectName( mg_name ); 

        if ( common.IsInSubRoom() ) then

          mg_name = common.GetCurrentSubRoom();
          minigame = common.GetObjectName( mg_name );

          if mg_name == "zz_auntbureau" then

            minigame = "sails";

          end;

        elseif ( int.GetCurrentInv() ~= "" ) then

          local inv = string.sub( int.GetCurrentInv(), 12, string.len( int.GetCurrentInv() ) );

          mg_name = inv;
          minigame = mg_name;

        end;

        ng_global.progress[ ng_global.currentprogress ][ "win_"..minigame ].skip_clk = true;    

        _G[ mg_name ].Skip();
      
        interface.ButtonSkipReload( 1 );

      else

        --

      end;

    elseif ( ng_global.gamemode == 2 ) then

      interface.DialogShow( "str_skip_hardcore", 512, 384 );

    else

      interface.DialogShow( "str_skip_custommode", 512, 384 );

    end;

  end;
  --------------------------------------------------------------------------------------
  function public.FrameSubroom_Click ()

  end;
  --------------------------------------------------------------------------------------
  function public.Tutorial_Click( button_id )
      
    local type = ng_global.currentprogress;

    local postfix = "";
    if ( type == "scr" ) then postfix = "_scr"; end;

    local tutorial_name = ng_global.progress[ type ][ "see_tutorial"..postfix ].state.currentpage;
    local pages = ng_global.progress[ type ][ "see_tutorial"..postfix ].state.pages;

    if ( string.find( button_id, "yes" ) ) then

      interface.TutorialHide();
      public.TutorialSetShown( tutorial_name );
      if (ng_global.progress[ type ][ "see_tutorial"..postfix ].start == 0 ) then

        if type == "std" and ng_global.progress[ "std" ].common.chapter == "level1" then

          public.TutorialShow( "tutorial_page_2" );

        elseif ( type == "scr" and tutorial_name == "tutorial_page_1_scr" and 
          pages[ "tutorial_page_2_scr" ][ "shown" ] == 0 ) then

          int_morph_scr.Show();
          public.TutorialShow( "tutorial_page_2_scr" );

        end;

      else 

        if ( type == "scr" and tutorial_name == "tutorial_page_2_scr" and 
          pages[ "tutorial_page_3_scr" ][ "shown" ] == 0 ) then

          public.TutorialShow( "tutorial_page_3_scr" );

        elseif ( type == "scr" and tutorial_name == "tutorial_page_3_scr" and 
          pages[ "tutorial_page_4_scr" ][ "shown" ] == 0  ) then

          public.TutorialShow( "tutorial_page_4_scr" );

        elseif ( type == "scr" and tutorial_name == "tutorial_page_4_scr" ) then

          cmn.StartMorhpTask();

        elseif ( type == "scr" and tutorial_name == "tutorial_page_5_scr" ) then

          int_timer_scr.StartTimer();

        elseif ( type == "scr" and tutorial_name == "tutorial_page_6_scr" ) then

          private.ChangeStage();

        end;

      end;        

      ng_global.progress[ type ][ "see_tutorial"..postfix  ].start = 1;

    elseif ( ng_global.progress[ type ][ "see_tutorial"..postfix  ].start == 1 ) and ( string.find( button_id, "empty" ) ) then

      interface.TutorialHide();
      public.TutorialSetShown( tutorial_name );

      if ( type == "scr" ) then
        
        cmn.StartMorhpTask();

        if ( tutorial_name == "tutorial_page_5_scr" ) then

          int_timer_scr.StartTimer();
        
        elseif ( tutorial_name == "tutorial_page_6_scr" ) then

          private.ChangeStage();

        end;

      end;

    elseif ( string.find( button_id, "no" ) ) then
      
      ng_global.progress[ type ][ "see_tutorial"..postfix  ].start = 1;
      ng_global.progress[ type ][ "see_tutorial"..postfix  ].state.no = 1;

      interface.TutorialHide();
      public.TutorialSetShown( tutorial_name );
      ng_global.progress[ type ][ "see_tutorial"..postfix  ].done = 1;

      if ( type == "scr" ) then

        cmn.StartMorhpTask();

        if ( tutorial_name == "tutorial_page_5_scr" ) then

          int_timer_scr.StartTimer();
        
        elseif ( tutorial_name == "tutorial_page_6_scr" ) then

          private.ChangeStage();

        end;

      end;

    elseif ( string.find( button_id, "skipall" ) ) then
      
      ng_global.progress[ type ][ "see_tutorial"..postfix  ].start = 1;
      ng_global.progress[ type ][ "see_tutorial"..postfix  ].state.no = -1;

      interface.TutorialHide();
      public.TutorialSetShown( tutorial_name );
      ng_global.progress[ type ][ "see_tutorial"..postfix  ].done = 1;

      if ( type == "scr" ) then

        cmn.StartMorhpTask();

        if ( tutorial_name == "tutorial_page_5_scr" ) then

          int_timer_scr.StartTimer();
        
        elseif ( tutorial_name == "tutorial_page_6_scr" ) then

          private.ChangeStage();

        end;

      end;

    else

      --DbgTrace("impossible "..button_id);

    end;
    
    local next  = pages[ tutorial_name ][ "next" ];

    if ( next ) then

      public.TutorialShow( next );

    end;
    
end;
  --------------------------------------------------------------------------------------
  function public.TutorialShow( tutorial_name )

    local type = ng_global.currentprogress;
    
    if ( ng_global.gamemode == 0 )or( ng_global.gamemode == 3 and ng_global.gamemode_custom[ "tutorial" ] or type == "scr" ) then

      if ng_global.currentprogress == "std" then

        local table_multiset = {};
        table.insert( table_multiset, { "obj_int_tutorial_buttons_mid", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_buttons_right", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_buttons_left", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_clk", { input = false } } );
        ObjDetach( "obj_int_tutorial_clk" );      

        if ( ng_global.progress[ type ][ "see_tutorial" ].state.no ~= 0 ) then

          table.insert( table_multiset, { "obj_int_tutorial_buttons_mid", { input = false, visible = false } } );

        end;

        ObjMultiSet( table_multiset );
        
        local pages = ng_global.progress[ type ][ "see_tutorial" ].state.pages;
        local currentpage = ng_global.progress[ type ][ "see_tutorial" ].state.currentpage;         
        local no_skip = pages[ tutorial_name ][ "noskip" ];
        
        if ( ng_global.progress[ type ][ "see_tutorial" ].state.no == 0 ) 
           or ( ( ng_global.progress[ type ][ "see_tutorial" ].state.no == -1 ) and ( no_skip == true ) ) then      

          if ( pages[ tutorial_name ][ "shown" ] == 0 ) then        

            ng_global.progress[ type ][ "see_tutorial" ].state.currentpage = tutorial_name;

            local dlg_pos_x   = pages[ tutorial_name ][ "posx" ];
            local dlg_pos_y   = pages[ tutorial_name ][ "posy" ];
            local arrows      = pages[ tutorial_name ][ "arrows" ];
            local string      = "str_"..tutorial_name;
            local block_input = pages[ tutorial_name ][ "input" ];

            interface.TutorialShow( string, block_input, dlg_pos_x, dlg_pos_y, arrows );

          end;
          
        end;

      elseif ( ng_global.currentprogress == "scr" ) then

        local table_multiset = {};
        table.insert( table_multiset, { "obj_int_tutorial_buttons_mid", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_buttons_right", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_buttons_left", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_clk", { input = false } } );
        ObjDetach( "obj_int_tutorial_clk" );      

        if ( ng_global.progress[ type ][ "see_tutorial_scr" ].state.no ~= 0 ) then

          table.insert( table_multiset, { "obj_int_tutorial_buttons_mid", { input = false, visible = false } } );

        end;

        ObjMultiSet( table_multiset );
        
        local pages = ng_global.progress[ type ][ "see_tutorial_scr" ].state.pages;
        local currentpage = ng_global.progress[ type ][ "see_tutorial_scr" ].state.currentpage;         
        local no_skip = pages[ tutorial_name ][ "noskip" ];
        
        if ( ng_global.progress[ type ][ "see_tutorial_scr" ].state.no == 0 ) 
           or ( ( ng_global.progress[ type ][ "see_tutorial_scr" ].state.no == -1 ) and ( no_skip == true ) ) then      

          if ( pages[ tutorial_name ][ "shown" ] == 0 ) then        

            ng_global.progress[ type ][ "see_tutorial_scr" ].state.currentpage = tutorial_name;

            local dlg_pos_x   = pages[ tutorial_name ][ "posx" ];
            local dlg_pos_y   = pages[ tutorial_name ][ "posy" ];
            local arrows      = pages[ tutorial_name ][ "arrows" ];
            local string      = "str_"..tutorial_name;
            local block_input = pages[ tutorial_name ][ "input" ];

            interface.TutorialShow( string, block_input, dlg_pos_x, dlg_pos_y, arrows );
            int_timer_scr.PauseTimer();

          end;
          
        end;
        
      elseif ( ng_global.currentprogress == "ext" ) then
        
        local pages = ng_global.progress[ type ][ "see_tutorial" ].state.pages;
        local currentpage = ng_global.progress[ type ][ "see_tutorial" ].state.currentpage;         
        local no_skip = pages[ tutorial_name ][ "noskip" ];
        
        if ( ( ng_global.progress[ type ][ "see_tutorial" ].state.no == 0 or ( no_skip == true ) ) ) and ( ng_global.progress[ type ][ "see_tutorial" ].state.no ~= -1 ) then      

          if ( pages[ tutorial_name ][ "shown" ] == 0 ) then        

            ng_global.progress[ type ][ "see_tutorial" ].state.currentpage = tutorial_name;

            local dlg_pos_x   = pages[ tutorial_name ][ "posx" ];
            local dlg_pos_y   = pages[ tutorial_name ][ "posy" ];
            local arrows      = pages[ tutorial_name ][ "arrows" ];
            local string      = "str_"..tutorial_name;
            local block_input = pages[ tutorial_name ][ "input" ];

            interface.TutorialShow( string, block_input, dlg_pos_x, dlg_pos_y, arrows );

          end;
          
        end;

      end;

    end;

  end;

  --------------------------------------------------------------------------------------
  function public.TutorialSetShown( tutorial_name )

    local type = ng_global.currentprogress;
    local postfix = "";
    if ( type == "scr" ) then postfix = "_scr"; end;

    local type = ng_global.currentprogress;

    local pages = ng_global.progress[ type ][ "see_tutorial"..postfix ].state.pages;

    pages[ tutorial_name ][ "shown" ] = 1;

  end;
  --------------------------------------------------------------------------------------
  function public.HoHint_NoObjects()

  end;
  --------------------------------------------------------------------------------------
  function public.DialogHo_Show()

    interface.TaskPanelHide();
    interface.ItemPanelHide();
    --interface.DialogHoShow();

    local ho_name = common.GetObjectName( GetCurrentRoom() );
      if port.isPortable() == 1 then
          port.LogEvent("win_"..ho_name, "close");
      end;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].done = 1;
    ng_global.progress[ ng_global.currentprogress ].common.currentroom = game.relations[ "ho_"..ho_name ].exitroom;
    
    if ( ng_global.currentprogress == "rpl" ) then
      cmn.GotoRoom( "rm_replayroom" );
      int.Lock( false );
    else
      interface.DialogHoShow();
    end;

  end;
  --------------------------------------------------------------------------------------
  function public.DialogHo_Hide()

    local ho_name = common.GetObjectName( GetCurrentRoom() );
    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      if ( "ho" == common.GetObjectPrefix( GetCurrentRoom() ) ) then

        common_impl.PassingHoWin();

      end;

    end;

    if ( "ho" == common.GetObjectPrefix( GetCurrentRoom() ) ) then

      cmn.CallEventHandler( "win_"..ho_name, GetCurrentRoom() );
      common.GotoRoom( game.relations[ GetCurrentRoom() ].exitroom );

    end;

  end;
  --------------------------------------------------------------------------------------
  function public.PanelNotification_Click( notification_type )

    DbgTrace( "Notification Panel Clicked. Notification type: "..notification_type );

  end;
--------------------------------------------------------------------------------------
--*********************************************************************************************************************
--***function *** GATES *** () end ************************************************************************************
--*********************************************************************************************************************
  function public.GotoRm( rm_name, need_fade )

    local rm_object_name = "rm_"..rm_name;

    need_fade = need_fade or 1;  

    public.DeleteHintFx()

    common.GotoRoom( rm_object_name, need_fade );

  end;
  --------------------------------------------------------------------
  function public.GotoHo( ho_name, need_fade )

    local ho_object_name = "ho_"..ho_name;

    need_fade = need_fade or 1; 
    
    public.DeleteHintFx()  

    common.GotoRoom( ho_object_name, need_fade );

  end;
  --------------------------------------------------------------------
  function public.GotoMg( mg_name, need_fade )

    local mg_object_name = "mg_"..mg_name;

    need_fade = need_fade or 1; 
    
    public.DeleteHintFx()  

    common.GotoRoom( mg_object_name, need_fade );

  end;
  --------------------------------------------------------------------
  function public.GotoZz( zz_name, pos_beg )
    
    local zz_object_name = "zz_"..zz_name;

    public.DeleteHintFx()
    ObjDelete( "obj_hint_obj_int_frame_subroom_button" );

    common.GotoSubRoom( zz_object_name, pos_beg );

  end;
  --------------------------------------------------------------------
  function public.GateMouseEnter( type_cursor, text_obj, sender )
        
    if ( type_cursor ) then
      SetCursor( type_cursor );
    else
      SetCursor( CURSOR_DEFAULT );
    end;
     
    local obj = sender;
    local postfix = "";
    if ( ObjGet( obj ).res == "" ) then
      postfix = "_focus";
    end;
    
    local alp = ObjGet( obj..postfix ).alp;
    local time = 0.3;
    ObjAnimate( obj..postfix, "alp", 0, 0, "", 
    { 
      0.0,              0, alp, 
      time*( 1 - alp ), 0, 1
    } );

    if ( ng_global.currentprogress == "ext" ) then

      text_obj = text_obj.."_ce";

    end;

    public.PopupShow( text_obj );

  end;
  --------------------------------------------------------------------
  function public.GateMouseLeave( sender )
      
    SetCursor( CURSOR_DEFAULT );

    local obj = sender;
    local postfix = "";
    if ( ObjGet( obj ).res == "" ) then
      postfix = "_focus";
    end;

    local alp = ObjGet( obj..postfix ).alp;
    local time = 0.3;
    ObjAnimate( obj..postfix, "alp", 0, 0, "", 
    { 
      0.0,        0, alp,
      time * alp, 0,   0 
    });
       
    public.PopupHide();

  end;
--*********************************************************************************************************************
--***function *** POPUP *** () end ************************************************************************************
--*********************************************************************************************************************
  function public.PopupShow( popup_text )

    popup_text_id = "pop_"..popup_text;
    interface.PopupShow( popup_text_id );
    
  end;
  --*********************************************************************************************************************
  function public.PopupHide()

    interface.PopupHide();
    
  end;
  --*********************************************************************************************************************
  function public.ShowBbt( bbt_text, bbt_cnt, bbt_rnd )

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "text" ] ) then    
    return;
    end;   

      local txtout = bbt_text;
      local cnt = 1;
      local rnd = false;

      local postfix = "";
      local prg = ng_global.currentprogress;

      if prg == "ext" then

        postfix = "_ce";

      elseif prg == "scr" then

        postfix = "_sc";

      end;
      
      
      -- если нет массива
      if not ng_global.bbt then
        ng_global.bbt = {};
      end;
      -- получаем количество
      if bbt_cnt then
        cnt = tonumber(bbt_cnt);
      end;
      if bbt_rnd then
        rnd = true;
      end;

      -- если много
      if cnt > 1 then
        -- если еще нет записи в массиве
        if not ng_global.bbt[txtout] then
          ng_global.bbt[txtout] = 1;
        end;
        -- без рандома
        if not rnd then
          interface.BBTShow(txtout.."_"..ng_global.bbt[txtout]..postfix);
          -- увеличиваем/сбрасываем счетчик
          if ng_global.bbt[txtout] == cnt then
            ng_global.bbt[txtout] = 1;
          else
            ng_global.bbt[txtout] = ng_global.bbt[txtout] + 1;
          end;
        -- рандом
        else
          local new_bbt = ng_global.bbt[txtout];
          --DbgTrace("old "..new_bbt);
          while (new_bbt == ng_global.bbt[txtout]) do
            new_bbt = math.random(1,cnt);
            --DbgTrace("new "..new_bbt);
          end;
          ng_global.bbt[txtout] = new_bbt;
          --DbgTrace("fin "..ng_global.bbt[txtout]);
          interface.BBTShow(txtout.."_"..ng_global.bbt[txtout]..postfix);
        end;
      else
        interface.BBTShow(txtout..postfix);
      end;

  end;
  --*********************************************************************************************************************
  function private.WrongApply()

    local txtout = "bbt_wrongapply";
    local cnt = 3;
    local sound_cnt = 3

    if not ng_global.wrongapply then
      ng_global.wrongapply = {};
    end;
    
    local new_wrongapply = ng_global.wrongapply[txtout];
    local new_sound = math.random(1,sound_cnt);

    while (new_wrongapply == ng_global.wrongapply[txtout]) do
      new_wrongapply = math.random(1,cnt);
    end;

    ng_global.wrongapply[txtout] = new_wrongapply;
    interface.BBTShow(txtout.."_"..ng_global.wrongapply[txtout]);

    cmn.PlayAudio( "sfx", "audio/aud_wrongapply"..new_sound, 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function public.DelayedCall( delay, caller )

    local timer;

    repeat

      timer = "tmr_delayedcall_timer_"..math.random( 10000 ); 
   
    until not private.timers[ timer ];

    private.timers[ timer ] = caller;

    --if not next( ObjGet( timer ) ) then

      ObjCreate( timer, "timer" );

    --end;

    ObjAttach( timer, "cmn_timers" );

    local trg_after = function ()

      private.DelayedCallTimer( timer );

    end;

    ObjSet( timer, { endtrig = trg_after, time = delay, playing = 1 } );

    return timer;

  end;
  --*********************************************************************************************************************
  function private.DeleteTimer( timer_id )

    if private.timers[ timer_id ] then

      ObjSet( timer_id, { playing = 0 } ); 
      private.timers[ timer_id ] = {};
      ObjDelete( timer_id );

      return true;

    else

      return false;

    end;

  end;
  --*********************************************************************************************************************
  function private.DelayedCallTimer( timer )

    local timer = timer;
    local callback = private.timers[ timer ];
    private.DeleteTimer( timer );
    callback();

  end;
  --*********************************************************************************************************************
  -- show/hide interface 
  function public.InterfaceSetVisible( key )

    local int_widget = {};
    if ng_global.currentprogress == "rpl" then
      int_widget = 
      {
        "int_button_hint"
       };
    else
      int_widget = 
      {
        "int_inventory",
        --"int_taskpanel",
        "int_button_hint",
        "int_button_map",
        "int_button_menu",
        "int_button_guide"
       };
    end;

    if ( key ) then

--      for i = 1, #int_widget do
--
--        ObjSet( int_widget[ i ], { input = true, visible = true, alp = 1 });
--
----DbgTrace( "int_widget[ i ] = "..tostring( int_widget[ i ] ) );
--      end;
      for i = 1, #int_widget do
        
        if ( ObjGet( int_widget[ i ] ) ) then         

          ObjSet( int_widget[ i ], { input = true, visible = true } );

          local alp = ObjGet( int_widget[ i ] ).alp;

          ObjAnimate( int_widget[ i ], "alp", 0, 0, "", { 0,0,alp,  0.3,0,1 } );
          
        end;          

      end;

      --ObjSet( "subroom", { input = 1 });

    else 

      for i = 1, #int_widget do
        
        if ( ObjGet( int_widget[ i ] ) ) then 

          ObjSet( int_widget[ i ], { input = 0 } );

          local alp = ObjGet( int_widget[ i ] ).alp;

          ObjAnimate( int_widget[ i ], "alp", 0, 0, "", { 0,0,alp,  0.3,0,0 } );
          
        end;

      end;

      --ObjSet( "subroom", { input = 0 });

    end;

  end;
--*********************************************************************************************************************
  function public.InterfaceSetInput( key )

    local int_widget = 
    {
      "int_inventory",
    }

    if ( key == false ) then

      for i = 1, #int_widget do

        ObjSet( int_widget[ i ], { input = 0 } );

      end;

    else 

      for i = 1, #int_widget do

        ObjSet( int_widget[ i ], { input = 1 });

      end;

    end;

  end;
--*********************************************************************************************************************
--***function *** AUDIO *** () end ************************************************************************************
--*********************************************************************************************************************
  function private.AudioInit ()

    cmn.PlayAudio          = private.PlayAudio;
    cmn.StopAudio          = private.StopAudio;
    cmn.StopAllEnv         = private.StopAllEnv;
    cmn.StopAllMus         = private.StopAllMus;
    cmn.StopAllVoc         = private.StopAllVoc;
    cmn.IsPlayEnv          = private.IsPlayEnv;
    cmn.VolumeFadingOff    = private.VolumeFadingOff;
    cmn.VolumeFadingOn     = private.VolumeFadingOn;
    cmn.GetCurrentEnv      = private.GetCurrentEnv;
    
  end;
  --*********************************************************************************************************************
  function private.PlayAudio ( type, path, loop, fade )

    if not loop then loop = 0; end;
    if not fade then fade = 0; end;
    
    local needtoplay = true;

    if ( ( type ~= "sfx" ) and 
         ( loop == 1 ) and 
         ( #private.audio[type] > 0 ) ) then

      for i = 1, #private.audio[type], 1 do
        if ( private.audio[type][i] == path ) then

          needtoplay = false;

        end;
      end;

    end;

    if ( needtoplay ) then

      if ( type == "sfx" ) then

        PlaySfx( "assets/"..path, loop, fade );

      elseif ( type == "env" ) then

        PlayEnv( "assets/"..path, loop, fade );
        private.audio["env"][ #private.audio["env"] + 1 ] = path;

      elseif ( type == "mus" ) then

        PlaySoundtrack( "assets/"..path, loop, fade );
        private.audio["mus"][ #private.audio["mus"] + 1 ] = path;

      elseif type == "mus_env" then

        PlaySoundtrack("assets/audio/"..path,loop,fade);
        private.audio["mus_env"][ #private.audio["mus_env"] + 1 ] = path;

      elseif ( type == "voc" ) then

        PlayVoice( "assets/"..path, loop, fade );
        private.audio["voc"][ #private.audio["voc"] + 1 ] = path;

      end;

      cmn.audio = private.audio;
      

    end;

  end;
  --*********************************************************************************************************************
  --функция проигрывания енвайромента
  function public.EnvPlay(paths,trig,fade)
    if not trig then trig = ""; end;
    if not fade then fade = 0; end;

    local loop = 1;
    local needtoplay = true;
    local shift = 0;
    
    
    for i = 1, #private.audio["env"] do    
      local needtostop = true;
      for j = 1, #paths do
        if private.audio["env"][i] == paths[j] then
          needtostop = false;
        end;
      end;
      if needtostop then
        SndStop("assets/"..private.audio["env"][i],2.0);
        private.audio["env"][i] = nil;
        shift = shift + 1;
      else
        private.audio["env"][i-shift] = private.audio["env"][i];
        if shift ~= 0 then
          private.audio["env"][i] = nil;
        end;
      end;
    end;

    for j = 1, #paths, 1 do
      needtoplay = true;
      for i = 1, #private.audio["env"], 1 do
        if private.audio["env"][i] == paths[j] then
          needtoplay = false;
        end;           
      end; 
      
      if needtoplay then
        PlayEnv("assets/"..paths[j],loop,fade);
        private.audio["env"][ #private.audio["env"] + 1 ] = paths[j];
      end;
    end;
    
  end;
  --*********************************************************************************************************************
  function public.PlayMusEnv ( path )

    if IsNoSoundDevice() then

      return;

    end;

    local rnd;
    local rnd_max = 7;
    local time_name = "tmr_mus_env";
    local time = 150;
    local prg = ng_global.currentprogress;
    local level = ng_global.progress[ prg ].common.chapter;
 
    if not ObjGet( time_name ) then

      ObjCreate( time_name, "timer" );
      ObjAttach( time_name, "cmn_timers" );

    end;

    ObjSet( time_name, { playing = true, time = time, endtrig = function() public.PlayMusEnv() end } );

    if not path then

      if level == "level1" then

        rnd = rnd_max;

      else

        rnd = rnd_max;

      end;

      path = "mus_env/aud_track"..math.random( rnd ).."_mus_env";

    end;

    public.StopMusEnv( true );
    private.PlayAudio( "mus_env", path, 0, "", 0.5 )

  end;
  --*********************************************************************************************************************
  function public.StopMusEnv ( continuation )

    if not continuation then

      local time_name = "tmr_mus_env";
      ObjSet( time_name, { playing = false } );

    end;

    if ( private.audio["mus_env"][1] ~= nil ) then

      SndStop( "assets/audio/"..private.audio["mus_env"][1], 2 );
      private.audio["mus_env"][1] = nil;

    end;
 
  end;
  --*********************************************************************************************************************
  function private.StopAudio ( type, path, fade)

    if ( not fade ) then 

      fade = 0; 

    end;

    for i = 1, #private.audio[type], 1 do
      if ( private.audio[type][i] == path ) then

        private.audio[type][i] = nil;

      end;
    end;

    SndStop("assets/"..path,fade);

  end;
  --*********************************************************************************************************************
  function private.StopAllEnv ( path, play_mus_env )

    for i = 1, #private.audio[ "env" ], 1 do

      if ( ( private.audio[ "env" ][ i ] ~= nil  )  and 
           ( private.audio[ "env" ][ i ] ~= path ) ) then

        local is_mus_env = string.find ( private.audio[ "env" ][ i ], "mus" );

        if ( not is_mus_env ) or ( is_mus_env and not play_mus_env ) then

          SndStop( "assets/"..private.audio[ "env" ][ i ], 2.5 );
          private.audio["env"][i] = nil;

        end;

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.StopAllMus ( path )

    for i = 1, #private.audio[ "mus" ], 1 do

      if ( ( private.audio[ "mus" ][ i ] ~= nil  ) and 
           ( private.audio[ "mus" ][ i ] ~= path ) ) then

        SndStop( "assets/"..private.audio[ "mus" ][ i ], 0.5 );
        private.audio[ "mus" ][ i ] = nil;

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.StopAllVoc ( path )

    for i = 1, #private.audio["voc"], 1 do

      if ( ( private.audio["voc"][i] ~= nil ) and 
           ( private.audio["voc"][i] ~= path ) ) then

        SndStop( "assets/"..private.audio["voc"][i], 0.5 );
        private.audio["voc"][i] = nil;

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.VolumeFadingOff()

      private.volume_fade = false;
    
      SetSoundVolume("voice",private.dialog_voice);
      SetSoundVolume("soundtrack",private.dialog_soundtrack);
      SetSoundVolume("env",private.dialog_env);
    
  end;
  --*********************************************************************************************************************
  function private.VolumeFadingOn()

    private.dialog_soundtrack = GetSoundVolume( "soundtrack" );
    private.dialog_voice = GetSoundVolume( "voice" );
    private.dialog_env = GetSoundVolume( "env" );

    if private.dialog_soundtrack > 0.15 and private.dialog_voice > 0.15 then 

      private.volume_fade = true;

      local dialog_voice = private.dialog_voice;
      local dialog_soundtrack = private.dialog_soundtrack;
      local dialog_env = private.dialog_env;

      if (private.dialog_voice - private.dialog_soundtrack) < 0.3 then

        dialog_voice = 0.7;
        dialog_soundtrack = 0.2;

        if (private.dialog_voice - private.dialog_env) < 0.3 then

          dialog_env = 0.6;
  --DbgTrace( "private.dialog_env0.3" );        
        end;

      elseif (private.dialog_voice - private.dialog_soundtrack) < 0.9 then 
     
        dialog_voice = 0.8;
        dialog_soundtrack = 0.3;

        if (private.dialog_voice - private.dialog_env) < 0.9 then

          dialog_env = 0.6;
  --DbgTrace( "private.dialog_env0.5" );        
        end;

      end;

      SetSoundVolume( "voice", dialog_voice );
      SetSoundVolume( "soundtrack", dialog_soundtrack );
      SetSoundVolume( "env", dialog_env );

    end;  
    
  end;

  --*********************************************************************************************************************
  function private.IsPlayEnv ( path )

    for i = 1, #private.audio[ "env" ], 1 do

      if ( ( private.audio[ "env" ][ i ] ~= nil  )  and 
           ( private.audio[ "env" ][ i ] == path ) ) then

        return true;

      end;

    end;

    return false;

  end;

  --*********************************************************************************************************************
  function private.GetCurrentEnv ()

    local current_env = {};

    if ( private.audio[ "env" ] ) then

      for e = 1, #private.audio[ "env" ] do

        table.insert( current_env, private.audio[ "env" ][ e ] );

      end;

    end;

    return current_env;

  end;
  --*********************************************************************************************************************
  function public.PlayDialogVideo ( vid_name, func_end, skip_func, skip_time, block_input )

    int_blackbartext.Hide();

    skip_func = skip_func or func_end;
    skip_time = skip_time or 1.5;
    block_input = block_input or 1;

    local env_list = {};

    for i = 1, #private.audio["env"] do

      table.insert( env_list, private.audio["env"][ 1 ] );

    end;

    public.StopMusEnv();
    cmn.StopAllMus();
    cmn.StopAllVoc();

    local func_env_end = function ()

      public.EnvPlay( env_list, "", 2 );
      public.PlayMusEnv();
      int.DialogVideoHide();

      func_end();

    end;

    local func_env_skip = function ()

      public.EnvPlay( env_list, "", 2 );
      public.PlayMusEnv();
      int.DialogVideoHide();

      skip_func();

    end;

    int.DialogVideoShow( vid_name, block_input, func_env_skip, skip_time );
    VidPlay( vid_name, func_env_end );

  end;
--------------------------------------------------------------------------------------
--*********************************************************************************************************************
--***function *** DIALOG CHARACTER *** () end**************************************************************************
--*********************************************************************************************************************
  function public.DialogCharacterChoiceClk( number_choice )

    cmn.StopAllVoc();

    local name = tostring( private.object_current );
    local current_room = common.GetObjectName( GetCurrentRoom() );
    public.dialog_character_select = 0;
   
    if public.frases[ number_choice ] then
    
      public.answer_text = "str_"..current_room.."_"..name.."_answer_"..public.frases[ number_choice ];
      private.lipsing_name = "vid_"..current_room.."_"..name.."_answer_"..public.frases[ number_choice ]; 
      public.dialog_character_select = public.frases[ number_choice ];

    end;

    local func_after = function()

      int.Lock( false );
       
      for i = 1, #public.frases do

       ObjSet( "spr_int_dialog_character_choise_"..i, { alp = 0, input = false } );

      end;

      ObjSet( "grd_int_dialog_character_choise", { input = false } );

      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = function() int_dialog_character.ContinueClick( false ) end; } );

      table.remove( public.frases, number_choice );
      table.remove( public.dial_icons, number_choice );

      if #public.frases == 0 then public.continue_visible = true;
      else public.continue_visible = false;
      end;
    
      int_dialog_character.ContinueClick( true );

    end;

    int.Lock( true );

     ObjAnimate( "grd_int_dialog_character_choise", "pos_x", 0, 0, func_after,
    {
      0, 3, 0,
      0.5, 3, -500   
    } );

  end;
  --******************************************************************************************
  function public.DialogCharacterSwitchDialogFrase( )

    local current_room = GetCurrentRoom();
    local count_txt = private.dialog_count_txt;
    local dlg_name = private.object_current;
    if ( _G[current_room].SwitchFrase ) then
    _G[current_room].SwitchFrase( dlg_name, count_txt );
    end;

  end;
  --******************************************************************************************
  function public.DialogCharacterShowDialogQuestions( number_choice, time, func_change_1, func_change_2 )

    name_object = tostring( private.object_current );
    number_choice = tonumber( number_choice );

    local current_room = common.GetObjectName( GetCurrentRoom() );
    local text_height = 0;

    local func_end_1 = function()

      public.DialogCharacterDialogQuestionsAnim();

      if ( func_change_1 ) then

        func_change_1();

      end;

    end;

    ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = function() func_end_1(); end } );

    local endtrig = "";

    for i = 1, number_choice do
   
     ObjSet( "txt_int_dialog_character_choise_"..i, { text = "str_"..current_room.."_"..name_object.."_question_"..public.frases[i] } );

     if public.dial_icons[i] then

        ObjSet( "spr_int_dialog_character_choise_"..i.."_picture", { alp = 1, res = "assets/interface/resources/dialog_character/icons/"..public.dial_icons[i] } );
        ObjSet( "spr_int_dialog_character_choise_"..i.."_focus", { res = "assets/interface/resources/dialog_character/icons/"..public.dial_icons[i].."_act" } );

     end;

     endtrig = function() 
  
       public.DialogCharacterChoiceClk( i );
  
       if ( func_change_2 ) then

         func_change_2();

       end;   

     end;    

     ObjSet( "spr_int_dialog_character_choise_"..i, { event_mdown = endtrig, alp = 1, input = true } );
     
     text_height = text_height + ObjGet( "txt_int_dialog_character_choise_"..i ).draw_height;

    end;

    local dialog_w = 550;
    local dialog_h = text_height + 200;
    local grid_corner_w = int_dialog_character_impl.GRID_CORNER_W;
    local grid_corner_h = int_dialog_character_impl.GRID_CORNER_H;
    local grid_mid_w = int_dialog_character_impl.GRID_MID_W;
    local grid_mid_h = int_dialog_character_impl.GRID_MID_H;

    interface.FrameGridSet( "int_dialog_character_choise",
    {
      grid_w   = dialog_w,
      grid_h   = dialog_h,
      corner_w = grid_corner_w,
      corner_h = grid_corner_h,
      mid_w    = grid_mid_w,
      mid_h    = grid_mid_h
    } );

    if number_choice == 3 then

      ObjSet( "spr_int_dialog_character_choise_1", { pos_y = -96 } );
      ObjSet( "spr_int_dialog_character_choise_2", { pos_y = 0 } );
      ObjSet( "spr_int_dialog_character_choise_3", { pos_y = 96 } );

    elseif number_choice == 2 then

      ObjSet( "spr_int_dialog_character_choise_1", { pos_y = -48 } );
      ObjSet( "spr_int_dialog_character_choise_2", { pos_y = 48 } );

    else

      ObjSet( "spr_int_dialog_character_choise_1", { pos_y = 0 } );

    end;

    if not time then time = 1; end; 
   
    int.Lock( true );
    ObjSet( "grd_int_dialog_character_choise", { input = false } ); 

    ObjAnimate( "grd_int_dialog_character_choise", "pos_x", 0, 0, func_end_1,
    {
      0, 3, -500,
     ( time - 0.5 ), 3, -500
    } );

  end;
  --******************************************************************************************
  function public.DialogCharacterDialogQuestionsAnim()

    cmn.StopAllVoc();
    public.DialogCharacterStopAllVid();

    local func_after = function()

      ObjSet( "grd_int_dialog_character_choise", { input = true } );
      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = "" } );

    end;

    ObjSet( "grd_int_dialog_character_choise", { pos_x = -500 } );

    ObjSet( "obj_int_dialog_character_input", { input = false } );

    ObjAnimate( "grd_int_dialog_character_choise", "pos_x", 0, 0, func_after,
    {
      0.0, 3, -500,
      0.5, 3, 0
    });
     

  end;
  --******************************************************************************************
  function public.DialogCharacterChangeCharacters( object_name, current_character, new_character )

      local current_room = common.GetObjectName( GetCurrentRoom() );

      if current_character then

        ObjAnimate( "obj_"..current_room.."_"..object_name.."_"..current_character, "scale_xy", 0, 0, "", { 0,0,1.05,1.05, 0.3,0,1,1 } );
        ObjSet( "obj_"..current_room.."_"..object_name.."_"..current_character, { pos_z = 1 } );

      end;
      
      local relations = ObjGetRelations( "obj_"..current_room.."_"..object_name.."_characters" );

      for i = 1, #relations.childs do

        ObjSet( relations.childs[i], { color_r = 0.4,color_g = 0.4, color_b = 0.4 } );

      end;
         
      ObjSet( "obj_"..current_room.."_"..object_name.."_"..new_character, { pos_z = 10, color_r = 1, color_g = 1, color_b = 1 } );
      ObjAnimate( "obj_"..current_room.."_"..object_name.."_"..new_character, "scale_xy", 0, 0, "", { 0,0,1,1, 0.3,0,1.05,1.05 } );
     
  end;
  --******************************************************************************************
  function public.DialogCharacterStart( object_name, max_number, click_func, skip_func, func_after_frase, end_trigger )
    
     public.InterfaceSetVisible( false );

     int.Lock( true );

     local current_room = common.GetObjectName( GetCurrentRoom() );

     local trg_after = function()

      int.Lock( false );

     end;

     if ( string.find( object_name, "jackie_" ) == 0 ) then

       ObjAnimate( "dlg_"..current_room.."_"..object_name, "alp", 0, 0, trg_after, { 0,0,0, 0.3,0,1 } );

     end;

     if public.dialog_character_loc then
    
      ObjAnimate( public.dialog_character_loc, "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );

     end;

     ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = function() int_dialog_character.ContinueClick( false ) end; } );
      
     ObjStopAnimate( "grd_int_dialog_character_choise", "pos_x" );

     ObjSet( "grd_int_dialog_character_choise", { pos_x = -500 } );
     
     interface.DialogCharacterShow( object_name, max_number, click_func, skip_func, func_after_frase, false, end_trigger );

  end;
  --******************************************************************************************
  function public.DialogCharacterShow( object_name, max_number, click_func, skip_func, func_after_frase, answer, end_trigger )

    cmn.StopAllVoc();

    if not func_after_frase then
      func_after_frase = false;
    end;

    if not end_trigger then
      end_trigger = false;
    end;

    public.func_after_frase = func_after_frase;
    public.end_trigger = end_trigger;
    public.max_number = max_number;
    private.object_current = object_name;

    if not private.dialog_count_txt then
      private.dialog_count_txt = 0;
    end;

    local current_room = common.GetObjectName( GetCurrentRoom() );

    private.dialog_count_txt = private.dialog_count_txt + 1;
   
    if not answer and public.continue_answer ~= true then
      public.answer_text = "str_"..current_room.."_"..object_name.."_"..private.dialog_count_txt; 
      private.lipsing_name = "vid_"..current_room.."_"..object_name.."_"..private.dialog_count_txt; 
    end;

    if public.continue_answer == true then
      public.continue_visible = true;
    end;

    --войсы

    local voc_name = string.sub( public.answer_text, 5, string.len( public.answer_text )  );
    local path;
    if ( ng_global.currentprogress == "ext" ) then
      path = "level4";
    else
      path = ng_global.progress[ ng_global.currentprogress ].common.chapter;
    end;
    voc_name = common.GetObjectName( voc_name );

    cmn.PlayAudio( "voc", "audio/"..path.."/voc/aud_"..voc_name.."_voc", 0, "", 0 );

    --липсинг
    
    public.DialogCharacterStopAllVid();
    ObjSet( private.lipsing_name, { alp = 1, playing = 1 } );
    --DbgTrace( private.lipsing_name );
    
    int_dialog_character.Show( object_name, click_func, skip_func );

    if func_after_frase then

      public.DialogCharacterSwitchDialogFrase();

    end;

  end;
  --******************************************************************************************
  function public.DialogCharacterHide()

    cmn.StopAllVoc();

    local func_end = public.end_trigger;

    local current_room = common.GetObjectName( GetCurrentRoom() );
      
    interface.DialogCharacterHide();

    ObjSet( "obj_int_dialog_character_input", { input = false } );
   
    int.Lock(true);

    local func_event_done = function()

      public.InterfaceSetVisible( true );
     
      cmn.SetEventDone( "dlg_"..current_room.."_"..private.object_current );
      
      int.Lock(false); 

      local room = GetCurrentRoom();
--and room and _G[ room ][public.end_trigger]
      if public.end_trigger  then

        --_G[ room ][public.end_trigger]();
        func_end();

      else

        cmn.CallEventHandler( "dlg_"..current_room.."_"..private.object_current.."_end" );

      end;

      ObjDetach( "dlg_"..current_room.."_"..private.object_current );

      public.func_after_frase = false;
      public.max_number = nil;  
      private.dialog_count_txt = nil; 
      public.answer_text = nil;
     
    end;
    
    ObjAnimate( "dlg_"..current_room.."_"..private.object_current, "alp", 0, 0, func_event_done, { 0,0,1, 0.3,0,0 } );
   
    if public.dialog_character_loc ~= "" then
      ObjAnimate( public.dialog_character_loc, "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
    end;

      
  end;
  --******************************************************************************************
  function public.DialogCharacterStopAllVid()

      local current_room = common.GetObjectName( GetCurrentRoom() );
      local relations = ObjGetRelations( "obj_"..current_room.."_"..private.object_current.."_characters" );

      if relations.childs then

        for i = 1, #relations.childs do
          local relations_2 = ObjGetRelations( relations.childs[i] )
            for j = 1, #relations_2.childs do
                if common.GetObjectPrefix( relations_2.childs[j] ) == "vid" then
                  ObjSet( relations_2.childs[j], { alp = 0, playing = 0 } );
                end;
            end;
        end;
      end;

  end;
  --******************************************************************************************
  function public.DialogCharacterContinueClick( answer )

    if private.dialog_count_txt >= public.max_number then

      public.DialogCharacterHide();

    else

      public.DialogCharacterShow( private.object_current, public.max_number, nil, nil, public.func_after_frase, answer, public.end_trigger );

    end;

  end;
  --******************************************************************************************
  function public.DialogCharacterSkipClick()

   for i = 1, 3 do
    ObjSet( "spr_int_dialog_character_choise_"..i, { alp = 0, input = false } ); 
   end;
    
   public.DialogCharacterHide();
   public.DialogCharacterStopAllVid();

  end;
  --******************************************************************************************
  function public.DialogCharacterSetMax()

    private.dialog_count_txt = public.max_number;

  end;
  --******************************************************************************************
  function public.DialogCharacterSetCursor()

    cmn.SetCursor( CURSOR_NULL );

  end;
--*********************************************************************************************************************
--***function *** NOTE SCALE *** () end *******************************************************************************
--*********************************************************************************************************************
  function private.NoteScale ( source_name )

    local obj = common.GetObjectName( GetCurrentRoom() );

    local small_pic = source_name[1];
    local big_pic   = "spr_"..common.GetObjectName( small_pic ).."_big";

    local pos_array  = {};

    pos_array.start  = {};
    pos_array.finish = {};

    pos_array.finish.pos_x = 512;
    pos_array.finish.pos_y = 384;

    if ( ( common.IsInSubRoom() ) or ( int_deploy_inv.IsOnScreen() ) ) then

      pos_array.finish.pos_x = 0;
      pos_array.finish.pos_y = 0;

    end;

    pos_array.start.pos_x = ObjGet( small_pic ).pos_x;
    pos_array.start.pos_y = ObjGet( small_pic ).pos_y;

    private.PlayAudio( "sfx", "audio/aud_paper" );

    if ( not private.note[ obj ] ) then

      int.Lock( true );

      private.note.scale.pos_x = pos_array.start.pos_x;
      private.note.scale.pos_y = pos_array.start.pos_y;

      ObjAnimate( small_pic, "alp", 0, 0, "", 
      { 
        0.0, 0, 1, 
        0.3, 0, 0 
      } );

      ObjSet( big_pic, { alp = 1, input = true, inputrect_init = true, inputrect_x = -1000, inputrect_y = -1000, inputrect_w = 2000, inputrect_h = 2000 } );
      ObjAnimate( big_pic, "pos_xy", 0, 0, "", 
      { 
        0.0, 3, pos_array.start.pos_x,  pos_array.start.pos_y,
        0.3, 3, pos_array.finish.pos_x, pos_array.finish.pos_y 
      } );

      ObjAnimate( big_pic, "scale_xy", 0, 0,
                                            function ()

                                              private.NoteScaleEnd( source_name )

                                            end, 
      { 
        0.0, 3, 0, 0,
        0.3, 3, 1, 1 
      } );

    else

      int.Lock( true );

      ObjAnimate( small_pic, "alp", 0, 0, "", 
      { 
        0.0, 0, 0, 
        0.3, 0, 1 
      } );

      ObjAnimate( big_pic, "pos_xy", 0, 0, "", 
      { 
        0.0, 3, pos_array.finish.pos_x,   pos_array.finish.pos_y,
        0.3, 3, private.note.scale.pos_x, private.note.scale.pos_y
      } );

      ObjAnimate( big_pic, "scale_xy", 0, 0, 
                                            function ()

                                              private.NoteScaleEnd( source_name )

                                            end,
      {
        0.0, 3, 1, 1,
        0.3, 3, 0, 0
      } );

    end;

  end;
  --*********************************************************************************************************************
  function private.NoteScaleEnd ( source_name, close_zz )

    local small_pic = source_name[ 1 ];
    local big_pic   = "spr_"..common.GetObjectName( small_pic ).."_big";

    int.Lock( false );

    local obj = common.GetObjectName( GetCurrentRoom() );

    if ( not private.note[ obj ] and
         not close_zz ) then

      private.note[ obj ] = obj;
      ObjSet( big_pic, { input = true } );

    else

      private.note[ obj ] = nil;     

      for i = 1, #source_name do

        small_pic = source_name[ i ];
        big_pic   = small_pic.."_big";
        ObjSet( small_pic, { input = true, alp = 1 } );
        ObjSet( big_pic,   { input = false, alp = 0 } );

      end;

    end;

  end;
--*********************************************************************************************************************
--***function *** ITEMS *** () end ************************************************************************************
--*********************************************************************************************************************
  function public.UseItem ( funcs )

    for id, func in pairs( funcs ) do

      if ( func() ) then

        break;

      end;
      
    end;
    
  end;
  --*********************************************************************************************************************
  function private.ApplyObj ( item, area, check_inzz )

    if ( subroom_impl.subroom_anim ) then

      return false;

    end;
    
    local obj = common.GetObjectName( GetCurrentRoom() );

    local currentroom = GetCurrentRoom();

    if common.IsInSubRoom() then

      currentroom = common.GetCurrentSubRoom();

    end;

    if ( ApplyObj( item, area, currentroom ) ) and
       ( not int_deploy_inv.IsOnScreen() ) and  -- для сложного инвентаря
       ( not int_dialog_task.IsOnScreen() ) and  -- для тасков      
       ( not private.note[ obj ] ) then 

      return true;

    end;

    return false;

  end;
 --*********************************************************************************************************************
  function private.GetObjectSfx ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );
    
  end;
 --*********************************************************************************************************************
  function private.GetInvObjectSfx ()

    cmn.PlayAudio( "sfx", "audio/aud_take_inventory" );
    
  end;
--**************************************************************************************************************
--***function *** Text *** () end*******************************************************************************
--**************************************************************************************************************
  function public.PrintText ( obj, text_id, time, func_end )
    
    table.insert( private.print, { time = time or 3, text_id = text_id, obj = obj, func_end = func_end } );
    ObjCreate( "tmr_"..obj, "timer" );
    ObjSet( "tmr_"..obj, { input = false, disprawtext = true } );
    ObjAttach( "tmr_"..obj, obj );
    cmn.PlayAudio( "sfx", "audio/aud_type", 0 );
    private.ShowLetter( 1, private.print[ #private.print ] );

  end;
  ---------------------------------------------------------
  function private.ShowLetter ( number, print )

    number = tonumber( number );    
    local text = StringGet( print.text_id );
    local length = string.len( text );
    if ( number <= length ) then  

      local time = print.time / length;
      local text_sub = string.sub( text, 1, number );    
      ObjSet( print.obj, { text = text_sub } );    
      ObjSet( "tmr_"..print.obj, { 
        time = time,
        endtrig = function() private.ShowLetter( number + 1, print ); end, 
        playing = 1 } );    

    else

      public.ShowText( print.obj )

    end; 
   
  end;
  ---------------------------------------------------------
  function public.ShowText ( obj )

    local print = nil;
    for i = 1, #private.print do

      if ( obj == private.print[ i ].obj ) then

        print = private.print[ i ]; 
        table.remove( private.print, i );      
        break;

      end;

    end;

    if ( print ) then

      ObjDelete( "tmr_"..obj ); 
      cmn.StopAudio( "sfx", "audio/aud_type", 0 );
      if ( print.func_end ) then
        print.func_end();
      end;    
      ObjSet( obj, { text = print.text_id, disprawtext = false } );     

    end;

  end;
--*********************************************************************************************************************
--***function *** ACHIEVEMENTS *** () end*******************************************************************************
--*********************************************************************************************************************
  function private.AchievementsInit ()

    private.achievements = {};
    private.achievements.queue = {};
    private.achievements.show  = false;

    -- навание ачивки, за какое событие, кол-во выполненных событий, номер самолета
    private.achievements.LIST = 
    {
      { "not_skip_mg_1", "win_mg", 3,  16 },--прохождение мг без скипа 
      { "not_skip_mg_2", "win_mg", 5,  15 },
      { "not_skip_mg_3", "win_mg", 10, 19 },
      { "not_skip_mg_4", "win_mg", 33, 7 },

      --{ "not_skip_ho_1", "win_ho", 3,  12 },--прохождение хо без скипа
      { "common_actions", "common_actions", 1,  17 },
      { "excellent_mind", "", 1, 13 },
      { "wrong_use_knife", "", 1, 11 },    

      { "ho_three_1", "ho_3", 3,  8 },--прохождение 3-х ХО подряд, меньше чем за 3 минуты каждое    
      { "ho_three_2", "ho_3", 5,  1 },
      { "ho_three_3", "ho_3", 10, 5 },

      { "ho_three_obj_three", "", 1, 2 },--подбор 3-х объектов ХО за 3 секунды 
      { "ho_five_obj_five",   "", 1, 3 },
      { "ho_ten_obj_ten",     "", 1, 10 },

      { "ho_ten_min",     "", 1, 18 },--прохождение 1-го ХО больше чем за 10 минут    

      { "ho_one_min",     "", 1, 14 },--прохождение 1-го ХО меньше чем за 1 минуту   

      { "mg_one_min",     "", 1, 4 },--Прохождение 1-ой МГ меньше чем за 1 минуту

      { "get_collect_1",     "get_collect", 1,        9 }, --подбор первого collectibles
      { "get_collect_2",     "get_collect", 16,       6 },
      { "get_morph_collect", "get_morph_collect", 27, 20 }, --сбор всех морфингов

      { "ho_not_hint_3", "win_ho", 3, 21 }, --Прохождение 3 ХО без подсказки
      { "ho_not_hint_5", "win_ho", 5, 22 }, --Прохождение 5 ХО без подсказки
      { "ho_not_hint_10", "win_ho", 10, 23 }, --Прохождение 10 ХО без подсказки
      { "ho_not_hint_all", "win_ho", 13, 24 }, --Прохождение всех ХО без подсказки

      --{ "win_secret_1",   "", 1 },  --secret room, start
      { "win_secret_1",   "", 1, 25 },   --less than 12 min
      { "win_secret_2",   "", 1, 26 },   --less than 6 min
      { "win_secret_3",   "", 1, 27 },   --without hints
      { "win_secret_4",   "", 1, 12 }    --secret room win
    };

    ng_global.achievements                    = {};
    ng_global.achievements.previous_room      = "";
    ng_global.achievements.count              = {};
    ng_global.achievements.count.get_collect  = 0; 
    ng_global.achievements.count.get_glass    = 0; 
    ng_global.achievements.count.get_morph_collect    = 0;
    ng_global.achievements.count.win_mg       = 0;    
    ng_global.achievements.count.win_ho       = 0;
    ng_global.achievements.count.ho_3         = 0;-- сколько хо выигранно за 3 минуты

    for j = 1, #private.achievements.LIST  do

      local name_achiev = private.achievements.LIST[ j ][ 1 ];
      ng_global.achievements[ name_achiev ]      = {};
      ng_global.achievements[ name_achiev ].done = 0;

    end;

    ng_global.achievements.found = {};

    if ( not ObjGet( "tmr_int_achievement_give" ) ) then
      ObjCreate( "tmr_int_achievement_give", "timer" );
    end;

  end;
  --------------------------------------------------------
  function public.GetPosAchiev ( name )
    --позиция соответствует номеру совы
    for i = 1, #private.achievements.LIST do

      --if ( private.achievements.LIST[ i ][ 1 ] == name ) then
        return private.achievements.LIST[ i ][ 1 ];
      --end;

    end;
    return -1;
    
  end;
  --------------------------------------------------------
  function public.GetNameAchiev ( pos )
    --позиция соответствует номеру совы
    for i = 1, #private.achievements.LIST do

      if ( private.achievements.LIST[ i ][ 4 ] == pos ) then
        return private.achievements.LIST[ i ][ 1 ];
      end;

    end;
    return nil;
    
  end;
  --------------------------------------------------------
  function private.CheckAnimAchiev ()

    if ( not ( IsCollectorsEdition() or IsSurveyEdition() ) ) then
      return;
    end;

    ObjAttach( "tmr_int_achievement_give", "cmn_timers" );
    ObjSet("tmr_int_achievement_give", { playing = true, time = 0.5, endtrig = private.CheckAnimAchiev } );

    if ( not private.achievements.show ) then

      for i = 1, #private.achievements.queue do

        ng_global.achievements[ private.achievements.queue[ i ] ].done = 1;
        int_achievements.Show( private.achievements.queue[ i ] );
        table.remove( private.achievements.queue, i );
        break;

      end;

    end;

  end;
  --------------------------------------------------------
    -- получение нестандартных ачивок
  function public.CheckGiveCustomAchiev ( name )

    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      private.GiveAchiev( name );

    end;

  end;
  --------------------------------------------------------
  function private.GiveAchiev ( name )

    if ( not ( IsCollectorsEdition() or IsSurveyEdition() ) ) then
      return;
    end;

    if ( ng_global.achievements[ name ].done == 0 ) then

      local name_exist = false;
      for i = 1, #private.achievements.queue do

        if ( private.achievements.queue[ i ] == name ) then

          name_exist = true;
          break;
      
        end;

      end;

      if ( not name_exist ) then

        for i = 1, #private.achievements.queue do

          ng_global.achievements[ private.achievements.queue[ i ] ].done = 1;

        end;

        table.insert( private.achievements.queue, name );
        
        if ( not ObjGet( "tmr_int_achievement_give" ).playing ) then
        
          private.CheckAnimAchiev();

        end;

      end;

    end;

  end;
  --------------------------------------------------------
  -- определяем какую из "градационных" ачивок выдать
  function private.CheckGiveAchiev ( name )
     
    if ( not ( IsCollectorsEdition() or IsSurveyEdition() ) ) then
      return;
    end;

    local value_count = {};

    for i = 1, #private.achievements.LIST do

      local prg_name = private.achievements.LIST[ i ][ 2 ];
      if ( prg_name == name ) then

        table.insert( value_count, { private.achievements.LIST[ i ][ 1 ], private.achievements.LIST[ i ][ 3 ]} )

      end;

    end;
    
    for i = 1, #value_count do

      if ( ng_global.achievements.count[ name ] == value_count[ i ][ 2 ] ) then   
          
        private.GiveAchiev( value_count[ i ][ 1 ] );

      end;

    end;

  end;
  --------------------------------------------------------
  -- Увеличение счетчика собранных collectibles
  function public.CountGetCollect ()

    ng_global.achievements.count.get_collect = ng_global.achievements.count.get_collect + 1;
    private.CheckGiveAchiev( "get_collect" ); 
       
  end;
  --------------------------------------------------------
  function public.CountGetMorphCollect ()

    ng_global.achievements.count.get_morph_collect = ng_global.achievements.count.get_morph_collect + 1;
    private.CheckGiveAchiev( "get_morph_collect" ); 
       
  end;
  --------------------------------------------------------
  function private.CountWinMg ( minigame_name )

    local mg_name = minigame_name or common.GetObjectName( GetCurrentRoom() );

    if ( not ng_global.progress[ ng_global.currentprogress ][ "win_"..mg_name ].skip_clk ) then

      ng_global.achievements.count.win_mg = ng_global.achievements.count.win_mg + 1;
      private.CheckGiveAchiev( "win_mg" );
     
    end;
         
  end;
  --------------------------------------------------------
  function private.CountWinHo ()

    if ( not ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( GetCurrentRoom() ) ].hint_clk ) then

      ng_global.achievements.count.win_ho = ng_global.achievements.count.win_ho + 1;
      private.CheckGiveAchiev( "win_ho" );

    end;

  end;
  --------------------------------------------------------
--  function public.CountWinSecret ()
--     
--    if ( not ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( GetCurrentRoom() ) ].win ) then
--
--      ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( GetCurrentRoom() ) ].win = true;
--      ng_global.achievements.count.win_secret = ng_global.achievements.count.win_secret + 1;
--      private.CheckGiveAchiev( "win_secret" );
--
--    end;
--
--  end;
  --------------------------------------------------------
  ------запускаем секундомер для каждой мг
  function public.PassingMgStart ( minigame_name )
    
    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      local mg_room   = GetCurrentRoom();
      local mg_name   = minigame_name or common.GetObjectName( mg_room );
      local tmr_name  = "tmr_achiev_"..mg_name;
      
      if ( not ObjGet( tmr_name ) ) then   

        ObjCreate( tmr_name, "timer" );
        ObjAttach( tmr_name, mg_room );

        local time_passing = ng_global.progress[ ng_global.currentprogress ][ "win_"..mg_name ].time_passing or 0;
        ng_global.progress[ ng_global.currentprogress ][ "win_"..mg_name ].time_passing = time_passing;  

        ObjSet( tmr_name, { playing = true, time = time_passing, infinite = true } );

      else    

        ObjSet( tmr_name, { playing = true } );

      end;

    end;

  end;
  --------------------------------------------------------
  ------проверяем получили ли мы за мг ачивку
  function public.PassingMgWin ( minigame_name )

    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      --cmn.PlayAudio( "sfx", "audio/aud_mg_win");   

      local mg_name = minigame_name or private.current_mg_name; 
      private.CountWinMg( mg_name );
      port.LogEvent("win_"..mg_name, "close", 1);
      
      local max_time = 60;
      local tmr_name = "tmr_achiev_"..mg_name;
      if ObjGet( tmr_name ) then
        local time = ObjGet( tmr_name ).time;      

        if ( time <= max_time ) and ( not ng_global.progress[ ng_global.currentprogress ][ "win_"..mg_name ].skip_clk ) then   
            
          private.GiveAchiev( "mg_one_min" );
            
        end;

        ObjDelete( tmr_name );
      end;
    end;

  end;
  --------------------------------------------------------
  ------стопаем секундомер для каждой мг при выходе из мг
  function public.PassingMgStop ( minigame_name )

    
    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      local mg_name = minigame_name or common.GetObjectName( GetCurrentRoom() );
      port.LogEvent("win_"..mg_name, "close", 0);
    
      local tmr_name = "tmr_achiev_"..mg_name;  

      if ( ObjGet( tmr_name ) ) then

        ng_global.progress[ ng_global.currentprogress ][ "win_"..mg_name ].time_passing = ObjGet( tmr_name ).time;
        ObjSet( tmr_name, { playing = false } );

      end;
    
    end;

  end;
  --------------------------------------------------------
  ------запускаем секундомер для каждой хо
  function public.PassingHoStart ()  

    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      local ho_room   = GetCurrentRoom();
      local ho_name   = common.GetObjectName( ho_room );
      local tmr_name  = "tmr_achiev_"..ho_name;

      if ( not ObjGet( tmr_name ) ) then 
     
        ObjCreate( tmr_name, "timer" );
        ObjAttach( tmr_name, ho_room );

        private.achievements[ "count_"..ho_room ] = 0;
        local time_passing = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].time_passing or 0;        
        ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].time_passing = time_passing;

        ObjSet( tmr_name, { playing = true, time = time_passing, infinite = true } );

      else    

        ObjSet( tmr_name, { playing = true } );

      end;

    end;

  end;
  --------------------------------------------------------
  ------стопаем секундомер для каждой хо при выходе из хо
  function public.PassingHoStop ()

    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      local ho_name = common.GetObjectName( GetCurrentRoom() );
      local tmr_name = "tmr_achiev_"..ho_name;  

      if ( ObjGet( tmr_name ) ) then

        ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].time_passing = ObjGet( tmr_name ).time;
        ObjSet( tmr_name, { playing = false } );  

      end;
    
    end;

  end;
  --------------------------------------------------------
  ------ проверка на получение ачивки при подборе объектов в хо
  function public.PassingHoCheck ()

    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      private.PassingHoGet();--создаем таймер
      private.PassingHoGetCheck( 3, "ho_three_obj_three" );-- проверяем на получение 3 ачивок
      private.PassingHoGetCheck( 5, "ho_five_obj_five" );
      private.PassingHoGetCheck( 10, "ho_ten_obj_ten" );

    end;

  end;
  --------------------------------------------------------
  ------проверяем прошли ли мы хо меньше чем за 3 минуты
  function public.PassingHoWin ()

    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      private.CountWinHo();

      local ho_name = common.GetObjectName( GetCurrentRoom() );
     
      local max_time    = 3 * 60;   --прохождение хо за 3 мин
      local max_time_2  = 10 * 60;  --прохождение хо больше чем за 10 мин 
      local max_time_3  = 60;       --прохождение хо меньше чем за 10 мин 
      local tmr_name    = "tmr_achiev_"..ho_name;
      
      local time = ObjGet( tmr_name ).time;      

      --прохождение хо за 3 мин
      if ( time <= max_time ) then

        ng_global.achievements.count.ho_3 = ng_global.achievements.count.ho_3 + 1;           
        private.CheckGiveAchiev( "ho_3" );

      else 
        
        ng_global.achievements.count.ho_3 = 0;

      end;

      --прохождение хо больше чем за 10 мин 
      if time > max_time_2 then        
        
        private.GiveAchiev( "ho_ten_min" );
        
      end;

      --прохождение хо меньше чем за 1 мин 
      if time < max_time_3 then

        private.GiveAchiev( "ho_one_min" );

      end;
      ObjDelete( tmr_name );

    end;

  end;
  --------------------------------------------------------
  ------подбор 3-х объектов ХО за 3 секунды    
  function private.PassingHoGet ()

    if ( not ( IsCollectorsEdition() or IsSurveyEdition() ) ) then
      return;
    end;

    local ho_room   = GetCurrentRoom();
    local ho_name   = common.GetObjectName( ho_room );
    local tmr_name  = "tmr_achiev_"..ho_name.."_"..private.achievements[ "count_"..ho_room ]; 

    if ( not ObjGet( tmr_name ) ) then
    
      ObjCreate( tmr_name, "timer" );
      ObjAttach( tmr_name, ho_room );
      
    end; 

    private.achievements[ "count_"..ho_room ] = private.achievements[ "count_"..ho_room ] + 1;
    ObjSet( tmr_name, { playing = true, time = time_passing, infinite = true } );  

  end;
  --------------------------------------------------------
  ------подбор 3-х объектов ХО за 3 секунды   проверка на получение ачивки 
  function private.PassingHoGetCheck ( count_ho_obj, name_achiev )

    if ( not ( IsCollectorsEdition() or IsSurveyEdition() ) ) then
      return;
    end;

    local ho_room = GetCurrentRoom();
    local ho_name = common.GetObjectName( ho_room );

    if ( ng_global.achievements[ name_achiev ].done == 0 ) then
      
      if ( count_ho_obj <= private.achievements[ "count_"..ho_room ] ) then
      
        local tmr_name_prev = "tmr_achiev_"..ho_name.."_"..( private.achievements[ "count_"..ho_room ] - count_ho_obj ); 
      
        if ( count_ho_obj == private.achievements[ "count_"..ho_room ] ) then
            
          if ( ObjGet( "tmr_achiev_"..ho_name ).time <= count_ho_obj ) then

            private.GiveAchiev( name_achiev );

          end;
        
        elseif ( ObjGet( tmr_name_prev ).time <= count_ho_obj ) then  
          
          private.GiveAchiev( name_achiev ); 

        end;

      end;

    end;  

  end;
  --------------------------------------------------------
  function private.Story ( name )

    if ( not ( IsCollectorsEdition() or IsSurveyEdition() ) ) then
      return;
    end;

    for i = 1, #private.achievements.LIST do

      local prg_name    = private.achievements.LIST[ i ][ 2 ];
      local achiev_name = private.achievements.LIST[ i ][ 1 ];

      if ( prg_name == name ) then

        private.GiveAchiev( achiev_name ); 

      end;

    end; 

  end;
  --------------------------------------------------------
  function public.Check ( name )

    if ( not ( IsCollectorsEdition() or IsSurveyEdition() ) ) then
      return;
    end;

    if ( string.find( name, "get_" ) ) then 

      --

    elseif ( string.find( name, "win_" ) ) then

      local type_room = cmn.GetObjectPrefix( GetCurrentRoom() );          
      if ( type_room == "ho" ) then

        private.CountWinHo();
        public.PassingHoWin();

      end;

    elseif ( private.CheckStory( name ) ) then
        
      private.Story( name );    

    end;

  end;
  --------------------------------------------------------
  function private.CheckStory ( name )

    if ( not ( IsCollectorsEdition() or IsSurveyEdition() ) ) then
      return;
    end;

    local find = false;
    
    for i = 1, #private.achievements.LIST do

        local prg_name = private.achievements.LIST[ i ][ 2 ];

        if ( string.find( prg_name, name ) ) then

          find = true;
          break;

        end;

    end;

    if ( find ) then

      return true;

    end;

    return false;

  end;
  --------------------------------------------------------
  ------проверяем получили ли мы за secret room ачивку
  function public.PassingSecretWin ()

    if ( not ( IsCollectorsEdition() or IsSurveyEdition() ) ) then
      return;
    end;

    --ld.PlayAudio( "sfx", "common/audio/aud_mg_win", 0 );

    private.GiveAchiev( "win_secret_4" ); 
    if ( ng_global.progress[ "scr" ].common.btntimer < 720 ) then
      private.GiveAchiev( "win_secret_1" );
    end;

    if ( ng_global.progress[ "scr" ].common.btntimer < 360 ) then
      private.GiveAchiev( "win_secret_2" );
    end;

    if ( not ng_global.progress[ "scr" ][ "win_secret" ].hint_clk ) then
      private.GiveAchiev( "win_secret_3" );
    end;

  end;
--*********************************************************************************************************************
--***function *** DIARY *** () end*******************************************************************************
--*********************************************************************************************************************
  function private.AddPageDiary ( name_page )

    local prg = ng_global.currentprogress;
    local num = tonumber( name_page );

    ng_global.progress[ prg ].common.diary.last_page = ng_global.progress[ prg ].common.diary.last_page + 1;
    ng_global.progress[ prg ].common.diary.current = math.ceil( ng_global.progress[ prg ].common.diary.last_page / 2 );
    ng_global.progress[ prg ].common.diary.pages[ ng_global.progress[ prg ].common.diary.last_page ] = num;
    ng_global.progress[ prg ].common.diary.show = true;

    local alp_open  = ObjGet( "spr_int_button_map_diary_opened" ).alp;
    local alp_close = ObjGet( "spr_int_button_map_diary_closed" ).alp;

    local func_end = function ()

      VidStop( "vid_int_button_map_diary_letter" );

      ObjSet( "vid_int_button_map_diary_letter", { alp = 0 } );
      ObjSet( "pfx_int_button_map_diary_focus",  { alp = 1 } );

    end;

    ObjAnimate( "spr_int_button_map_diary_opened", "alp", 0, 0, "", 
    { 
      0.0, 0, alp_open,
      0.3, 0, alp_open, 
      0.6, 0, 1 
    } );

    ObjAnimate( "spr_int_button_map_diary_closed", "alp", 0, 0, "", 
    { 
      0.0, 0, alp_close, 
      0.5, 0, alp_close,
      0.7, 0, 0 
    } );

    ObjAnimate( "pfx_int_button_map_diary_focus", "alp", 0, 0, "", 
    { 
      0.0, 0, alp_open, 
      1.0, 0, alp_open,
      2.0, 0, 1
    } );
         
    ObjSet( "vid_int_button_map_diary_letter", { alp = 1 } );
    VidPlay( "vid_int_button_map_diary_letter", func_end );

  end;
--**************************************************************************************************************
--***function  CUSTOM GFX  () end*************************************************************
--***************************************************************************************************************
  function private.GetAllGfx( mas_obj, table_gfx )
   
   local func_get_gfx;

    func_get_gfx = function ( obj )
    
      local rel = ObjGetRelations( obj ).childs;

       if rel ~= nil then

         for i = 1, #rel do

           if common.GetObjectPrefix( rel[i] ) == "gfx" then

             table.insert( table_gfx, rel[i] );

          end;

           func_get_gfx( rel[i] );

         end;

       end;

    end;
    
    for i = 1, #mas_obj do
      
      func_get_gfx( mas_obj[i] );

    end;

  end;
  --***************************************************************************************************************
  function private.TurnMasGfx( table_gfx, state )

    local table_multiset = {};
    
    if ( state ) then

      for i = 1, #table_gfx do

        --table.insert( table_multiset, { table_gfx[i], { res = "assets/levels/common/fx/sparkle_effect" } } );
        table.insert( table_multiset, { table_gfx[i], { visible = true } } );

      end;
    
    else

      for i = 1, #table_gfx do

        --table.insert( table_multiset, { table_gfx[i], { res = "assets/levels/common/fx/sparkle_empty" } } );
        table.insert( table_multiset, { table_gfx[i], { visible = false } } );

      end;  
      
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;
    
  end;
  --***************************************************************************************************************
  function public.TurnChildGfx( mas_parent, rm_name, state )

    if not public[rm_name] then 

      public[rm_name] = {};

    end;
    
    if not public[rm_name].AllGfx then 

      public[rm_name].AllGfx = {};
      private.GetAllGfx( mas_parent, public[rm_name].AllGfx );

    end;

    private.TurnMasGfx( public[rm_name].AllGfx, state );

  end;
--*********************************************************************************************************************  
--*********************************************************************************************************************
--*********************************************************************************************************************
--***function *** SECRETROOM *** () end*********************************************************************
--*********************************************************************************************************************
  function private.SecretroomInit ()

    private.final_stage = "cards_of_destiny";

    if ( not ng_global.secret ) then

      ng_global.secret = {};
      ng_global.secret.game = false;
      ng_global.secret.best_time = 0;
      ng_global.secret.achiev = { -- глобально считает, может лт пользователь получить ачивку
        [ "win_scr" ]         = false,
        [ "less_12minutes" ]  = false,
        [ "less_6minutes" ]   = false,
        [ "no_hint" ]         = false,
      };
  
      public.ResetSecretroom();

    end;
    
  end;
  ---------------------------------------------------------
  function public.ResetSecretroom ()

    ng_global.secret.curr_time = 0;
    ng_global.secret.curren_task = ""
    ng_global.secret.curren_object = ""

    ng_global.secret.achiev_temp = { -- анализирует всё во время игровой ссесии
      [ "win_scr" ]           = true,
      [ "less_12minutes" ]    = true,
      [ "less_6minutes" ]     = true,
      [ "no_hint" ]           = true,
    };

    ng_global.secret.location = {
      [ "rm_waitinghall_scr" ]         = {},
      [ "rm_window_scr" ]              = {},
      [ "rm_technicalroom_scr" ]       = {},
      [ "rm_secondfloorcorridor_scr" ] = {},
      [ "rm_aircompaniesstand_scr" ]   = {},
    };  

    for key, value in pairs( ng_global.secret.location ) do

      private.SecretroomhAddPrg( ng_global.secret.location[ key ], "roses",             1 );
      private.SecretroomhAddPrg( ng_global.secret.location[ key ], "knives",            2 );
      private.SecretroomhAddPrg( ng_global.secret.location[ key ], "fire",              3 );
      private.SecretroomhAddPrg( ng_global.secret.location[ key ], "planes",            4 );
      private.SecretroomhAddPrg( ng_global.secret.location[ key ], "cursed_tickets",    5 );
      private.SecretroomhAddPrg( ng_global.secret.location[ key ], "cards_of_destiny",  2 );

    end;

  end;
  ---------------------------------------------------------
  function private.SecretroomhAddPrg ( table_progress, obj, quantity )

    local table_bool = {};
    for i = 1, quantity do

      table.insert( table_bool, false );

    end;  
    table_progress[ obj ] = table_bool

  end;
  ---------------------------------------------------------
  function private.MakeSecretHint ( room, task )

    local oblect_name = "";
    for i = 1, #ng_global.secret.location[ room ][ task ] do  

      if ( private.IsTaskIndexDone( room, task, i ) == false ) then
        
        local room_no_prefix = string.sub( room, 4, string.len( room ) );
        oblect_name = "spr_"..room_no_prefix.."_"..task.."_"..i;
        break;        

      end;

    end;  

    if ( oblect_name == "" ) then

      local all_rooms = { "rm_waitinghall_scr", "rm_window_scr", "rm_technicalroom_scr", "rm_secondfloorcorridor_scr", "rm_aircompaniesstand_scr" };
      for i = 1, #all_rooms do

        if ( all_rooms[ i ] ~= room ) then
          
          for j = 1, #ng_global.secret.location[ all_rooms[ i ] ][ task ] do

            if ( not ng_global.secret.location[ all_rooms[ i ] ][ task ][ j ] ) then
              
              room = all_rooms[ i ];
              local room_no_prefix = string.sub( all_rooms[ i ], 4, string.len( all_rooms[ i ] ) );
              oblect_name = "spr_"..room_no_prefix.."_"..task.."_"..j;
              break;
              
            end;        

          end;      

        end;
        if ( oblect_name ~= "" ) then

          break;

        end;

      end;

    end;
    
    ng_global.secret.curren_object = oblect_name;
    common_impl.hint[ "get_"..task.."_scr" ] = {
    type = "get_scr",
      get_obj = oblect_name,
      room = room,
    };    

  end
  ---------------------------------------------------------
  function public.DefaultMorphItemSecret ()
    
    for key, value in pairs( ng_global.secret.location ) do

      for key_t, value_t in pairs( ng_global.secret.location[ key ] ) do

        for i = 1, #ng_global.secret.location[ key ][ key_t ] do

          local room_no_prefix = string.sub( key, 4, string.len( key ) );
          local object_name = "spr_"..room_no_prefix.."_"..key_t.."_"..i;
          ObjMultiSet( {
            { object_name,            { alp = 0, input = false } },
            { object_name.."_morph",  { alp = 1 } },
          } );

        end;

      end;

    end;
    int_taskpanel_scr.UpdateAchievpanel();
    int_taskpanel_scr.UpdateProgressPanel();
    
  end;
  ---------------------------------------------------------
  function public.StartMorhpTask ()

    local task = ng_global.secret.curren_task;
    if ( not cmn.IsEventStart( "get_"..task.."_scr" ) ) then

      int_dialog_scr.ShowAnim( task );

    else 

      local pages = ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.pages;

      public.SrartMorphItemSecret();

      if ( not ng_global.secret.game ) then

        ng_global.secret.game = true;
        int_timer_scr.StartTimer();
        int_morph_scr.Show();
        int_taskpanel_scr.UpdateProgressPanel();

      end; 

    end;

  end;
  ---------------------------------------------------------
  function public.SrartMorphItemSecret ()
--common.DialogWindowShow( "common", "winsecrteroom" );
    local room = GetCurrentRoom();
    local task = ng_global.secret.curren_task;

    private.MakeSecretHint( room, task );

    int_morph_scr.UpdateTaskIcon( task );
    int_morph_scr.SetTaskCount( task );

    for i = 1, #ng_global.secret.location[ room ][ task ] do

      if ( not private.IsTaskIndexDone( room, task, i ) ) then

        local room_no_prefix = string.sub( GetCurrentRoom(), 4, string.len( GetCurrentRoom() ) );
        local object_name = "spr_"..room_no_prefix.."_"..task.."_"..i;
        private.MorphItemMorphingSecret( object_name );

      end;

    end;

  end;
  ---------------------------------------------------------
  function public.SecretroomhAddObj ( room, obj, quantity )
  
    local room_no_prefix = string.sub( room, 4, string.len( room ) );
    table_multiset = {};

    for i = 1, quantity do

      object_name = "spr_"..room_no_prefix.."_"..obj.."_"..i;
      table.insert( table_multiset, { object_name, {
          input = false,
          alp = 0,
          event_mdown   = function() private.GetSecretMorph( room, obj, i ) end;
          event_menter  = function() SetCursor( CURSOR_GET ) end;
          event_mleave  = function() SetCursor( CURSOR_DEFAULT ) end;
        }
      } );

    end;  
  
    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;
  ---------------------------------------------------------
  function private.IsTaskIndexDone ( room, task, id )

    return ng_global.secret.location[ room ][ task ][ id ];

  end;
  ---------------------------------------------------------
  function private.SetDoneSecretMorph ( room, task, id )

    ng_global.secret.location[ room ][ task ][ id ] = true;
    local room_no_prefix = string.sub( room, 4, string.len( room ) );

    if ( task ~= private.final_stage ) then

      ObjDelete( "obj_"..room_no_prefix.."_"..task.."_"..id );
      ObjDelete( "spr_"..room_no_prefix.."_"..task.."_"..id );
      ObjDelete( "spr_"..room_no_prefix.."_"..task.."_"..id.."_morph" );

    end;

  end;
  ---------------------------------------------------------
  function private.StartLastStage ()

    local all_rooms = { "rm_waitinghall_scr", "rm_window_scr", "rm_technicalroom_scr", "rm_secondfloorcorridor_scr", "rm_aircompaniesstand_scr" };
    local index_room = math.random( #all_rooms );
    local task = ng_global.secret.curren_task;
    local index_task = math.random( #ng_global.secret.location[ all_rooms[ index_room ] ][ task ] );
    
    ng_global.secret.curren_object = "spr_"..all_rooms[ index_room ].."_"..task.."_"..index_task;

    for i = 1, #all_rooms do

      for j = 1, #ng_global.secret.location[ all_rooms[ i ] ][ task ] do

        if ( all_rooms[ i ] == all_rooms[ index_room ] and j == index_task ) then

        else

          private.SetDoneSecretMorph( all_rooms[ i ], task, j );
    
        end;

      end;

    end;

  end  
  ---------------------------------------------------------
  function private.ChangeStage ()  

    local pages = ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.pages;
    if ( ng_global.progress[ "scr" ][ "see_tutorial_scr" ].done == 0 and 
      pages[ "tutorial_page_6_scr" ][ "shown" ] == 0 ) then

      common_impl.TutorialShow( "tutorial_page_6_scr" );

    else 

      public.MorphingSecretLoad();

      if ( ng_global.secret.curren_task == private.final_stage ) then

        private.StartLastStage();
        cmn.StartMorhpTask();

      else

        cmn.StartMorhpTask();

      end;

    end;

  end;
  ---------------------------------------------------------
  function private.GetSecretMorph ( room, task, id )

    local room_no_prefix = string.sub( room, 4, string.len( room ) );
    local func_end = function ()

      private.SetDoneSecretMorph( room, task, id );   
 
      int_morph_scr.UpdateTaskIcon( task );
      int_morph_scr.SetTaskCount( task );
      int_taskpanel_scr.UpdateProgressPanel();

      if ( private.CheckSecretMorphStage( task ) ) then

        cmn.SetEventDone( "get_"..task.."_scr" );
        int_taskpanel_scr.UpdateProgressPanel();
        if ( task == private.final_stage ) then

          private.WinSecretRoom();

        else

          private.ChangeStage();

        end;

      else 
    
        private.MakeSecretHint( room, task );

      end;
      
    end;

    local pages = ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.pages;
    if ( pages[ "tutorial_page_5_scr" ][ "shown" ] == 0 ) then

      common_impl.TutorialShow( "tutorial_page_5_scr" );

    end;

    cmn.PlayAudio( "sfx", "audio/aud_hide_sfx", 0, "", 0 );

    object_name = "spr_"..room_no_prefix.."_"..task.."_"..id;
    ObjStopAnimate( object_name, "alp" );
    ObjStopAnimate( object_name.."_morph", "alp" );
    public.PlayEffectHO( object_name, func_end );

  end;
  ---------------------------------------------------------
  function private.CheckSecretMorphStage ( task )

    for key, value in pairs( ng_global.secret.location ) do

      for i = 1, #ng_global.secret.location[ key ][ task ] do

        if ( not ng_global.secret.location[ key ][ task ][ i ] ) then

          return false;

        end;

      end;

    end;
    return true;

  end;
  ---------------------------------------------------------
  function private.MorphItemMorphingSecret ( object_name )

    local tim = 0.5;
    local func_end = function ()

      local func_end_1 = function ()

        ObjMultiSet( {
          { object_name,            { alp = 1, input = false } },
          { object_name.."_morph",  { alp = 0, input = false } },
        } );

        ObjAnimate( object_name, "alp", 0, 0, "", { 
            0.0,  0, 1,
            tim,  0, 0,   
        } );
        ObjAnimate( object_name.."_morph", "alp", 0, 0, function() private.MorphItemMorphingSecret ( object_name ) end, { 
            0.0,  0, 0,
            tim,  0, 1,    
        } );

      end;

      ObjMultiSet( {
        { object_name,            { alp = 1, input = true } },
        { object_name.."_morph",  { alp = 0, input = false } },
      } );
      local tm2 = (math.random( 15, 30 )) / 10; 
      ObjAnimate( object_name, "alp", 0, 0, "", { 
          0.0,        0, 1,
          tm2,        0, 1, 
      } );
      ObjAnimate( object_name.."_morph", "alp", 0, 0, func_end_1, { 
          0.0,        0, 0,
          tm2,        0, 0, 
      } );

    end;

    if ( ObjGet( object_name ) ) then --проверка на существования объекта

      ObjMultiSet( {
        { object_name,            { alp = 0, input = false } },
        { object_name.."_morph",  { alp = 1 } },
      } );
      local tm1 = (math.random( 15, 30 )) / 10;
      ObjAnimate( object_name, "alp", 0, 0, "", { 
          0.0,        0, 0,
          tm1,        0, 0, 
          tm1 + tim,  0, 1,    
      } );
      ObjAnimate( object_name.."_morph", "alp", 0, 0, func_end, { 
          0.0,        0, 1,
          tm1,        0, 1, 
          tm1 + tim,  0, 0,    
      } );

    end;

  end;
  ---------------------------------------------------------
  function private.DeleteMorphSecretDone ( task )

    for key, value in pairs( ng_global.secret.location ) do

      for i = 1, #ng_global.secret.location[ key ][ task ] do

        if ( private.IsTaskIndexDone( key, task, i ) ) then

          private.SetDoneSecretMorph( key, task, i );

        end;

      end;

    end;

  end;
  ---------------------------------------------------------
  function public.MorphingSecretLoad ()

    local progress = { "roses", "knives", "fire", "planes", "cursed_tickets", private.final_stage };

    for i = 1, #progress do

      if ( not cmn.IsEventDone( "get_"..progress[ i ].."_scr" ) ) then

        ng_global.secret.curren_task = progress[ i ];
        private.DeleteMorphSecretDone( progress[ i ] );
        break;

      else

        private.DeleteMorphSecretDone( progress[ i ] );

      end;

    end;

  end;
  ---------------------------------------------------------
  function private.WinSecretRoom ()

    for key, value in pairs( ng_global.secret.achiev ) do

      if ( not ng_global.secret.achiev[ key ] ) then

        ng_global.secret.achiev[ key ] = ng_global.secret.achiev_temp[ key ];

      end;

    end;

    if ( ng_global.secret.curr_time < ng_global.secret.best_time or 
      ng_global.secret.best_time == 0 ) then

      ng_global.secret.best_time = ng_global.secret.curr_time;

    end;
    local time = math.floor ( ng_global.secret.curr_time );

    local hours = math.floor(time / 3600);
    local minuts = math.floor(((time - hours * 3600)/60));
    local seconds = math.ceil(time - hours*3600 - minuts*60 );
    local str_time = hours..":"..minuts..":"..seconds;

    local time_b = math.floor ( ng_global.secret.best_time );

    local hours_b = math.floor(time_b / 3600);
    local minuts_b = math.floor(((time_b - hours_b * 3600)/60));
    local seconds_b = math.ceil(time_b - hours_b*3600 - minuts_b*60 );
    local str_time_b = hours_b..":"..minuts_b..":"..seconds_b;

    ObjSet( "txt_dialog_common", {
      param0 = str_time,
      param1 = str_time_b,
    }  );

    int_timer_scr.PauseTimer(); -- ставим на паузу таймер
    int_morph_scr.Hide();

    cmn.CheckGiveCustomAchiev( "win_secret_4" );

    ng_global.progress[ "scr" ].common.gamewin   = true; 
    ng_global.progress[ "scr" ].common.gamestart = false;

    common.DialogWindowShow( "common", "finishsecretroom" );

  end;
  
  
--*********************************************************************************************************************
--***function *** IOS_function *** () end******************************************************************************
--*********************************************************************************************************************

  ObjAttach( "obj_port_tap_down"       ,"ng_level" );
  ObjAttach( "tmr_port_tap_down"       ,"ng_level" );
  ObjAttach( "tmr_common_forbidscale"  ,"ng_level" );
  ObjAttach( "tmr_common_logevent"  ,"ng_level" );

  port = {};
  port.ios = {};
  port.android = {};
  
  ---------------------------------
  -----| Это читор для АйОсь |-----
  ---------------------------------
  
  --ModLoad( "assets/levels/common/cheater_ios/mod_cheater_ios" );
  --cheater_ios.Init();
  
  ---------------------------------
  ---------------------------------
  ---------------------------------
  --
  function port.isPortable()

    local isPortable = 1;
    --включение и выкл. ios & android режима

    if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
      isPortable = 1;
    end;

    return isPortable;

  end;
---------------------------------

  function port.isTablet()

    local isTablet = 0;
    if IsIpad() == true then  
      isTablet = 1;
    else
      isTablet = 0;
    end;

    
    return isTablet;

  end;


-------------------------------------------------------------
   port.lang_array = {
    "en",
    "ja",
    "ru",
    "de",
    "fr"
  };
-------------------------------------------------------------
  function port.ios_lang()

    local lang = "ja";
    
    if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
      lang = iOS_GetLang();
    end;
    
    local check = false;
    
    for i=1,#port.lang_array do
      if lang == port.lang_array[i] then check = true; break; end;
    end;
    
    if check ~= true then
      lang = "en";
    end;
    
    return lang;
  end;

-------------------------------------------------------------
  function port.TapDownTimer(tmr,funcEnd)

    local timer = tmr; 
    if timer == "" then
      timer = 0.7
    end;
    ObjSet( "obj_port_tap_down", { input = 1 } );
    ObjSet( "tmr_port_tap_down", { time = timer, playing = 1, 
      endtrig = function() 
        ObjSet( "obj_port_tap_down", { input = 0 } ); 
        funcEnd(); 
      end  
    } );

  end;


  function port.TapDown(tmr)

    local timer = tmr; 
    if timer == "" then
      timer = 0.7
    end;
    ObjSet( "obj_port_tap_down", { input = 1 } );
    ObjSet( "tmr_port_tap_down", { time = timer, playing = 1, endtrig = function() port.TapDownEnd(); end  } );

  end;
------------------------------------------------------------

  function port.TapDownEnd()

    ObjSet( "obj_port_tap_down", { input = 0 } );

  end;

--------------------------------------------------------------
  port.list_video_resize =
  {
   { "dialog_task"     ,{ "vid_int_dialog_task_hourlass", "1"} }
  ,{ "abandonedfarm"     ,{ "vid_tent_scorpio_spray", "1"} ,{ "vid_abandonedfarm_fire", "1"} ,{ "vid_abandonedfarm_fire_02", "1"} ,{ "vid_abandonedfarm_bat", "1"} }
  ,{ "bygrayscar"     ,{ "vid_bygrayscar_survey_1", "1.334"} ,{ "vid_bygrayscar_present_transfer", "1.334"} ,{ "vid_bygrayscar_bike", "1.334"} ,{ "vid_wheels_wheels_1", "1"} ,{ "vid_wheels_wheels_2", "1"} }
  ,{ "bypolicestation"     ,{ "vid_bypolicestation_intro", "1.334"} }
  ,{ "carrepairshop"     ,{ "vid_carrepairshop_atropos_appearance", "1.334"} ,{ "vid_carrepairshop_collapse", "1.334"} ,{ "vid_workdesk_use_lever", "1"} }
  ,{ "policestation"     ,{ "vid_policestation_past_transfer", "1.334"} ,{ "vid_policestation_outro", "1.334"} }
  ,{ "townoutskirts"     ,{ "vid_townoutskirts_survey_2", "1.334"} ,{ "vid_townoutskirts_scare", "1.334"} ,{ "vid_townoutskirts_carjack", "1.334"} ,{ "vid_policewindow_use_mallet", "1"} ,{ "vid_policecar_screw", "1"} }
  ,{ "track"     ,{ "vid_track_fire", "1.334"} ,{ "vid_burningroad_fire", "1"} ,{ "vid_burningroad_extinguisher", "1"} ,{ "vid_pileofhay_flamingfirebrand", "1"} ,{ "vid_pileofhay_flamingfirebrand_add", "1"} ,{ "vid_pileofhay_flamingfirebrand_add", "1"} }
  ,{ "darkness"     ,{ "vid_darkness_atropos_disappear", "1.334"} ,{ "vid_darkness_use_lighter", "1.33"} }
  ,{ "repair"     ,{ "vid_repair_present_transfer", "1.334"} }
  ,{ "basement"     ,{ "vid_firestand_use_hammer", "1"} }
  ,{ "livingroom"     ,{ "vid_livingroom_survey_1", "1.334"} ,{ "vid_livingroom_inyard", "1.334"} }
  ,{ "policestation2"     ,{ "vid_policestation2_past_transfer", "1.334"} }
  ,{ "switchroom"     ,{ "vid_switchroom_fire_beginning", "1.334"} ,{ "vid_switchroom_fire_beginning", "1.334"} ,{ "vid_panelboard_use_insulatingtape", "1"} ,{ "vid_switchroom_sandbucket", "1"} ,{ "vid_switchroom_fire", "1"} ,{ "vid_switchroom_smoke_add", "1"} }
  ,{ "yard"     ,{ "vid_yard_survey_2", "1.334"} ,{ "vid_yard_atropos_appearance", "1.334"} }
  ,{ "worriedmessage"     ,{ "vid_worriedmessage_outro", "1.334"} }
  ,{ "aircompaniesstand"     ,{ "vid_secondfloordoor_use_gun", "1"} }
  ,{ "controltower"     ,{ "vid_controltower_atropos_appearance", "1.334"} }
  ,{ "policestation3"     ,{ "vid_policestation3_past_transfer", "1.334"} }
  ,{ "secondfloorcorridor"     ,{ "vid_secondfloorcorridor_closing_door", "1.334"} }
  ,{ "waitinghall"     ,{ "vid_waitinghall_scare_3_1", "1.334"} ,{ "vid_waitinghall_survey_1", "1.334"} }
  ,{ "mgfate"     ,{ "vid_mgfate_outro", "1.334"} }
  ,{ "basementext"     ,{ "vid_picture_disappear", "1"} }
  ,{ "farm"     ,{ "vid_hollow_web_destruction", "1"} ,{ "vid_skeleton_fire_add", "1"} ,{ "vid_farm_fire", "1"} }
  ,{ "flightdeck"     ,{ "vid_flightdeck_crash", "1.334"} ,{ "vid_firstaidkit_use_wrenchext", "1"} }
  ,{ "kitchenext"     ,{ "vid_kitchenext_portal", "1"} ,{ "vid_kitchenext_transfer", "1.34"} }
  ,{ "livingroomext"     ,{ "vid_deskext_use_tuningfork", "1"} ,{ "vid_livingroom_lava", "1"} ,{ "vid_livingroom_kitchendoorext_combustion", "1"} ,{ "vid_livingroom_kitchendoorext_combustion_add", "1"} ,{ "vid_livingroom_kitchendoorext_combustion_add", "1"} }
  ,{ "nearcar"     ,{ "vid_nearcar_intro", "1.334"} ,{ "vid_nearcar_maniac", "1.334"} ,{ "vid_nearcar_maniac_destruction", "1.334"} ,{ "vid_nearcar_maniac_destruction", "1.334"} ,{ "vid_nearcar_water", "1"} ,{ "vid_nearcar_water", "1"} ,{ "vid_nearcar_smoke_1", "1"} ,{ "vid_nearcar_smoke_2", "1"} ,{ "vid_nearcar_smoke_3", "1"} ,{ "vid_nearcar_smoke_3", "1"} ,{ "vid_nearcar_transfer", "1.34"} }
  ,{ "plane"     ,{ "vid_stewardessroom_use_screwdriver", "1"} }
  ,{ "stewardessroom"     ,{ "vid_fridge_use_corkscrew", "1"} }
  ,{ "intro"     ,{ "vid_intro_video", "1.334"} }
  };



  function port.VideoResizeInRoom(room_object)

    local room_current = room_object;
    --DbgTrace("resize room = "..room_object);
    local room_name = room_current;
    if room_current ~= "levelext_inv" and 
       room_current ~= "level1_inv" and 
       room_current ~= "level2_inv" and 
       room_current ~= "level3_inv" and
       room_current ~= "evidence" then
      room_name = string.sub(room_current,4);
    end;
    local count_room = #port.list_video_resize;
    
    for i=1,#port.list_video_resize do
      if room_name == port.list_video_resize[i][1] then
        --DbgTrace("port.list_video_resize[i][1]="..port.list_video_resize[i][1]);
        for j=2,#port.list_video_resize[i] do
          if ObjGet(port.list_video_resize[i][j][1]) then
            --DbgTrace("port.list_video_resize[i][j][1]="..port.list_video_resize[i][j][1]);
            --DbgTrace("port.list_video_resize[i][j][2]="..port.list_video_resize[i][j][2]);
            local scaleObj = tostring(ObjGet(port.list_video_resize[i][j][1]).scale_x);
            if scaleObj == "1.0" then scaleObj ="1"; end;
            local scaleInTable = port.list_video_resize[i][j][2];
            if string.len(scaleObj) > 3 then
              scaleObj = string.sub(scaleObj,1,3);
            end;
            if string.len(scaleInTable) > 3 then
              scaleInTable = string.sub(scaleInTable,1,3);
            end;
            --DbgTrace("scaleObj="..scaleObj);
            --DbgTrace("scaleInTable="..scaleInTable);
            if  scaleObj == scaleInTable then
              --DbgTrace("resize video="..port.list_video_resize[i][j][1]);
              ObjSet(port.list_video_resize[i][j][1],{ scale_x = ObjGet(port.list_video_resize[i][j][1]).scale_x*2, scale_y = ObjGet(port.list_video_resize[i][j][1]).scale_y*2 });
              if (ObjGet(port.list_video_resize[i][j][1]).drawoff_x ~= 0) then
                ObjSet(port.list_video_resize[i][j][1],{ drawoff_x = ObjGet(port.list_video_resize[i][j][1]).drawoff_x/2 });
              end;    
              if (ObjGet(port.list_video_resize[i][j][1]).drawoff_y ~= 0) then
                ObjSet(port.list_video_resize[i][j][1],{ drawoff_y = ObjGet(port.list_video_resize[i][j][1]).drawoff_y/2 });
              end;
            end;
          end;
        end;
        break;
      end;
    end;
  end;

--------------------------------------------------------------
  port.logevent_array = {};
  port.skip_mg = false;

  function port.LogEvent(event_name, status, win)
    
    local check_event = true;
    local win_check = win or "close"; 
    local length_name = string.len(event_name);
    local name = string.sub(event_name,5,length_name);

    if #port.logevent_array > 0 then
      for i=1,#port.logevent_array do
        if port.logevent_array[i] == string.format("%s%s%s",event_name,status,tostring(win_check)) then
          check_event = false;
        end;
      end;
    end;

    --DbgTrace("port.LogEvent");
    --DbgTrace("port.LogEvent event_name = "..event_name.." || status = "..status.." || name = "..name);

    if check_event then
      
      port.logevent_array[#port.logevent_array] = string.format("%s%s%s",event_name,status,tostring(win_check));
      
      --DbgTrace("port.LogEvent event_name = "..event_name.." || status = "..status.." || name = "..name);

      local current_room = GetCurrentRoom();
      local prefix = string.sub(current_room,0,2);
      if prefix == "mg" or prefix == "rm" then 
        --DbgTrace("prefix = "..prefix);
        if status == "open" then
          iOS_LogEvents(5, "mg_"..name );
        else
                if win_check then
                  if win_check == true or win_check == 1 then

                        if port.skip_mg then
                          iOS_LogEvents(7, "mg_"..name );
                          --DbgTrace("skip_win");
                          port.skip_mg = false;
                        else
                          iOS_LogEvents(6, "mg_"..name );
                          --DbgTrace("win_win");
                        end;
                      
                  else 
                        --DbgTrace("mg no_win");
                  end;
                else
                      --DbgTrace("mg no_win");
                end;


        end;

      end;
      if prefix == "ho" then 
        --DbgTrace("prefix = "..prefix);
        if status == "open" then
          --DbgTrace("ho_open");
          iOS_LogEvents(12, "ho_"..name );
        else
          --DbgTrace("ho_close win");
          iOS_LogEvents(13, "ho_"..name );
        end;      
      end;

    end;

  end;

--------------------------------------------------------------
  function port.InventoryPopupInit( name )
    
    local name_obj = name or "";
    
      local objs_child = ObjGetRelations( name_obj );
      
      for i=1,#objs_child.childs do
          
          local obj_menter = ObjGet(objs_child.childs[i]).event_menter;
          
          if ObjGet(objs_child.childs[i]).event_mdown then 
            local obj_down = ObjGet(objs_child.childs[i]).event_mdown;      
            ObjSet(objs_child.childs[i],{ event_menter = "", event_mleave = "", event_mdown =  function() obj_menter(); port.ShowPopUp(); obj_down(); end });
          else
            ObjSet(objs_child.childs[i],{ event_menter = "", event_mleave = "", event_mdown = function() obj_menter(); port.ShowPopUp(); end });
          end;
      end;
    
    
  end;
      
  port.active_popup = false;
--------------------------------------------------------------
  function port.ShowPopUp()

      port.active_popup = true;
      
      local timer = 2;
      local room = common.GetCurrentRoom();
      if "ho" == common.GetObjectPrefix( room ) then
        timer = 0.5;
      end;     
    
      ObjSet( "tmr_port_tap_down", { endtrig = function() port.active_popup = false; interface.PopupHide(); end, time = timer, playing = 1 } );
  end;
      
  function port.ShowPopUpHO( name )

      port.active_popup = true;
      interface.PopupShow( name );
      
      local timer = 2;
    
      ObjSet( "tmr_port_tap_down", { endtrig = function() port.active_popup = false; interface.PopupHide(); end, time = timer, playing = 1 } );
  end;
-----------------------------------------------------------------
  function port.DebugEndTimer()

  DbgTrace("DebugEndTimer");

  end;

------------------------------------------------------------------------------------

--
  port.list_gates_1 =
  {
   { "ho_farmhouse"            ,"grm_farmhouse_abandonedfarm_focus"         ,1 }
  ,{ "ho_investigatorsdesk"    ,"grm_investigatorsdesk_policestation_focus" ,1 }
  ,{ "ho_roundthecorner"       ,"grm_roundthecorner_townoutskirts_focus"    ,1 }
  ,{ "mg_mgboxes"              ,"grm_mgboxes_carrepairshop_focus"           ,1 }
  ,{ "mg_mgremovecollapse"     ,"grm_mgremovecollapse_carrepairshop_focus"  ,1 }
  ,{ "mg_onthelid"             ,"grm_onthelid_abandonedfarm_focus"          ,1 }
  ,{ "rm_abandonedfarm"        ,"grm_abandonedfarm_bygrayscar_focus"        ,1 }
  ,{ "rm_bygrayscar"           ,"grm_bygrayscar_abandonedfarm_focus"        ,0 }
  ,{ "rm_bygrayscar"           ,"grm_bygrayscar_track_focus"                ,0 }
  ,{ "rm_bypolicestation"      ,"grm_bypolicestation_policestation_focus"   ,1 }
  ,{ "rm_carrepairshop"        ,"grm_carrepairshop_townoutskirts_focus"     ,1 }
  ,{ "rm_policestation"        ,"grm_policestation_bypolicestation_focus"   ,1 }
  ,{ "rm_townoutskirts"        ,"grm_townoutskirts_track_focus"             ,1 }
  ,{ "rm_townoutskirts"        ,"grm_townoutskirts_carrepairshop_focus"     ,0 }
  ,{ "rm_track"                ,"grm_track_townoutskirts_focus"             ,0 }
  ,{ "rm_track"                ,"grm_track_bygrayscar_focus"                ,1 }
  };                                                                          
  --
  --
  --
  port.list_gates_2 =
  {
   { "ho_dollhouse"            ,"grm_dollhouse_livingroom_focus"            ,1 }
  ,{ "ho_inbasement"           ,"grm_inbasement_basement_focus"             ,1 }
  ,{ "ho_investigatorsdesk2"   ,"grm_investigatorsdesk2_policestation2_focus",1 }
  ,{ "mg_darkness"             ,"grm_darkness_yard_focus"                   ,1 }
  ,{ "mg_onsafedoor"           ,"grm_onsafedoor_office_focus"               ,1 }
  ,{ "mg_repair"               ,"grm_repair_switchroom_focus"               ,1 }
  ,{ "rm_basement"             ,"grm_basement_switchroom_focus"             ,0 }
  ,{ "rm_basement"             ,"grm_basement_yard_focus"                   ,1 }
  ,{ "rm_kitchen"              ,"grm_kitchen_livingroom_focus"              ,1 }
  ,{ "rm_livingroom"           ,"grm_livingroom_yard_focus"                 ,0 }
  ,{ "rm_livingroom"           ,"grm_livingroom_kitchen_focus"              ,0 }
  ,{ "rm_livingroom"           ,"grm_livingroom_office_focus"               ,0 }
  ,{ "rm_office"               ,"grm_office_livingroom_focus"               ,1 }
  ,{ "rm_switchroom"           ,"grm_switchroom_basement_focus"             ,1 }
  ,{ "rm_yard"                 ,"grm_yard_livingroom_focus"                 ,1 }
  ,{ "rm_yard"                 ,"grm_yard_basement_focus"                   ,0 }
  };
  port.list_gates_3 =
  {
   { "ho_crashreport"          ,"grm_crashreport_policestation3_focus"      ,1 }
  ,{ "ho_hosecuritypoint"      ,"grm_hosecuritypoint_aircompaniesstand_focus",1 }
  ,{ "ho_serverroom"           ,"grm_serverroom_controltower_focus"         ,1 }
  ,{ "mg_cashtill"             ,"grm_cashtill_waitinghall_focus"            ,1 }
  ,{ "mg_ondoor"               ,"grm_ondoor_technicalroom_focus"            ,1 }
  ,{ "mg_worriedmessage"       ,"grm_worriedmessage_controltower_focus"     ,1 }
  ,{ "rm_aircompaniesstand"    ,"grm_aircompaniesstand_waitinghall_focus"   ,1 }
  ,{ "rm_aircompaniesstand"    ,"grm_aircompaniesstand_secondfloorcorridor_focus",0 }
  ,{ "rm_controltower"         ,"grm_controltower_secondfloorcorridor_focus",1 }
  ,{ "rm_secondfloorcorridor"  ,"grm_secondfloorcorridor_aircompaniesstand_focus",1 }
  ,{ "rm_secondfloorcorridor"  ,"grm_secondfloorcorridor_technicalroom_focus",0 }
  ,{ "rm_secondfloorcorridor"  ,"grm_secondfloorcorridor_controltower_focus",0 }
  ,{ "rm_technicalroom"        ,"grm_technicalroom_secondfloorcorridor_focus",1 }
  ,{ "rm_waitinghall"          ,"grm_waitinghall_window_focus"              ,1 }
  ,{ "rm_waitinghall"          ,"grm_waitinghall_aircompaniesstand_focus"   ,0 }
  ,{ "rm_window"               ,"grm_window_waitinghall_focus"              ,1 }
  };
  port.list_gates_4 =
  {
   { "ho_hocabinet"            ,"grm_hocabinet_stewardessroom_focus"        ,1 }
  ,{ "ho_hofridge"             ,"grm_hofridge_stewardessroom_focus"         ,1 }
  ,{ "ho_hoscrypt"             ,"grm_hoscrypt_farm_focus"                   ,1 }
  ,{ "ho_house"                ,"grm_house_livingroomext_focus"             ,1 }
  ,{ "mg_lulling"              ,"grm_lulling_kitchenext_focus"              ,1 }
  ,{ "mg_mgbook"               ,"grm_mgbook_nearcar_focus"                  ,1 }
  ,{ "mg_mgfate"               ,"grm_mgfate_flightdeck_focus"               ,1 }
  ,{ "mg_mgstatue"             ,"grm_mgstatue_cemetery_focus"               ,1 }
  ,{ "rm_basementext"          ,"grm_basementext_livingroomext_focus"       ,1 }
  ,{ "rm_cemetery"             ,"grm_cemetery_nearcar_focus"                ,1 }
  ,{ "rm_farm"                 ,"grm_farm_nearcar_focus"                    ,1 }
  ,{ "rm_flightdeck"           ,"grm_flightdeck_plane_focus"                ,1 }
  ,{ "rm_kitchenext"           ,"grm_kitchenext_livingroomext_focus"        ,1 }
  ,{ "rm_livingroomext"        ,"grm_livingroomext_basementext_focus"       ,0 }
  ,{ "rm_livingroomext"        ,"grm_livingroomext_kitchenext_focus"        ,0 }
  ,{ "rm_nearcar"              ,"grm_nearcar_farm_focus"                    ,1 }
  ,{ "rm_nearcar"              ,"grm_nearcar_cemetery_focus"                ,0 }
  ,{ "rm_plane"                ,"grm_plane_stewardessroom_focus"            ,0 }
  ,{ "rm_plane"                ,"grm_plane_flightdeck_focus"                ,0 }
  ,{ "rm_stewardessroom"       ,"grm_stewardessroom_plane_focus"            ,1 }
  };
--------------------------------------------------------------------
-- выбираем нужный массив гейтов по текущему прогрессу
  function port.GetCurListGates()

    if ng_global.currentprogress ~= nil then
      if ng_global.currentprogress ~= "alt" then
  --------------------------------------------------
        local arr = {{"1",  port.list_gates_1},
                     {"2",  port.list_gates_2},
                     {"3",  port.list_gates_3},   
                     {"t",  port.list_gates_4},  
                                                  };
        local currentlistgates = arr[1][2];
        
        if ng_global.currentprogress ~= nil then
          local prg = ng_global.currentprogress;
          local lvl = string.sub (ng_global.progress[ prg ].common.chapter, -1)
          --DbgTrace("current_prg_"..prg);
          --DbgTrace("current_level_"..lvl);
          for i=1,#arr do
            if arr[i][1] == tostring(lvl) then
              currentlistgates = arr[i][2];
              break;
            end;
          end;
        end;

          return currentlistgates;    
  -------------------------------------------
      end;
    end;

  end;
--------------------------------------------------------------------
---- включение анимации при загрузке комнаты
  function port.GrmLightOn(room)

    if ng_global.currentprogress ~= nil then
      if ng_global.currentprogress ~= "alt" then
    ----------------------------------------------------------
        local cur_mass = port.GetCurListGates();
        for i=1,#cur_mass do
            if cur_mass[i][1] == room and cur_mass[i][3] == 1 then 
                  local delay = 1.5 + math.random();
                  ObjSet (cur_mass[i][2], {event_menter = "", event_mleave = "", active = 1, visible = 1});
                  ObjAnimate( cur_mass[i][2], 8, 1, 0, "", {  0,         0,0,
                                                                       delay/2,   0,1,
                                                                       delay,     0,1,
                                                                       delay*1.5, 0,0,
                                                                       delay*1.8, 0,0  });

            end;
            if cur_mass[i][1] == room then 
                local count_word = string.len(cur_mass[i][2]);
                local str_name_grm = string.sub(cur_mass[i][2],1,count_word-6);
                ObjSet (str_name_grm,{ event_menter = "", event_mleave = "" }); 
                
            end;
        end;
  -----------------------------------------------------------------
      end;
    end;

  end;
--------------------------------------------------------------------
-- --включение анимации для зон перехода после события
  function port.GrmEventLightOn(gate)
      if port.isPortable() == 1 then
            local cur_mass = port.GetCurListGates();
            for i=1,#cur_mass do
                if cur_mass[i][2] == gate then 
                      local delay = 1.5 + math.random();
                      ObjSet (cur_mass[i][2], {event_menter = "", event_mleave = ""});
                      ObjStopAnimate(cur_mass[i][2], 8);
                      cur_mass[i][3] = 1;
                      ObjAnimate( cur_mass[i][2], 8, 1, 0, "", {  0,         0,0,
                                                                           delay/2,   0,1,
                                                                           delay,     0,1,
                                                                           delay*1.5, 0,0,
                                                                           delay*1.8, 0,0}); 
                end;
            end;
      end;
  end;
------------------------------------------------------------------
-- --выключение анимации для зон перехода после события
  function port.GrmEventLightOff(gate)
      if port.isPortable() == 1 then
              local cur_mass = port.GetCurListGates();
              for i=1,#cur_mass do
                  if cur_mass[i][2] == gate then
                        cur_mass[i][3] = 0; 
                        ObjSet (cur_mass[i][2], {event_menter = "", event_mleave = ""});
                        ObjStopAnimate(cur_mass[i][2], 8);
                        ObjAnimate( cur_mass[i][2], 8, 0, 0, "", {0,0,ObjGet(cur_mass[i][2]).alp, 0.1,0,0}); 
                  end;
              end;
      end;
  end;

------------------------------------------------------------------------------------
  function port.ForbidScaleWidget(cforbid, lforbid)
    ObjSet("tmr_common_forbidscale",{endtrig = "", time = 0.5, playing = 0 });
    if cforbid == 1 and lforbid == 1 then
      iOS_EnableMultiTouch(0);
      MsgSend( Command_Level_ResetZoom, { forbid = 1, luaforbid = lforbid } );
      ObjSet("tmr_common_forbidscale", { time = 0.5, playing = 1, endtrig = function () port.ForbidScale( 1, 1 ); end; }); 
    else
      iOS_EnableMultiTouch(1);
      MsgSend( Command_Level_ResetZoom, { forbid = 0, luaforbid = lforbid } );
      ObjSet("tmr_common_forbidscale",{endtrig = "", time = 0.5, playing = 0 }); 
    end;
  end;

------------------------------------------------------------------------------------
  port.RoomNoZoom = {
    "rm_intro",
    "rm_menu",
    "rm_unlock",
    "rm_collectable",
    "rm_achievements",
    "rm_sequel",
    "rm_extra",
    "rm_credits"
  };

  port.TaskPanelActive = false;

  function port.Scale( enable )
      --if port.TaskPanelActive == true then
      --    DbgTrace("port.TaskPanelActive=1");
      --else
      --    DbgTrace("port.TaskPanelActive=0");
      --end;
    local room = common.GetCurrentRoom();
    local check = false;
      
    if not room then room = "rm_intro" end; 
    if enable == 1 then
      if port.isTablet() == 1 then
        --DbgTrace("isTablet");
        if "ho" == common.GetObjectPrefix( room ) or port.TaskPanelActive == true then
          --DbgTrace("Command_Level_SetZoom = 1");
          MsgSend( Command_Level_SetZoom, { zoom = true } );
          iOS_EnableMultiTouch(1);     
        else
          --DbgTrace("Command_Level_SetZoom = 0");
          MsgSend( Command_Level_SetZoom, { zoom = false } );
          iOS_EnableMultiTouch(0);
        end;
      else 
         --DbgTrace("isIphone");
        if ("ho" == common.GetObjectPrefix( room )) then
          for i=1,#port.RoomNoZoom do
            if room == port.RoomNoZoom[i] then check = true; end;
          end;

          if check then
             iOS_EnableMultiTouch(0);
             MsgSend( Command_Level_SetZoom, { zoom = false } );
             --DbgTrace("Command_Level_SetZoom = 0");
          else
             iOS_EnableMultiTouch(1);
             MsgSend( Command_Level_SetZoom, { zoom = true } );
             --DbgTrace("Command_Level_SetZoom = 1");
          end;
        else 
          iOS_EnableMultiTouch(0);
          MsgSend( Command_Level_SetZoom, { zoom = false } );
          --DbgTrace("Command_Level_SetZoom = 0");
        end;
      end;  
    else
      iOS_EnableMultiTouch(0);
      MsgSend( Command_Level_SetZoom, { zoom = false } );
     -- DbgTrace("Command_Level_SetZoom = 0");
    end;

  end;


--*********************************************************************************************************************

  private.enable_android_back_button = true;

  function public.EnableAndroidBackButton( param )
    private.enable_android_back_button = param;
    --DbgTrace("cmn.EnableAndroidBackButton private.enable_android_back_button = "..tostring(private.enable_android_back_button));
  end;

  function public.AndroidBackPressed()
    
    --DbgTrace("[common_impl] cmn.AndroidBackPressed private.enable_android_back_button = "..tostring(private.enable_android_back_button));

    local status = GetCurrentProfile();
    if status == "ng_noprofiles" or status == "ng_error" and loc == "rm_menu" then
      --DbgTrace("loc = "..loc.." profile not create!");
    elseif ( private.enable_android_back_button ) then
  --[[ пример кода взять из проекта mc или из вашей кнопки "назад" ]] 

      local loc = GetCurrentRoom();
      local pref = common.GetObjectPrefix( loc );

      --DbgTrace("loc = "..loc);
      -- obj_int_lock or obj_int_top_lock
      if (ObjGet("obj_int_lock")) then
        --DbgTrace("input:"..tostring(ObjGet("obj_int_lock").input));
        if (ObjGet("obj_int_lock").input == true) then
          ObjSet("obj_int_lock",{ input = false });
        end;
      end;  

      if ( int_window.GetIntShown() ) then
        --DbgTrace("Hide dialog ");
      elseif ( common.GetCurrentSubRoom() ) then
        common.CloseSubRoom();
      elseif ( pref == "rm" ) then
        --DbgTrace("pref = "..pref);
        if ( loc == "rm_achievements" or loc == "rm_collectibles" or loc == "rm_collectibles2" ) then
          local room = common.GetCurrentRoom();
          if ( not room ) then
            room = "rm_extra";
          end; 
          --DbgTrace("GotoRoom = "..room);
          common.GotoRoom( room ); 
        elseif ( loc == "rm_unlock" ) then
          --DbgTrace("rm_unlock.BackDown()");
          rm_unlock.BackDown();
        elseif ( loc == "rm_credits" ) then
          --DbgTrace("rm_credits.Exit();"); 
          rm_credits.Exit();
        elseif ( loc == "rm_moregames" or loc == "rm_extra" or loc == "rm_sequel" or loc == "rm_secretroom") then 
          --DbgTrace("common.GotoRoom( \"rm_menu\" );"); 
          common.GotoRoom( "rm_menu" );
        elseif (loc == "rm_menu") then
          if rm_menu.sub_menu_active then
            --DbgTrace("rm_menu.closeGearSubMenu();"); 
            rm_menu.closeGearSubMenu();
          else
            --DbgTrace("rm_menu.closeGearSubMenu();"); 
            common.MenuQuit();
          end;       
        elseif ( game and public.FindIndex( game.room_names, loc ) ) then
          --DbgTrace("MsgSend( Event_ButtonMenu_Click, {} );"); 
          MsgSend( Event_ButtonMenu_Click, {} );
        end;
      elseif pref == "mg" then
          MsgSend( Event_ButtonMenu_Click, {} );
      elseif pref == "ho" then  
          common.GotoRoom( game.relations[ loc ].exitroom );
      end;      
   
    end; 
  end;
--**************************************************************************************************************
--***function *** operations with arrays *** () end*************************************************************
--**************************************************************************************************************
  function public.FindIndex( arr, elem ) -- поиск по таблице SS
    for i = 1, #arr  do
      if arr[i] == elem then
        return i;
      end;
    end;
    return 0; 
  end;  
--*********************************************************************************************************************
