-- name=level1

function public.Start ( param )

  int.WidgetAdd( InterfaceWidget_Pause, 1800 );

  int.WidgetAdd( InterfaceWidget_BtnMenu, 12 );


  int.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  int.WidgetAdd( InterfaceWidget_BtnSkip, 9 );
  int.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  int.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  int.WidgetAdd( InterfaceWidget_Inventory, 21 );
  int.WidgetAdd( InterfaceWidget_TaskPanel, 22 );
  int.WidgetAdd( InterfaceWidget_ItemPanel, 22 );

  int.WidgetAdd( InterfaceWidget_Effects, 23 );

  int.WidgetAdd( InterfaceWidget_BtnMap, 13 );

  int.WidgetAdd( InterfaceWidget_DialogHo );

  int.ButtonLockAdd();

  int.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  int.WidgetAdd( InterfaceWidget_Popup, 31 );

  int.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  int.WidgetAdd( InterfaceWidget_Dialog );

  --1491
  int.WidgetAdd( InterfaceWidget_DialogVideo, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogStory, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogCharacter, 1491 );

  int.WidgetAdd( InterfaceWidget_Window );
  int.WidgetAdd( InterfaceWidget_StrategyGuide );     

  int.WidgetAdd( InterfaceWidget_Tutorial );
  int.WidgetAdd( InterfaceWidget_Map, 24  );

  int.PanelNotificationAdd();
  int.DeployInvAdd(9);

  int.DialogHintAdd( 10 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );
  int.InitMiniho( 18 );

  ObjSet( "int_button_map_impl",
  {
    alp = 0,
    input = false,
    visible = false,
    active = true
  } );   
  
  --
  private.Init();
  ModLoad( "assets/levels/level1/mod_level1_inv" );
  level1_inv.Init();
  --
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then


  int.WidgetAdd( InterfaceWidget_BtnGuide, 10 );  
    interface.AchievementsAdd( 10 );
    int.MorphingAdd( 10 );
    int.CollectiblesAdd( 20 );
    int.Collectibles2Add( 22 );

  end;  

  common.LevelLoad( "level1", "std", "rm_bypolicestation", param, private.menu_moduls );
  
  private.TutorialSetParams(); 
  interface.KeyUpdate(); 
  int.UpdateTask( 1 );

  if not IsCollectorsEdition() and not IsSurveyEdition() then

    ObjSet( "btn_map_button_diary", { pos_x = 10 } );
    ObjSet( "btn_map_button_collectibles", { visible = 0, active = 0, input = 0  } );
    ObjSet( "btn_map_button_achievements", { visible = 0, active = 0, input = 0  } );    

    local collect = 
    {
      "get_collect2_1_1"
      ,"get_collect2_1_2"
      ,"get_collect2_1_3"
      ,"get_collect2_1_4"
    }
    local collect_morph = 
    {
      "get_morphobject_1_1"
      ,"get_morphobject_1_2"
      ,"get_morphobject_1_3"
      ,"get_morphobject_1_4"
      ,"get_morphobject_1_5"
      ,"get_morphobject_1_6"
    };

    for i = 1, #collect do
      cmn.SetEventDone( collect[ i ] );
      cmn.CallEventHandler( collect[ i ] );
    end;
    for i = 1, #collect_morph do
      cmn.SetEventDone( collect_morph[ i ] );
      cmn.CallEventHandler( collect_morph[ i ] );
    end;

  end;

end;

function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_bypolicestation"
    ,"rm_policestation"
    ,"rm_bygrayscar"
    ,"rm_abandonedfarm"
    ,"rm_track"
    ,"rm_demo"
    ,"rm_townoutskirts"
    ,"rm_carrepairshop"
    ,"ho_investigatorsdesk"    
    ,"ho_farmhouse"  
    ,"ho_roundthecorner"
    ,"mg_onthelid"
    ,"mg_mgboxes"
    ,"mg_mgremovecollapse"
  };

  game.progress_names =
  {
   "beg_level1"
  ,"opn_bypolicestation"
  ,"dlg_bypolicestation_jackie_1"

  ,"opn_policestation"
  ,"clk_policeman"
  ,"dlg_policestation_policeman_1"
  ,"opn_investigatorsdesk"
  ,"win_investigatorsdesk"
  --,"get_killersphoto"
  ,"dlg_policestation_policeman_2"
  ,"get_carkeys"

  ,"opn_bygrayscar"
  ,"clk_bygrayscar_survey"
  ,"get_rope"
  ,"get_folder"
  ,"clk_folder"
  ,"clk_folder_page_1"
  ,"clk_folder_page_2"
  ,"clk_folder_page_3"
  ,"get_medalliondove"
  ,"get_gloveboxslider"
  ,"use_gloveboxslider"
  ,"clk_box"
  ,"get_areamap"
  ,"get_amuletmechanics"
  ,"use_carkeys"
  ,"clk_carkeys"
  ,"use_amuletmechanics"
  ,"get_machete"
  ,"get_extinguisher"
  ,"get_purse"
  ,"use_machete_0"
  ,"use_machete_1"
  --,"use_machete_2"
  --,"use_machete_3"

  ,"opn_abandonedfarm"
  ,"get_triangularpart_1"
  ,"get_triangularpart_2"
  ,"clk_vid_bat"
  ,"use_triangularpart_2"
  ,"opn_onthelid"
  ,"win_onthelid"
  ,"get_lantern"
  ,"get_hammer"
  ,"use_hammer_1"
  ,"get_planks_2"
  ,"get_nails_4"
  ,"use_hammer_2"
  ,"get_planks_4"
  ,"get_nails_8"
  ,"use_planks_4"
  ,"use_nails_8"
  ,"use_hammer_3"
  ,"use_lantern"
  ,"get_nut"
  ,"get_bicyclekey"
  ,"use_bicyclekey"
  ,"clk_bicyclekey"
  ,"get_bicycle"
  ,"use_handfulofnuts"
  ,"get_goldennut"
  ,"use_goldennut"
  ,"get_thread"
  ,"get_notebooksheet"
  ,"use_bicycle"
  ,"opn_track"
  ,"clk_vid_fire_1"
  ,"clk_lockpick"
  ,"get_shard"
  ,"use_shard"
  ,"get_coaltongs"
  ,"use_coaltongs"
  ,"get_flamingfirebrand"
  ,"use_flamingfirebrand"
  ,"get_lockpick"
  ,"use_lockpick_1"
  ,"clk_handle"
  ,"use_killersphoto"
  ,"win_carcab"
  ,"use_rope"
  ,"clk_man"
  ,"get_stolenbag"
  ,"use_medalliondove"
  ,"clk_stolenbag"
  ,"clk_stolenbag_note"
  ,"get_suitcasebutton"
  ,"get_gloves"
  ,"use_lockpick_2"
  ,"opn_farmhouse"
  ,"win_farmhouse"
  ,"use_extinguisher"
  ,"use_chainsaw"

  ,"opn_townoutskirts"
  ,"clk_townoutskirts_survey"
  ,"get_bow"
  ,"get_mallet"
  ,"use_mallet"
  ,"use_gloves"
  ,"get_awl"
  ,"get_handle"
  ,"use_notebooksheet"
  ,"use_handle"
  ,"get_amuletpicture"
  ,"use_awl_1"
  ,"get_ironpiece"
  ,"get_toggle"
  ,"use_toggle"
  ,"clk_toggle"
  ,"clk_bag"
  ,"clk_photo_1"
  ,"clk_photo_2"
  ,"get_arrow"
  ,"use_awl_2"
  ,"get_coin_1"
  ,"get_feathers"
  ,"use_amuletpicture"
  ,"clk_ironpiece_chalk"
  ,"win_ironpiece"
  ,"use_awl_3"
  ,"get_amuletowl"
  ,"see_scare_1_1"
  ,"use_amuletowl"
  ,"get_playdough"
  ,"get_adhesivetape"
  ,"use_arrow"
  ,"use_playdough"
  ,"use_feathers"
  ,"use_thread"
  ,"get_bowwitharrow"
  ,"use_bowwitharrow"
  ,"win_policewindow"
  ,"get_masterkey"
  ,"use_masterkey"

  ,"opn_carrepairshop"
  ,"get_coin_2"
  ,"get_amuletcar"
  ,"use_amuletcar"
  ,"use_suitcasebutton"
  ,"get_acetoneandcottonwool"
  ,"use_acetoneandcottonwool"
  ,"win_mechanism"
  ,"win_mgboxes"
  ,"get_rustyjack"
  ,"get_scissors"
  ,"use_scissors"
  ,"get_cabinetkey"
  ,"use_cabinetkey"
  ,"get_winchlever"
  ,"get_brokenworkshopfob"
  ,"use_winchlever"
  ,"clk_winchlever"
  ,"get_pliers"
  ,"use_pliers"
  ,"opn_roundthecorner"
  ,"win_roundthecorner"
  --,"get_antirustsolution"
  ,"use_antirustsolution_1"
  ,"get_crossed_bones"
  ,"get_jack"
  ,"use_antirustsolution_2"
  ,"clk_cabinet"
  ,"get_smallbattery_1"
  ,"get_skull"
  ,"use_skull"
  ,"use_crossed_bones"
  ,"get_lighter"
  ,"get_insectspray"
  ,"clk_newspaper"
  ,"use_insectspray"
  ,"clk_bag_lvl1"
  ,"get_pump"
  ,"get_smallbattery_2"
  ,"clk_brokenworkshopfob_bottom"
  ,"clk_brokenworkshopfob_cup_open"
  ,"use_smallbattery_2"
  ,"clk_brokenworkshopfob_cup_close"
  ,"use_adhesivetape"
  ,"clk_brokenworkshopfob_up"
  ,"get_workshopfob"
  ,"use_workshopfob"
  ,"get_wheel"
  ,"get_screwdriver"
  --,"clk_dlg_atropos"
  ,"dlg_carrepairshop_atropos_1"
  ,"win_mgremovecollapse"
  ,"use_screwdriver"
  ,"clk_connectwires"
  ,"get_wheelwrench"
  ,"get_wheel_2"
  ,"use_jack"
  ,"use_wheelwrench_1"
  ,"use_wheel"
  ,"use_wheel_1"
  ,"use_wheel_2"
  ,"use_wheelwrench_2"
  ,"clk_jack"
  ,"use_pump"
  ,"get_morphobject_1_1"
  ,"get_morphobject_1_2"
  ,"get_morphobject_1_3"
  ,"get_morphobject_1_4"
  ,"get_morphobject_1_5"
  ,"get_morphobject_1_6"
  ,"get_collect2_1_1"
  ,"get_collect2_1_2"
  ,"get_collect2_1_3"
  ,"get_collect2_1_4"
  };

  game.relations = {};
  
  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      --"rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;  

end;

function private.TutorialSetParams()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function() end;
    
    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );

    end;

    ng_global.progress[ "std" ][ "see_tutorial" ].state.pages = {

      [ "tutorial_page_1" ]  = { shown = 0, noskip = true,  posx = 512, posy = 250, input = true,  arrows = {} },       -- Показать туториал?

      [ "tutorial_page_2" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 780, pos_y = 280, ang = 3.14 }
                                                                            } },                                        -- Диалог с Джеки
      [ "tutorial_page_3" ]  = { shown = 0, noskip = false, posx = 420, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 720, pos_y = 360, ang = -2.3 }
                                                                            } },                                        -- Открытие ЗЗ
      [ "tutorial_page_4" ]  = { shown = 0, noskip = false, posx = 370, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 640, pos_y = 320, ang = -2.3 }
                                                                            } },                                        -- Подбор папки
      [ "tutorial_page_5" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 0, pos_y = -80, ang = -3.14, target = "hub_int_inventory_folder" }
                                                                            } },                                        -- Сложный инвентарный
      [ "tutorial_page_6" ]  = { shown = 0, noskip = false, posx = 370, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 640, pos_y = 340, ang = -2.3 }
                                                                            } },                                        -- Подбор бегунка
      [ "tutorial_page_7" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 0, pos_y = -120, ang = -3.14, target = "int_button_map_impl" }
                                                                            } },                                        -- Карта
      [ "tutorial_page_8" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 0, pos_y = -80, ang = -3.14, target = "grm_bygrayscar_abandonedfarm" }
                                                                            } },                                        -- Переход в локацию
      [ "tutorial_page_9" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 450, pos_y = 500, ang = -3.14 }
                                                                            } },                                        -- Переход в ХО
      [ "tutorial_page_10" ] = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, next = "tutorial_page_14", arrows = { 
                                                                              { pos_x = 140, pos_y = -80, ang = 3.14, target = "int_taskpanel_impl" }
                                                                            } },                                        -- В ХО
      [ "tutorial_page_14" ] = { shown = 0, noskip = false, posx = 300, posy = 400, input = false, arrows = { 
                                                                              { pos_x = 80, pos_y = 0, ang = 2.3, target = "int_button_hint_impl" }
                                                                            } },                                        -- На хинт
      [ "tutorial_page_21" ] = { shown = 0, noskip = false, posx = 512, posy = 330, input = false, arrows = { 
                                                                              { pos_x = 120, pos_y = 0,   ang =  1.57,  target = "obj_int_button_info" },
                                                                              { pos_x = 120, pos_y = 0,   ang =  1.57,  target = "obj_int_button_reset" },
                                                                              { pos_x = 100, pos_y = -50, ang = -4,     target = "int_button_skip_impl" }
                                                                            } },                                        -- Кнопка Инфо в МГ
      --[ "tutorial_page_22" ] = { shown = 0, noskip = false, posx = 512, posy = 330, input = false, arrows = { 
      --                                                                        { pos_x = 120, pos_y = 0, ang =  1.57,  target = "obj_int_button_reset" },
      --                                                                        { pos_x = 100, pos_y = -50, ang = -4,  target = "int_button_skip_impl" }
      --                                                                      } },      
      [ "tutorial_page_30" ] = { shown = 0, noskip = false, posx = 620, posy = 380, input = false, arrows = { 
                                                                              { pos_x = 0, pos_y = -90, ang = 3.14, target = "int_itempanel_impl" }, 
                                                                              { pos_x = 260, pos_y = 400, ang = 2.2 }  
                                                                            } },   -- ��_������ ������
      [ "tutorial_page_31" ] = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "int_itempanel_impl" },  
                                                                              { pos_x = 80, pos_y = -180, ang = -2.2, target = "int_itempanel_impl" }  
                                                                            } },                                        
    };

  end;
  
end;
--***********************************************************************************************************************************
--***********************************************************************************************************************************