-- name=ho_investigatorsdesk2
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------

  room.Define( "ho_investigatorsdesk2" );

  private.room_objname = "ho_investigatorsdesk2";
  game.relations[ private.room_objname ].exitroom = "rm_policestation2";

  private.win_investigatorsdesk2 = {};

  private.InitAnim();
  private.win_investigatorsdesk2.time = { 5, 7, 5, 10, 7, 9, 9, 9, 8, 6, 9, 7 };
  --------------------------------------------------------------------------------------------
  -- function opn_investigatorsdesk2 () end;
  --------------------------------------------------------------------------------------------
  local opn_investigatorsdesk2 = function ()

  end;

  cmn.AddSubscriber( "opn_investigatorsdesk2", opn_investigatorsdesk2, private.room_objname );
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_investigatorsdesk2" ] =
  {
    type    = "get",
    get_obj = "spr_investigatorsdesk2_win",
    room    = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_investigatorsdesk2_func = function ()

    if ( cmn.IsEventDone( "win_investigatorsdesk2" ) ) then

        --int.InventoryItemAdd( "inv_apartment_planning", "spr_investigatorsdesk2_win" );
        ObjDelete( "gho_policestation2_investigatorsdesk2" );
        ObjDelete( "obj_investigatorsdesk2_taskpanel" );
        ObjDelete( "anm_policestation2_policeman1" );     
        ObjSet( "anm_policestation2_policeman2", { alp = 1 } );
        ObjSet( "obj_policestation2_clk_past_transfer", { input = true} );
        --int.DeleteTaskMap( "rm_policestation", "win_investigatorsdesk2" );
        --ObjSet( "rm_policestation2", { color_r = 0, color_g = 0, color_b = 0 } );
        ObjSet( "int_button_map_impl",
        {
          alp = 1,
          input = true,
          visible = true,
          active = true
        } );   

    end;
 
  end;
  cmn.AddSubscriber( "win_investigatorsdesk2", win_investigatorsdesk2_func );
  --------------------------------------------------------------------------------------------------
  local start_investigatorsdesk2_func = function ()

    if ( cmn.IsEventStart( "win_investigatorsdesk2" ) ) then

        common_impl.ProcessHoStart( "investigatorsdesk2" );

        local ho_found = ng_global.progress[ "std" ][ "win_investigatorsdesk2" ].found;

        for i = 1, #ho_found, 1 do

            ObjDelete( ho_found[ i ][ "object" ] );

        end;

        for i = 1,3 do

          local idx = ng_global.progress["std"]["win_investigatorsdesk2"].note[ i ][ 1 ];

          if ( ng_global.progress["std"]["win_investigatorsdesk2"].note[ i ][ 2 ] ) then

            ObjSet( "spr_investigatorsdesk2_"..i.."check", { alp = 1 } );

          end;

        end;

    end;

  end;
  cmn.AddSubscriber( "win_investigatorsdesk2", start_investigatorsdesk2_func, "ho_investigatorsdesk2" );
  --------------------------------------------------------------------------------------------------

  private.win_investigatorsdesk2.task = { "fire", "franklin", "firetruck", "photo", "voltage", "layout", "house", "rat", "plane", "moon", "evidencebag", "casefile" };

  for i = 1, #private.win_investigatorsdesk2.task do

    ObjSet( "spr_investigatorsdesk2_"..private.win_investigatorsdesk2.task[ i ], { input = false, event_mdown = function () private.CompleteTask( private.win_investigatorsdesk2.task[ i ] ); end } );

  end;
  --------------------------------------------------------------------------------------------------  
end;
--*********************************************************************************************************************
function public.Load ()


end;
--*********************************************************************************************************************
function public.PreOpen ()


  cmn.InterfaceSetVisible( true );
  --int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_investigatorsdesk2" ) ) then

    cmn.SetEventDone( "opn_investigatorsdesk2" );
    cmn.CallEventHandler( "opn_investigatorsdesk2" );

    ng_global.progress[ "std" ][ "win_investigatorsdesk2" ].number = 1;
    ng_global.progress[ "std" ][ "win_investigatorsdesk2" ].note = { { 5, false }, { 8, false }, { 12, false } };
    --cmn.TutorialShow( "tutorial_page_10" );
    --cmn.TutorialSetShown( "tutorial_page_10" );

  end;

  private.TaskStart();

  local ho_tasks = {};

  interface.TaskPanelTaskAdd( ho_tasks, "fire",        1, 0, { { "spr_investigatorsdesk2_fire"        } } );
  interface.TaskPanelTaskAdd( ho_tasks, "franklin",    1, 0, { { "spr_investigatorsdesk2_franklin"    } } );
  interface.TaskPanelTaskAdd( ho_tasks, "firetruck",   1, 0, { { "spr_investigatorsdesk2_firetruck"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "photo",       1, 0, { { "spr_investigatorsdesk2_photo"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "voltage",     1, 0, { { "spr_investigatorsdesk2_voltage"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "layout",      1, 0, { { "spr_investigatorsdesk2_layout"      } } );
  interface.TaskPanelTaskAdd( ho_tasks, "house",       1, 0, { { "spr_investigatorsdesk2_house"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "rat",         1, 0, { { "spr_investigatorsdesk2_rat"         } } );
  interface.TaskPanelTaskAdd( ho_tasks, "plane",       1, 0, { { "spr_investigatorsdesk2_plane"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "moon",        1, 0, { { "spr_investigatorsdesk2_moon"        } } );
  interface.TaskPanelTaskAdd( ho_tasks, "evidencebag", 1, 0, { { "spr_investigatorsdesk2_evidencebag" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "casefile",    1, 0, { { "spr_investigatorsdesk2_casefile"    } } );


  if ( not cmn.IsEventStart( "win_investigatorsdesk2" ) ) then

      cmn.InitHo( "investigatorsdesk2" );

  end;

  int.TaskPanelShow( ho_tasks );
  private.Panel();

  common_impl.StopMusEnv( false );

  --cmn.StopAllEnv( "audio/level3/env/aud_policestation_env" );

  --cmn.PlayAudio( "env", "audio/level3/env/aud_policestation_env", 1 );

  --cmn.PlayAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  private.TimerStart();

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  --cmn.StopAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 0.3 );
  cmn.StopAllVoc();

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "int_inventory_impl", { input = true } );


end;
--*********************************************************************************************************************
function public.HoComplete ()

  --common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  local postfix = "";

  if ( number ) then

     postfix = "_1"

  end;

  cmn.HoTaskFind( "spr_investigatorsdesk2_"..name..postfix, name..postfix );
  common_impl.PassingHoCheck();
  private.CheckDone();
  if ( ng_global.progress["std"]["win_investigatorsdesk2"].number ~= 12) then

    ng_global.progress["std"]["win_investigatorsdesk2"].number = ng_global.progress["std"]["win_investigatorsdesk2"].number + 1;
    private.Task();

  end;

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_investigatorsdesk2_taskpanel" , "int_taskpanel_impl" );

end;
--*********************************************************************************************************************
function private.TaskStart()

  local number = ng_global.progress[ "std" ][ "win_investigatorsdesk2" ].number;
  ObjSet( "txt_investigatorsdesk2_taskpanel", { alp = 1, text = "tsk_investigatorsdesk2_"..private.win_investigatorsdesk2.task[ number ] } );
  ObjSet( "spr_investigatorsdesk2_"..private.win_investigatorsdesk2.task[ number ], { input = true } );

end;
--*********************************************************************************************************************
function private.Task ()
  
  local func_end = function ()

    local number = ng_global.progress["std"]["win_investigatorsdesk2"].number;
    ObjSet( "txt_investigatorsdesk2_taskpanel", { text = "tsk_investigatorsdesk2_"..private.win_investigatorsdesk2.task[ number ] } );
    ObjSet( "spr_investigatorsdesk2_"..private.win_investigatorsdesk2.task[ number ], { input = true } );

  end;

  local func_end2 = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "txt_investigatorsdesk2_taskpanel", "alp", 0, 0, func_end2,
  { 
    0.0, 0, 1, 
    0.3, 0, 0,
    0.4, 0, 0,
    0.7, 0, 1

  } );

  ObjAnimate( "ho_investigatorsdesk2", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1, 
    0.3, 0, 1
  } );

  private.TimerDone();
  private.TimerStart();

end;
--*********************************************************************************************************************
function private.TimerStart ()

  local number = ng_global.progress[ "std" ][ "win_investigatorsdesk2" ].number;

  ObjSet( "tmr_investigatorsdesk2_voice", 
    { 
    playing = true, 
    time = private.win_investigatorsdesk2.time[ number ],
    endtrig = private.TimerDone
    } );

  cmn.StopAllVoc();
  cmn.PlayAudio( "voc", "audio/level2/voc/aud_youngpolice_"..number.."_voc", 0 ); 

  ObjSet( "obj_investigatorsdesk2_button", { input = false } );
  ObjSet( "anm_investigatorsdesk2_recorder", { active = true } );
  ObjAnimate( "spr_investigatorsdesk2_play2", "alp", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_investigatorsdesk2_play2" ).alp, 
    0.3, 0, 1
  } );

end;
--*********************************************************************************************************************
function private.TimerDone ()

  local func_end = function ()

    private.TimerStart();
    cmn.PlayAudio( "env", "audio/level1/env/aud_investigatorsdesk_in", 0 );
 
  end;

  local number = ng_global.progress[ "std" ][ "win_investigatorsdesk2" ].number;

  cmn.StopAllVoc();
  cmn.PlayAudio( "env", "audio/level1/env/aud_investigatorsdesk_in", 0 );
  ObjSet( "obj_investigatorsdesk2_button", { input = true, event_mdown = func_end } );
  ObjSet( "anm_investigatorsdesk2_recorder", { active = false } );
  ObjAnimate( "spr_investigatorsdesk2_play2", "alp", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_investigatorsdesk2_play2" ).alp, 
    0.3, 0, 0
  } );

end;

--*********************************************************************************************************************
function private.CheckDone ()

  local number = ng_global.progress["std"]["win_investigatorsdesk2"].number;

  for i = 1,3 do

    local idx = ng_global.progress["std"]["win_investigatorsdesk2"].note[ i ][ 1 ];

    if ( number == idx ) and not ( ng_global.progress["std"]["win_investigatorsdesk2"].note[ i ][ 2 ] ) then

      ng_global.progress["std"]["win_investigatorsdesk2"].note[ i ][ 2 ] = true;
      ObjAnimate( "spr_investigatorsdesk2_"..i.."check", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );

      AnimPlay( "anm_investigatorsdesk2_sighnfx_"..i, "DoAnim", "" );

    end;


  end;

end;
--*********************************************************************************************************************
function private.InitAnim ()

  ObjAnimate( "spr_investigatorsdesk2_lamp_light_add", "alp", 1, 0, "",
  { 
    0.0, 0, 1, 
    0.5, 0, 0.9,
    1, 0, 1 
  } );

end;