-- name=rm_policestation2
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_policestation2";
  ObjSet( "obj_policestation2_clk_policeman_dialog_1",           { event_mdown = private.dlg_policestation2_policeman_1 } );
  ObjSet( "obj_policestation2_clk_policeman_dialog_1_focus",     { event_mdown = private.dlg_policestation2_policeman_1 } );
  ObjSet( "obj_policestation2_clk_lamp",                         { event_mdown = private.ClkLamp } );
  ObjSet( "obj_policestation2_clk_past_transfer",                { event_mdown = private.PastTransfer } );

  private.InitAnim();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_policestation2 = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gho_policestation2_investigatorsdesk2"
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_policestation2", update_game_mode_policestation2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_policestation2 () end;
  --------------------------------------------------------------------------------------------
  local opn_policestation2 = function ()

    ObjDelete( "anm_bypolicestation2_jackie" );

  end;

  cmn.AddSubscriber( "opn_policestation2", opn_policestation2 );
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_coins_2 () end;
  --------------------------------------------------------------------------------------------
  local get_coins_2_inv = function ()

    int.InventoryItemAdd( "inv_coins_2" );

  end;

  cmn.AddSubscriber( "get_coins_2", get_coins_2_inv );

--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_lighter2 () end;
  --------------------------------------------------------------------------------------------
  local get_lighter2_inv = function ()

    int.InventoryItemAdd( "inv_lighter2" );

  end;

  cmn.AddSubscriber( "get_lighter2", get_lighter2_inv );

--*********************************************************************************************************************
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function dlg_policestation2_policeman_1 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_policestation2_policeman_1" ] =
  {
    type = "click",
    clk_obj = "obj_policestation2_clk_policeman_dialog_1",
    use_place = "obj_policestation2_clk_policeman_dialog_1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local dlg_policestation2_policeman_1_beg = function ()

  end;
  -----------------------------------------------
  local dlg_policestation2_policeman_1_end = function ()

    ObjDelete( "obj_policestation2_clk_policeman_dialog_1" );
    ObjSet( "gho_policestation2_investigatorsdesk2", { active = true, input = true, alp = 1 } );

  end;

  cmn.AddSubscriber( "dlg_policestation2_policeman_1", dlg_policestation2_policeman_1_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation2_policeman_1", dlg_policestation2_policeman_1_end, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation2_policeman_1_beg", dlg_policestation2_policeman_1_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation2_policeman_1_end", dlg_policestation2_policeman_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_pasttransfer () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_pasttransfer" ] =
  {
    type = "click",
    clk_obj = "obj_policestation2_clk_past_transfer",
    use_place = "obj_policestation2_clk_past_transfer",
    room = private.room_objname,
  };
  -----------------------------------------------
  local clk_pasttransfer_beg = function ()

    ObjDelete( "obj_policestation2_clk_past_transfer" );

  end;
  -----------------------------------------------
  local clk_pasttransfer_end = function ()

  end;

  cmn.AddSubscriber( "clk_pasttransfer", clk_pasttransfer_beg, private.room_objname );
  cmn.AddSubscriber( "clk_pasttransfer", clk_pasttransfer_end, private.room_objname );
  cmn.AddSubscriber( "clk_pasttransfer_beg", clk_pasttransfer_beg, private.room_objname );
  cmn.AddSubscriber( "clk_pasttransfer_end", clk_pasttransfer_end, private.room_objname );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_policestation2 ()

  if not ( cmn.IsEventDone( "opn_policestation2" ) ) then

    cmn.SetEventDone( "opn_policestation2" );
    cmn.CallEventHandler( "opn_policestation2" );
    cmn.ShowBbt( "bbt_policestation2_open" );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopAllEnv( "audio/level1/env/aud_policestation_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_policestation_env", 1 );

  if not ( cmn.IsEventDone( "opn_policestation2" ) ) then

    cmn.SetEventDone( "get_lighter2" );
    cmn.SetEventDone( "get_coins_2" );
    cmn.CallEventHandler( "get_lighter2" );
    cmn.CallEventHandler( "get_coins_2" );

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_policestation2();

  if ( cmn.IsEventDone( "win_repair" ) ) then

    private.SeeOutro_2_1();

  end;

--  if ( cmn.IsEventDone( "win_investigatorsdesk2" ) ) then
--
--    private.PastTransfer();
--
--  end;

end;
--*********************************************************************************************************************
-------------------------------------------------
function private.SeeOutro_2_1()

  local func_end = function ()

    --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_policestation_outro_mus" );
    --cmn.StopAudio( "voc", "audio/level1/voc/aud_policestation_outro_voc" );


    local prg = ng_global.currentprogress;
    ng_global.progress[ prg ].common.chapter = "level3";
    ng_global.progress[ prg ].common.currentroom = nil;
    local level = ng_global.progress[ prg ].common.chapter;
    ng_global.task_current = nil;

    common.LevelSwitch( level );    

  end;

  func_end();

--  common_impl.PlayDialogVideo( "vid_policestation_outro", func_end );  
--
--  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_policestation_outro_mus" );
--  cmn.PlayAudio( "voc", "audio/level1/voc/aud_policestation_outro_voc" );

end;
--*********************************************************************************************************************
-------------------------------------------------
function private.dlg_policestation2_policeman_1 ()

  ObjAttach( "dlg_policestation2_policeman_1", "rm_policestation2" );
  common_impl.dialog_character_loc = "";
  private.dialog_voices_time = { 3 };
  common_impl.DialogCharacterStart( "policeman_1", 3, nil, nil, false, 
    function () 
      cmn.ShowBbt( "bbt_policestation2_dlg1" );  
      cmn.CallEventHandler( "dlg_policestation2_policeman_1_end" );
    end );

  ObjSet( "tmr_policestation2_fordial", { playing = 1, time = 0.3, endtrig = "" } );

end;
-------------------------------------------------
--------------------------------------------------------------------
function private.PastTransfer()

  local func_end = function ()

    cmn.StopAudio( "sfx", "audio/level2/sfx/aud_back_in_past" );

    cmn.GotoRoom( "rm_livingroom" );
    int.Lock( false );
    common_impl.InterfaceSetVisible( true );

    cmn.SetEventDone( "clk_pasttransfer" );
    cmn.CallEventHandler( "clk_pasttransfer_end" );
    --cmn.ShowBbt( "bbt_livingroom_open" );

  end;

  cmn.CallEventHandler( "clk_pasttransfer_beg" );

  common_impl.InterfaceSetVisible( false );
  --ObjSet( "rm_policestation2", { color_r = 0, color_g = 0, color_b = 0 } );
  common_impl.PlayDialogVideo( "vid_policestation2_past_transfer", func_end ); 

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_back_in_past" );

end;
-------------------------------------------------
-------------------------------------------------
function private.ClkLamp ()

  local func_end = function ()

    --cmn.ShowBbt( "bbt_pointer_use_handfulofnuts" );
    ObjSet( "anm_policestation2_lamp1", { alp = 1 } );
    ObjSet( "anm_policestation2_lamp2", { alp = 0 } );
    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/aud_lamp_xx" );
  ObjSet( "anm_policestation2_lamp1", { alp = 0 } );
  ObjSet( "anm_policestation2_lamp2", { alp = 1 } );

  AnimPlay( "anm_policestation2_lamp2", "DoAnim", func_end ); 

end;
-------------------------------------------------
function private.InitAnim ()

 ObjAnimate( "spr_policestation2_sunlight", "alp", 1, 0, "",
  { 
    0.0, 0, 1,
    1, 0, 0.5,
    2, 0, 1,
    3.4, 0, 0.1,
    4.2, 0, 1
  } );

end;
-------------------------------------------------
