-- name=rm_policestation3
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_policestation3";
  ObjSet( "obj_policestation3_clk_jackie_dialog_1",           { event_mdown = private.dlg_policestation3_jackie_1 } );
  ObjSet( "obj_policestation3_clk_jackie_dialog_1_focus",     { event_mdown = private.dlg_policestation3_jackie_1 } );
  ObjSet( "obj_policestation3_clk_lamp",                      { event_mdown = private.ClkLamp } );

  private.InitAnim();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_policestation3 = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gho_policestation3_crashreport"
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_policestation3", update_game_mode_policestation3, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_policestation3 () end;
  --------------------------------------------------------------------------------------------
  local opn_policestation3 = function ()


  end;

  cmn.AddSubscriber( "opn_policestation3", opn_policestation3 );
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_crashreport () end;
  --------------------------------------------------------------------------------------------
  local win_crashreport = function ()

    if cmn.IsEventDone( "win_crashreport" ) then
      ObjDelete( "spr_policestation3_ho" );
      ObjSet( "obj_policestation3_clk_jackie_dialog_1", { event_mdown = private.dlg_policestation3_jackie_2, input = true  } );
      ObjSet( "obj_policestation3_clk_jackie_dialog_1_focus", { event_mdown = private.dlg_policestation3_jackie_2 } );
    end;

  end;

  cmn.AddSubscriber( "win_crashreport", win_crashreport, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_bird_1 () end;
  --------------------------------------------------------------------------------------------
  local get_bird_1_inv = function ()

    int.InventoryItemAdd( "inv_bird" );

  end;

  cmn.AddSubscriber( "get_bird_1", get_bird_1_inv );

--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_hanky3 () end;
  --------------------------------------------------------------------------------------------
  local get_hanky3_inv = function ()

    int.InventoryItemAdd( "inv_hanky3" );

  end;

  cmn.AddSubscriber( "get_hanky3", get_hanky3_inv );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function dlg_policestation3_jackie_1 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_policestation3_jackie_1" ] =
  {
    type = "click",
    clk_obj = "obj_policestation3_clk_jackie_dialog_1",
    use_place = "obj_policestation3_clk_jackie_dialog_1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local dlg_policestation3_jackie_1_beg = function ()

  end;
  -----------------------------------------------
  local dlg_policestation3_jackie_1_end = function ()

    ObjSet( "gho_policestation3_crashreport", { active = true, input = true, alp = 1 } );
    ObjSet( "obj_policestation3_clk_jackie_dialog_1", { input = false  } );

  end;

  cmn.AddSubscriber( "dlg_policestation3_jackie_1", dlg_policestation3_jackie_1_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation3_jackie_1", dlg_policestation3_jackie_1_end, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation3_jackie_1_beg", dlg_policestation3_jackie_1_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation3_jackie_1_end", dlg_policestation3_jackie_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function dlg_policestation3_jackie_2 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_policestation3_jackie_2" ] =
  {
    type = "click",
    clk_obj = "obj_policestation3_clk_jackie_dialog_1",
    use_place = "obj_policestation3_clk_jackie_dialog_1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local dlg_policestation3_jackie_2_beg = function ()

  end;
  -----------------------------------------------
  local dlg_policestation3_jackie_2_end = function ()

  end;

  cmn.AddSubscriber( "dlg_policestation3_jackie_2", dlg_policestation3_jackie_2_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation3_jackie_2", dlg_policestation3_jackie_2_end, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation3_jackie_2_beg", dlg_policestation3_jackie_2_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation3_jackie_2_end", dlg_policestation3_jackie_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function see_pasttransfer3 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_pasttransfer3" ] =
  {
    type = "click",
    clk_obj = "obj_policestation3_clk_jackie_dialog_1",
    use_place = "obj_policestation3_clk_jackie_dialog_1",
    room = private.room_objname,
  };
  local see_pasttransfer3 = function ()

    ObjDelete( "obj_policestation3_clk_jackie_dialog_1" );

  end;

  cmn.AddSubscriber( "see_pasttransfer3", see_pasttransfer3 );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_policestation3 ()

  if not ( cmn.IsEventDone( "opn_policestation3" ) ) then

    cmn.SetEventDone( "opn_policestation3" );
    cmn.CallEventHandler( "opn_policestation3" );
    cmn.ShowBbt( "bbt_policestation3_open" );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopAllEnv( "audio/level1/env/aud_policestation_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_policestation_env", 1 );

  if not ( cmn.IsEventDone( "opn_policestation3" ) ) then

    cmn.SetEventDone( "get_bird_1" );
    cmn.SetEventDone( "get_hanky3" );
    cmn.CallEventHandler( "get_bird_1" );
    cmn.CallEventHandler( "get_hanky3" );

  end;

  if not cmn.IsEventDone( "win_crashreport" ) then

    if ( cmn.IsEventStart( "win_crashreport" ) ) then
      for i = 1,3 do
        if ( ng_global.progress["std"]["win_crashreport"].note[ i ][ 2 ] ) then

          ObjSet( "spr_policestation3_task"..i, { alp = 1 } );

        end;
      end;

    end;

  else 
    ObjDelete( "spr_policestation3_ho" );
  end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_policestation3();

--  if ( cmn.IsEventDone( "win_crashreport" ) ) then
--
--    private.PastTransfer();
--
--  end;

end;
--*********************************************************************************************************************
-------------------------------------------------
function private.dlg_policestation3_jackie_1 ()

  ObjAttach( "dlg_policestation3_jackie_1", "rm_policestation3" );
  common_impl.dialog_character_loc = "";
  private.dialog_voices_time = { 3 };
  common_impl.DialogCharacterStart( "jackie_1", 4, nil, nil, false, 
    function () 
      cmn.ShowBbt( "bbt_policestation3_dlg1" );  
      cmn.CallEventHandler( "dlg_policestation3_jackie_1_end" );
      cmn.AddPageDiary( 13 );
    end );

  ObjSet( "tmr_policestation3_fordial", { playing = 1, time = 0.3, endtrig = "" } );

end;
-------------------------------------------------
-------------------------------------------------
function private.dlg_policestation3_jackie_2 ()

  ObjAttach( "dlg_policestation3_jackie_2", "rm_policestation3" );
  common_impl.dialog_character_loc = "";
  private.dialog_voices_time = { 3 };
  common_impl.DialogCharacterStart( "jackie_2", 1, nil, nil, false, 
    function () 
      cmn.CallEventHandler( "dlg_policestation3_jackie_2_end" );
      --cmn.AddPageDiary( 13 );
      private.PastTransfer ()
    end );

  ObjSet( "tmr_policestation3_fordial", { playing = 1, time = 0.3, endtrig = "" } );

end;
-------------------------------------------------
function private.PastTransfer ()

  local func_end = function ()

    int.Lock( false );
    cmn.StopAudio( "sfx", "audio/level3/sfx/aud_policestation3_past_transfer" );
    --cmn.StopAudio( "voc", "audio/level1/voc/aud_intro_voc" );
    --cmn.PlayAudio( "env", "audio/level1/env/aud_bypolicestation_env", 1 );
    cmn.SetEventDone( "see_pasttransfer3" );
    cmn.CallEventHandler( "see_pasttransfer3" );

    ObjSet( "rm_policestation3", { color_r = 0, color_g = 0, color_b = 0 } );

    cmn.GotoRoom( "rm_waitinghall" );
    --cmn.SetEventDone( "opn_controltower" );

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_policestation3_past_transfer", func_end );  

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_policestation3_past_transfer" );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_intro_voc" );

end;
-------------------------------------------------
function private.ClkLamp ()

  local func_end = function ()

    --cmn.ShowBbt( "bbt_pointer_use_handfulofnuts" );
    ObjSet( "anm_policestation3_lamp1", { alp = 1 } );
    ObjSet( "anm_policestation3_lamp2", { alp = 0 } );
    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/aud_lamp_xx" );
  ObjSet( "anm_policestation3_lamp1", { alp = 0 } );
  ObjSet( "anm_policestation3_lamp2", { alp = 1 } );

  AnimPlay( "anm_policestation3_lamp2", "DoAnim", func_end ); 

end;
-------------------------------------------------
function private.InitAnim ()

 ObjAnimate( "spr_policestation3_sunlight", "alp", 1, 0, "",
  { 
    0.0, 0, 1,
    1, 0, 0.5,
    2, 0, 1,
    3.4, 0, 0.1,
    4.2, 0, 1
  } );

end;
-------------------------------------------------
