-- name=ho_hocabinet
function public.Init ()
  --------------------------------------------------------------------------------------------------

  room.Define( "ho_hocabinet" );
  game.relations[ "ho_hocabinet" ].exitroom = "rm_stewardessroom";
  private.room_objname = "ho_hocabinet";

  private.win_hocabinet = {};

  private.win_hocabinet.array_amulets = 
  {
    { "spr_hocabinet_barrette", "spr_hocabinet_fox",    "spr_hocabinet_skull" },
    { "spr_hocabinet_bow",      "spr_hocabinet_key",    "spr_hocabinet_rose" },
    { "spr_hocabinet_bracelet", "spr_hocabinet_mirror", "spr_hocabinet_shawl" },
    { "spr_hocabinet_flower",   "spr_hocabinet_ring",   "spr_hocabinet_star" }
  }
  
  --------------------------------------------------------------------------------------------
  -- function opn_hocabinet () end;
  --------------------------------------------------------------------------------------------
  local opn_hocabinet = function ()

  end;

  cmn.AddSubscriber( "opn_hocabinet", opn_hocabinet, private.room_objname );
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_hocabinet" ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hocabinet_func = function ()

    if ( cmn.IsEventDone( "win_hocabinet" ) ) then

      int.InventoryItemAdd( "inv_sparekey", "spr_hocabinet_win" );
      ObjDelete( "gho_stewardessroom_hocabinet" );
      ObjDelete( "obj_hocabinet_taskpanel" );

      ObjSet( "obj_int_taskpanel_task_1", { pos_x = 40, pos_y = 0 } );
      ObjSet( "obj_int_taskpanel_task_5", { pos_x = 40, pos_y = 22 } );
      ObjSet( "obj_int_taskpanel_task_9", { pos_x = 40, pos_y = 44 } );

      ObjSet( "obj_int_taskpanel_task_2", { pos_x = 220, pos_y = 0 } );
      ObjSet( "obj_int_taskpanel_task_6", { pos_x = 220, pos_y = 22 } );
      ObjSet( "obj_int_taskpanel_task_10", { pos_x = 220, pos_y = 4 } );

      ObjSet( "obj_int_taskpanel_task_3", { pos_x = 385, pos_y = 0 } );
      ObjSet( "obj_int_taskpanel_task_7", { pos_x = 385, pos_y = 22 } );
      ObjSet( "obj_int_taskpanel_task_11", { pos_x = 385, pos_y = 44 } );

      ObjSet( "obj_int_taskpanel_task_4", { pos_x = 550, pos_y = 0 } );
      ObjSet( "obj_int_taskpanel_task_8", { pos_x = 550, pos_y = 22 } );
      ObjSet( "obj_int_taskpanel_task_12", { pos_x = 550, pos_y = 44 } );

      ObjSet( "obj_int_taskpanel", { alp = 1 } );

      --int.DeleteTaskMap( "rm_stewardessroom", "win_hocabinet" );

    else 

      for i = 1, 4 do

          if ( ng_global.progress[ ng_global.currentprogress ][ "win_hocabinet" ].amulets_slot[ i ] == 0 ) then

            for j = 1, #private.win_hocabinet.array_amulets[ i ] do

              ObjSet( private.win_hocabinet.array_amulets[ i ][ j ], { input = false } );

            end;

          else 

            for j = 1, #private.win_hocabinet.array_amulets[ i ] do

              ObjSet( private.win_hocabinet.array_amulets[ i ][ j ], { input = true } );
              
              if  ( private.win_hocabinet.array_amulets[ i ][ j ] == "spr_hocabinet_skull" ) then
                
                for i = 1, 3 do
                  
                  ObjSet( "spr_hocabinet_skull_"..i, { input = true } );
                  
                end;
          
              end;
              
              if  ( private.win_hocabinet.array_amulets[ i ][ j ] == "spr_hocabinet_barrette" ) then
                
                for i = 1, 2 do
                  
                  ObjSet( "spr_hocabinet_barrette_"..i, { input = true } );
                  
                end;
          
              end;
              
              if  ( private.win_hocabinet.array_amulets[ i ][ j ] == "spr_hocabinet_bow" ) then
                
                for i = 1, 3 do
                  
                  ObjSet( "spr_hocabinet_bow_"..i, { input = true } );
                  
                end;
          
              end;
              
              if  ( private.win_hocabinet.array_amulets[ i ][ j ] == "spr_hocabinet_key" ) then
                
                for i = 1, 3 do
                  
                  ObjSet( "spr_hocabinet_key_"..i, { input = true } );
                  
                end;
          
              end; 
              
              if  ( private.win_hocabinet.array_amulets[ i ][ j ] == "spr_hocabinet_mirror" ) then
                
                for i = 1, 3 do
                  
                  ObjSet( "spr_hocabinet_mirror_"..i, { input = true } );
                  
                end;
          
              end; 
              
              if  ( private.win_hocabinet.array_amulets[ i ][ j ] == "spr_hocabinet_ring" ) then
                
                for i = 1, 2 do
                  
                  ObjSet( "spr_hocabinet_ring_"..i, { input = true } );
                  
                end;
          
              end;  
              
              if  ( private.win_hocabinet.array_amulets[ i ][ j ] == "spr_hocabinet_shawl" ) then
                
                for i = 1, 2 do
                  
                  ObjSet( "spr_hocabinet_shawl_"..i, { input = true } );
                  
                end;
          
              end;  
              
              if  ( private.win_hocabinet.array_amulets[ i ][ j ] == "spr_hocabinet_star" ) then
                
                for i = 1, 2 do
                  
                  ObjSet( "spr_hocabinet_star_"..i, { input = true } );
                  
                end;
          
              end;  
              
            end;


          end;

          if ( ng_global.progress[ ng_global.currentprogress ][ "win_hocabinet" ].amulets_slot[ i ] == 1 ) then

              ObjDelete( "obj_hocabinet_amulet_"..i );

          end;

          if ( ng_global.progress[ ng_global.currentprogress ][ "win_hocabinet" ].amulets[ i ] == 1 ) then

              ObjDelete( "spr_hocabinet_amulet_"..i );
              ObjDelete( "spr_hocabinet_amulet_"..i.."_shadow" );
              
          end;
            
      end;

    end;

  end;
  cmn.AddSubscriber( "win_hocabinet", win_hocabinet_func );
  --------------------------------------------------------------------------------------------------
  local start_hocabinet_func = function ()

    if ( cmn.IsEventStart( "win_hocabinet" ) ) then

        common_impl.ProcessHoStart( "hocabinet" );

        local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_hocabinet" ].found;

        for i = 1, #ho_found, 1 do

            ObjDelete( ho_found[ i ][ "object" ] );

        end;

    end;

  end;
  cmn.AddSubscriber( "win_hocabinet", start_hocabinet_func, "ho_hocabinet" );
  --------------------------------------------------------------------------------------------------

  private.win_hocabinet.task = { "barrette", "bow", "bracelet", "flower", "fox", "key", "mirror", "ring", "skull", "rose", "shawl", "star" };

  for i = 1, #private.win_hocabinet.task do

    ObjSet( "spr_hocabinet_"..private.win_hocabinet.task[ i ], { event_mdown = function() private.CompleteTask( private.win_hocabinet.task[ i ] ); end, input = false } );

  end;

  for i = 1, 4 do

    ObjSet( "spr_hocabinet_amulet_"..i, { event_mdown = function() private.GetAmulet( i ); end, event_dragdrop = function() private.UseAmulet ( i ); end } );

  end;
  
  for i = 1, 3 do
    
    ObjSet( "spr_hocabinet_skull_"..i, { event_mdown = function() private.CompleteTask( "skull", i ); end, input = false } );
    ObjSet( "spr_hocabinet_bow_"..i,   { event_mdown = function() private.CompleteTask( "bow", i ); end, input = false } );
    ObjSet( "spr_hocabinet_key_"..i,   { event_mdown = function() private.CompleteTask( "key", i ); end, input = false } );
    ObjSet( "spr_hocabinet_mirror_"..i,{ event_mdown = function() private.CompleteTask( "mirror", i ); end, input = false } );
     
  end;
  
  for i = 1, 2 do
    
    ObjSet( "spr_hocabinet_barrette_"..i, { event_mdown = function() private.CompleteTask( "barrette", i ); end, input = false } );
    ObjSet( "spr_hocabinet_ring_"..i,     { event_mdown = function() private.CompleteTask( "ring", i ); end, input = false } );
    ObjSet( "spr_hocabinet_shawl_"..i,    { event_mdown = function() private.CompleteTask( "shawl", i ); end, input = false } );
    ObjSet( "spr_hocabinet_star_"..i,     { event_mdown = function() private.CompleteTask( "star", i ); end, input = false } );
    
  end;
  -------------------------------------------------
end;
-------------------------------------------------
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  if ( not cmn.IsEventStart( "win_hocabinet" ) ) then

      cmn.InitHo( "hocabinet" );

  end;

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_hocabinet" ) ) then

      cmn.SetEventDone( "opn_hocabinet" );
      cmn.CallEventHandler( "opn_hocabinet" );

      ng_global.progress[ ng_global.currentprogress ][ "win_hocabinet" ].amulets          = { 0, 0, 0, 0 };
      ng_global.progress[ ng_global.currentprogress ][ "win_hocabinet" ].amulets_slot     = { 0, 0, 0, 0 };
      ng_global.progress[ ng_global.currentprogress ][ "win_hocabinet" ].amulet_items     = { { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 } };
      --ng_global.progress[ ng_global.currentprogress ][ "win_hocabinet" ].amulet_items_use = { 0, 0, 0, 0 };

  end;

  local ho_tasks = {};

  --interface.TaskPanelTaskAdd( ho_tasks, "barrette", 1, 0, { { "spr_hocabinet_barrette"        } } );
  interface.TaskPanelTaskAdd( ho_tasks, "barrette", 2, 0, { { "spr_hocabinet_barrette_1", "spr_hocabinet_barrette_2" } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "bow",      1, 0, { { "spr_hocabinet_bow"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "bow",      3, 0, { { "spr_hocabinet_bow_1", "spr_hocabinet_bow_2", "spr_hocabinet_bow_3" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "bracelet", 1, 0, { { "spr_hocabinet_bracelet"  } } );
  interface.TaskPanelTaskAdd( ho_tasks, "flower",   1, 0, { { "spr_hocabinet_flower" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "fox",      1, 0, { { "spr_hocabinet_fox"     } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "key",      1, 0, { { "spr_hocabinet_key"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "key",      3, 0, { { "spr_hocabinet_key_1", "spr_hocabinet_key_2", "spr_hocabinet_key_3" } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "mirror",   1, 0, { { "spr_hocabinet_mirror"      } } );
  interface.TaskPanelTaskAdd( ho_tasks, "mirror",   3, 0, { { "spr_hocabinet_mirror_1", "spr_hocabinet_mirror_2", "spr_hocabinet_mirror_3" } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "ring",     1, 0, { { "spr_hocabinet_ring"      } } );
  interface.TaskPanelTaskAdd( ho_tasks, "ring",     2, 0, { { "spr_hocabinet_ring_1", "spr_hocabinet_ring_2" } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "skull",    1, 0, { { "spr_hocabinet_skull"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "skull",    3, 0, { { "spr_hocabinet_skull_1", "spr_hocabinet_skull_2", "spr_hocabinet_skull_3" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "rose",     1, 0, { { "spr_hocabinet_rose"       } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "shawl",    1, 0, { { "spr_hocabinet_shawl" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "shawl",    2, 0, { { "spr_hocabinet_shawl_1", "spr_hocabinet_shawl_2" } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "star",     1, 0, { { "spr_hocabinet_star"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "star",     2, 0, { { "spr_hocabinet_star_1", "spr_hocabinet_star_2" } } );
  
  interface.TaskPanelTaskAdd( ho_tasks, "amulet1",  1, 0, { { "spr_hocabinet_amulet_1", "obj_hocabinet_amulets_1_1", "obj_hocabinet_amulets_1_2", "obj_hocabinet_amulets_1_3", "obj_hocabinet_amulets_1_4" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "amulet2",  1, 0, { { "spr_hocabinet_amulet_2", "obj_hocabinet_amulets_2_1", "obj_hocabinet_amulets_2_2", "obj_hocabinet_amulets_2_3", "obj_hocabinet_amulets_2_4" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "amulet3",  1, 0, { { "spr_hocabinet_amulet_3", "obj_hocabinet_amulets_3_1", "obj_hocabinet_amulets_3_2", "obj_hocabinet_amulets_3_3", "obj_hocabinet_amulets_3_4" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "amulet4",  1, 0, { { "spr_hocabinet_amulet_4", "obj_hocabinet_amulets_4_1", "obj_hocabinet_amulets_4_2", "obj_hocabinet_amulets_4_3", "obj_hocabinet_amulets_4_4" } } );

  int.TaskPanelShow( ho_tasks );
  private.Panel();
  --ng_global.progress[ prg.current ][ "win_hocabinet" ].start = 1;

  common_impl.StopMusEnv( false );

--  cmn.StopAllEnv( "audio/level1/env/aud_kitchen_env" );
--
--  cmn.PlayAudio( "env", "audio/level1/env/aud_kitchen_env", 1 );
--  cmn.PlayAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 1 );

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "int_inventory_impl", { input = true } );
  ObjAttach( "obj_hocabinet_taskpanel","ho_hocabinet" );
  
end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  --cmn.StopAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 0.3 );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )
  
  local postfix = "";
  if number then postfix = "_"..number; end;
  
  cmn.HoTaskFind( "spr_hocabinet_"..name..postfix, name );
  common_impl.PassingHoCheck();

  local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_hocabinet" ].found;

  for i = 1, #ho_found, 1 do

    if ( ho_found[ i ][ "object" ] ) then

      for j = 1, 4 do

       for k = 1, 3 do

        if ( private.win_hocabinet.array_amulets[ j ][ k ] == ho_found[ i ][ "object" ] ) then

          number = j;
          ng_global.progress[ ng_global.currentprogress ][ "win_hocabinet" ].amulet_items[ j ][ k ] = 1;

          break;

        end;

       end;

      end;

    end;

  end;

end;
--*********************************************************************************************************************
function private.Panel ( )

  ObjSet( "obj_hocabinet_taskpanel", { alp = 1 } );
  ObjSet( "int_inventory_impl", { input = false } );

  ObjAttach( "obj_hocabinet_taskpanel","int_taskpanel_impl" );

  for i = 1, 4 do

      if ( ng_global.progress[ ng_global.currentprogress ][ "win_hocabinet" ].amulets_slot[ i ] == 0 ) then

          for j = 1, #private.win_hocabinet.array_amulets[ i ] do

              ObjSet( private.win_hocabinet.array_amulets[ i ][ j ], { input = false } );

          end;

      end;

  end;

  ObjSet( "obj_int_taskpanel", { alp = 1 } );

  ObjSet( "obj_int_taskpanel_task_1",  { pos_x = 65, pos_y = 0 } );
  ObjSet( "obj_int_taskpanel_task_5",  { pos_x = 65, pos_y = 20 } );
  ObjSet( "obj_int_taskpanel_task_9",  { pos_x = 65, pos_y = 40 } );

  ObjSet( "obj_int_taskpanel_task_2",  { pos_x = 221, pos_y = 0 } );
  ObjSet( "obj_int_taskpanel_task_6",  { pos_x = 221, pos_y = 20 } );
  ObjSet( "obj_int_taskpanel_task_10", { pos_x = 221, pos_y = 40 } );

  ObjSet( "obj_int_taskpanel_task_3",  { pos_x = 375, pos_y = 0 } );
  ObjSet( "obj_int_taskpanel_task_7",  { pos_x = 375, pos_y = 20 } );
  ObjSet( "obj_int_taskpanel_task_11", { pos_x = 375, pos_y = 40 } );

  ObjSet( "obj_int_taskpanel_task_4",  { pos_x = 530, pos_y = 0 } );
  ObjSet( "obj_int_taskpanel_task_8",  { pos_x = 530, pos_y = 20 } );
  ObjSet( "obj_int_taskpanel_task_12", { pos_x = 530, pos_y = 40 } );

end;
--*********************************************************************************************************************

function private.GetAmulet ( num )

  cmn.GetObjectSfx();
  ObjAttach( "spr_hocabinet_amulet_"..num, "int_taskpanel_impl" );
  ObjSet( "spr_hocabinet_amulet_"..num, { pos_z = 5 } );
  ObjSet( "spr_hocabinet_amulet_"..num.."_shadow", { alp = 0 } );

end;
--*********************************************************************************************************************
function private.UseAmulet ( num )

  local item = "spr_hocabinet_amulet_"..num;
  local bool = true;
  SetCursor( CURSOR_DEFAULT );

  for i = 1,4 do

      if ( ObjIntersect( item, "obj_hocabinet_amulet_"..i ) ) then

          bool = false;
          int.Lock( true );
          parent_obj = "ho_hocabinet";

          local func_end = function ()

              private.UseAmuletEnd( num, i );

          end;          

          ObjDelete( item );
          
          cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_slidepanel" ); 

          ObjAnimate( "spr_hocabinet_amulets_"..i.."_amulet", "alp", 0, 0, "", 
          { 
            0.0,  0,  0,
            0.3,  0,  1,
          } );
          ObjAnimate( "obj_hocabinet_amulet_"..i, "pos_y", 0, 0, func_end, 
          { 
            0.0,  0,  20,
            0.3,  0,  20,
            0.8,  1,  150
          } );

          break;

      end;

  end;

  if ( bool ) then

      ObjAttach( "spr_hocabinet_amulet_"..num, "obj_hocabinet_amulet" );
      ObjSet( "spr_hocabinet_amulet_"..num, { pos_z = 0 } );
      ObjSet( "spr_hocabinet_amulet_"..num.."_shadow", { alp = 1 } );
      cmn.WrongApply();

  end;

end;
--*********************************************************************************************************************
function private.UseAmuletEnd( num1, num2 )

  ng_global.progress[ ng_global.currentprogress ][ "win_hocabinet" ].amulets[ num1 ] = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_hocabinet" ].amulets_slot[ num2 ] = 1;

  private.CompleteTask( "amulet"..num1 );

  for i = 1,#private.win_hocabinet.array_amulets[ num2 ] do

      ObjSet( private.win_hocabinet.array_amulets[ num2 ][ i ], { input = true } );
      
      if  ( private.win_hocabinet.array_amulets[ num2 ][ i ] == "spr_hocabinet_skull" ) then
        
        for i = 1, 3 do
          
          ObjSet( "spr_hocabinet_skull_"..i, { input = true } );
          
        end;
  
      end;
            
      if  ( private.win_hocabinet.array_amulets[ num2 ][ i ] == "spr_hocabinet_bow" ) then
        
        for i = 1, 3 do
          
          ObjSet( "spr_hocabinet_bow_"..i, { input = true } );
          
        end;
  
      end;
      
      if  ( private.win_hocabinet.array_amulets[ num2 ][ i ] == "spr_hocabinet_skull" ) then
        
        for i = 1, 2 do
          
          ObjSet( "spr_hocabinet_barrette_"..i, { input = true } );
          
        end;
  
      end;
      
      if  ( private.win_hocabinet.array_amulets[ num2 ][ i ] == "spr_hocabinet_key" ) then
        
        for i = 1, 3 do
          
          ObjSet( "spr_hocabinet_key_"..i, { input = true } );
          
        end;
  
      end;
      
      if  ( private.win_hocabinet.array_amulets[ num2 ][ i ] == "spr_hocabinet_mirror" ) then
        
        for i = 1, 3 do
          
          ObjSet( "spr_hocabinet_mirror_"..i, { input = true } );
          
        end;
  
      end; 
      
      if  ( private.win_hocabinet.array_amulets[ num2 ][ i ] == "spr_hocabinet_shawl" ) then
        
        for i = 1, 2 do
          
          ObjSet( "spr_hocabinet_shawl_"..i, { input = true } );
          
        end;
  
      end; 
      
      if  ( private.win_hocabinet.array_amulets[ num2 ][ i ] == "spr_hocabinet_star" ) then
        
        for i = 1, 2 do
          
          ObjSet( "spr_hocabinet_star_"..i, { input = true } );
          
        end;
  
      end;
      
      if  ( private.win_hocabinet.array_amulets[ num2 ][ i ] == "spr_hocabinet_ring" ) then
        
        for i = 1, 2 do
          
          ObjSet( "spr_hocabinet_ring_"..i, { input = true } );
          
        end;
  
      end;        
  end;
    
  int.Lock( false ); 

  ObjDelete( "obj_hocabinet_amulet_"..num2 );

end;
--*********************************************************************************************************************