-- name=levelscr

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 20 );

--  if IsCollectorsEdition() then
--
--    interface.WidgetAdd( InterfaceWidget_BtnGuide, 20 );
--
--  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  --interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  --interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  --interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  --interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

--  interface.WidgetAdd( InterfaceWidget_Effects, 11 );
--
--  interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );

  --interface.WidgetAdd( InterfaceWidget_DialogHo, 19 );

  interface.ButtonLockAdd();
  --interface.LockAdd();

  --interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  --interface.WidgetAdd( InterfaceWidget_ItemPanel );
  --interface.WidgetAdd( InterfaceWidget_Popup, 27 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog, 26 );

  --interface.WidgetAdd( InterfaceWidget_DialogVideo, 26 );
  --interface.WidgetAdd( InterfaceWidget_DialogStory );
  --interface.WidgetAdd( InterfaceWidget_DialogCharacter, 19 );

  --interface.WidgetAdd( InterfaceWidget_StrategyGuide, 23 );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial, 30 );

  --interface.WidgetAdd( InterfaceWidget_Map, 26  );

  --interface.PanelNotificationAdd();
  --interface.DeployInvAdd( 9 );
  int.DialogHintAdd( 10 );
  --interface.ButtonTaskAdd( 1 );
  --interface.DialogTaskAdd( 20 );  
  --interface.DiaryAdd( 28 );

  interface.IntTaskpanelScrAdd( 5 );
  interface.IntMorphScrAdd( 5 );
  interface.IntTimerScrAdd( 5 );
  interface.IntDialogScrAdd( 19 );

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then
--
--    interface.BtnCollectibles2Add( 18 );
--    interface.BtnCollectiblesAdd( 18 );
    interface.AchievementsAdd( 18 );
--    interface.BtnMorphAdd( 18 );
--
  end;
  cmn.SecretroomInit();
  private.Init(); 
  --cmn.SecretroomInit();
  common.LevelLoad( "levelscr", "scr", "rm_waitinghall_scr", param, private.menu_moduls );
  cmn.MorphingSecretLoad();
  private.TutorialSetParams();
  --interface.KeyUpdate();

  --cmn.PlayMusEnv();

  int_timer_scr.SetTimer();
  int_taskpanel_scr.UpdateAchievpanel();

  ng_global.secret.game = false;

--  end;
--
end;
    
function private.Init ()

  game = {};
  game.room_names =  {
     "rm_waitinghall_scr"
    ,"rm_window_scr"
    ,"rm_technicalroom_scr"
    ,"rm_secondfloorcorridor_scr"
    ,"rm_aircompaniesstand_scr"
  };

   game.progress_names_room =
  {
     { "opn_waitinghall_scr" }
    ,{ "opn_window_scr" }
    ,{ "opn_technicalroom_scr" }
    ,{ "opn_secondfloorcorridor_scr" }
    ,{ "opn_aircompaniesstand_scr" }

    ,{ "get_roses_scr" }
    ,{ "get_knives_scr" }
    ,{ "get_fire_scr" }
    ,{ "get_planes_scr" }
    ,{ "get_cursed_tickets_scr" }
    ,{ "get_cards_of_destiny_scr" }
    
  };

  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      --"rm_collectibles2"
      --,"rm_collectibles"
      "rm_achievements"
    }

    for i = 1, #menu_moduls_ce do

      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );

    end;

  end;



end;
-------------------------------------------------
function private.TutorialSetParams ()

  if not ng_global.progress[ "scr" ][ "see_tutorial_scr" ] then

    ng_global.progress[ "scr" ][ "see_tutorial_scr" ] = {};
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].done  = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].start = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state = {};
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.no  = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].func = function()
      --
    end;

    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );      

    end;

    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.pages = {

      [ "tutorial_page_1_scr" ] = { shown = 0, noskip = true, posx = 512, posy = 200, arrows = { } }, -- о начале сикретрума

      [ "tutorial_page_2_scr" ] = { shown = 0, noskip = false, posx = 550, posy = 380, arrows = {
                                                                                    { pos_x = 220, pos_y = 50, ang =  1.3, target = "obj_int_morph_scr" }
                                                                                  } } , -- что искать и сколько искать
      [ "tutorial_page_3_scr" ] = { shown = 0, noskip = false, posx = 500, posy = 450, arrows = {
                                                                                    { pos_x = 800, pos_y = 570, ang =  -2.1, target = "int_timer_scr" }
                                                                                  } } , -- показать на таймер
      [ "tutorial_page_4_scr" ] = { shown = 0, noskip = false, posx = 512, posy = 384, arrows = {
                                                                                    { pos_x = 350, pos_y = 550, ang =  2.9 },
                                                                                    { pos_x = 650, pos_y = 550, ang =  -2.9 }
                                                                                  } } , -- показать на панель ачивок и прогресса
      [ "tutorial_page_5_scr" ] = { shown = 0, noskip = false, posx = 550, posy = 380, arrows = {
                                                                                    { pos_x = 220, pos_y = 50, ang =  1.3, target = "obj_int_morph_scr" }
                                                                                  } } , -- показать, что становится серым когда взяли все предметы в этой локи
      [ "tutorial_page_6_scr" ] = { shown = 0, noskip = false, posx = 512, posy = 384, arrows = {
                                                                                    { pos_x = 512, pos_y = 550, ang =  3.14 }
                                                                                  } } , -- показать на прогресс бар после первого этапа сикретрума

    };

  end;

end;