-- name=int_button_map
--******************************************************************************************
function public.Init( pos_z )

  interface.LoadImplementation( "button_map" );
  ObjAttach( "int_button_map", interface.originhub );
  ObjSet( "int_button_map", { pos_z = pos_z } );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  private.event_anim_end = {};

end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function public.MouseDown()

  MsgSend( Event_ButtonMap_Click, {} );

end;
--******************************************************************************************
function private.WideScreenUpdate()

  interface.WideScreenUpdate( "button_map" );

end;
--******************************************************************************************
