-- name=int_dialog_impl
--******************************************************************************************
function public.Init ()

  public.GRID_CORNER_W =  50;
  public.GRID_CORNER_H =  50;
  public.GRID_MID_W    =   8;
  public.GRID_MID_H    =   8;

  public.GRID_BORDER_W = 300;
  public.GRID_BORDER_H = 200;

  public.MIN_W = 200;
  public.MAX_W = 400;
  public.MIN_H = 100;
  public.MAX_H = 500;

  private.SHOW_ANIM_TIME = 0.3;
  ObjSet( "obj_dialog_transpanent", {
    event_mdown = int_dialog.MouseDown
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local trg = function () int_dialog.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_dialog", "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local trg = function () int_dialog.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_dialog", "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );

end;
--******************************************************************************************