-- name=room_impl
--********************************************************************************************************************
function public.Init()

  public.VIA_BLACK_SCREEN = true;
  public.BLACK_NAME = "spr_room_black_screen";
  private.FADE_TIME = 1.0;

end;
--********************************************************************************************************************
function public.Hide( event_id, obj_name )

  local trg = function() room.EventAnimEnd( event_id ); end;
  ObjAnimate( obj_name, "alp", 0, 0, trg, {0,0,1, private.FADE_TIME,0,0} );

end;
--********************************************************************************************************************
function public.Show( event_id, obj_name )
 
  local trg = function() room.EventAnimEnd( event_id ); end;
  ObjAnimate( obj_name, "alp", 0, 0, trg, {0,0,0, private.FADE_TIME,0,1} );

end;
--********************************************************************************************************************
function public.HideBlack( event_id )

  local trg = function() room.EventAnimEnd( event_id ); end;
  ObjAnimate( public.BLACK_NAME, "alp", 0, 0, trg, {0,0,1, private.FADE_TIME/2,0,0} );

end;
--********************************************************************************************************************
function public.ShowBlack( event_id )
 ObjSet("spr_room_black_screen",{ pos_x = 512, pos_y = 384, scale_x = 21.3438, scale_y = 12 });
  local trg = function() room.EventAnimEnd( event_id ); end;
  ObjAnimate( public.BLACK_NAME, "alp", 0, 0, trg, {0,0,0, private.FADE_TIME/2,0,1} );

end;
--********************************************************************************************************************