-- name=level2

function public.Start ( param )

  int.WidgetAdd( InterfaceWidget_Pause, 1800 );

  int.WidgetAdd( InterfaceWidget_BtnMenu, 12 );


  int.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  int.WidgetAdd( InterfaceWidget_BtnSkip, 9 );
  int.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  int.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  int.WidgetAdd( InterfaceWidget_Inventory, 21 );
  int.WidgetAdd( InterfaceWidget_TaskPanel, 22 );
  int.WidgetAdd( InterfaceWidget_ItemPanel, 22 );

  int.WidgetAdd( InterfaceWidget_Effects, 23 );

  int.WidgetAdd( InterfaceWidget_BtnMap, 13 );

  int.WidgetAdd( InterfaceWidget_DialogHo );

  int.ButtonLockAdd();

  int.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  int.WidgetAdd( InterfaceWidget_Popup, 31 );

  int.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  int.WidgetAdd( InterfaceWidget_Dialog );

  int.WidgetAdd( InterfaceWidget_DialogVideo, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogStory, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogCharacter, 1491 );

  int.WidgetAdd( InterfaceWidget_StrategyGuide );
  int.WidgetAdd( InterfaceWidget_Window );

  int.WidgetAdd( InterfaceWidget_Tutorial );
  int.WidgetAdd( InterfaceWidget_Map, 24  );

  int.PanelNotificationAdd();
  int.DeployInvAdd(9);
  int.DialogHintAdd( 10 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );
  int.InitMiniho( 18 );

  ObjSet( "int_button_map_impl",
  {
    alp = 0,
    input = false,
    visible = true,
    active = true
  } );   
  
  --
  private.Init();
  ModLoad( "assets/levels/level2/mod_level2_inv" );
  level2_inv.Init();
  --
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

  int.WidgetAdd( InterfaceWidget_BtnGuide, 10 );    
    interface.AchievementsAdd( 10 );
    int.MorphingAdd( 10 );
    int.CollectiblesAdd( 10 );
    int.Collectibles2Add( 22 );

  end;  

  common.LevelLoad( "level2", "std", "rm_policestation2", param, private.menu_moduls );
  
  private.TutorialSetParams(); 
  interface.KeyUpdate(); 
  int.UpdateTask( 2 );
  
    if not IsCollectorsEdition() and not IsSurveyEdition() then

    ObjSet( "btn_map_button_diary", { pos_x = 10 } );
    ObjSet( "btn_map_button_collectibles", { visible = 0, active = 0, input = 0  } );
    ObjSet( "btn_map_button_achievements", { visible = 0, active = 0, input = 0  } );    

    local collect = 
    {
      "get_collect2_2_1"
      ,"get_collect2_2_2"
      ,"get_collect2_2_3"
      ,"get_collect2_2_4"
    }
    local collect_morph = 
    {
      "get_morphobject_2_1"
      ,"get_morphobject_2_2"
      ,"get_morphobject_2_3"
      ,"get_morphobject_2_4"
      ,"get_morphobject_2_5"
      ,"get_morphobject_2_6"
    };

    for i = 1, #collect do
      cmn.SetEventDone( collect[ i ] );
      cmn.CallEventHandler( collect[ i ] );
    end;
    for i = 1, #collect_morph do
      cmn.SetEventDone( collect_morph[ i ] );
      cmn.CallEventHandler( collect_morph[ i ] );
    end;

  end;

end;

function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_policestation2"
    ,"rm_livingroom"
    ,"rm_yard"
    ,"rm_kitchen"
    ,"rm_office"
    ,"rm_basement"
    ,"rm_switchroom"
    ,"ho_investigatorsdesk2"
    ,"ho_dollhouse"    
    ,"ho_inbasement"
    ,"mg_onsafedoor"
    ,"mg_darkness"    
    ,"mg_repair"
  };

  game.progress_names =
  {
   "beg_level2"
  ,"opn_policestation2"
  ,"dlg_policestation2_policeman_1"
  ,"get_lighter2"
  ,"get_coins_2"
  ,"clk_dlg"
  ,"opn_investigatorsdesk2"
  ,"win_investigatorsdesk2"
  ,"clk_pasttransfer"
  --,"get_apartment_planning"

  ,"opn_livingroom"
  ,"clk_livingroom_survey"
  ,"clk_vid_inyard"
  ,"get_brokenelectricscrewdriver"
  ,"get_casebutton"
  ,"clk_harebackopen"
  ,"get_battery"
  ,"clk_openstand"
  ,"use_casebutton"
  ,"clk_casebutton"
  ,"get_screwdriverrmanual"
  ,"get_screwdrivercap"
  ,"use_screwdriverrmanual"
  ,"clk_battery_cover"
  ,"use_battery"
  ,"use_screwdrivercap"
  ,"win_brokenelectricscrewdriver"
  ,"get_screwdriver2"
  ,"use_screwdriver2"
  ,"clk_door"
  ,"clk_cabinet_2"

  ,"opn_kitchen"
  ,"get_butler"
  ,"get_spraynozzle"
  ,"get_hanky2"
  ,"use_spraynozzle"
  ,"get_cleaner"
  ,"use_cleaner"
  ,"get_penguin_1"
  ,"get_penguin_2"
  ,"use_butler"
  ,"use_penguin_1"
  ,"use_penguin_2"
  ,"opn_dollhouse"
  ,"win_dollhouse"
  ,"clk_doll"
  ,"get_counterbutton"
  ,"get_snailamulet_1"
  ,"use_counterbutton"
  ,"clk_counterbutton"
  ,"get_wire"
  ,"use_wire"

  ,"opn_office"
  ,"get_bell_1"
  ,"get_airplanewing"
  ,"get_fountainpen"
  ,"use_fountainpen"
  ,"get_airplanenose"
  ,"get_pliers2"
  ,"use_airplanewing"
  ,"use_airplanenose"
  ,"get_signet"
  ,"use_signet"
  ,"get_boathook"
  ,"get_snailamulet_2"
  ,"use_boathook"
  ,"get_artificialflower_1"
  ,"use_snailamulet_1"
  ,"use_snailamulet_2"
  ,"get_artificialflower_2"
  ,"use_artificialflower_1"
  ,"use_artificialflower_2"
  ,"win_wallhangingcabinet"
  ,"get_rubbergloves"
  ,"get_insulatingtape"
  ,"use_insulatingtape_1"
  ,"get_boxkey"
  ,"use_boxkey"
  ,"clk_boxkey"
  ,"get_documentfolder"
  ,"clk_documentfolder_closed"
  ,"clk_documentfolder_open_1"
  ,"get_razorblade"
  ,"get_doordowel_1"
  ,"use_razorblade"
  ,"get_slingshotframe"
  ,"use_slingshotframe"

  ,"opn_yard"
  ,"get_brokenbutterfly"
  ,"get_butterflypart_1"
  ,"get_butterflypart_2"
  ,"get_butterflypart_3"
  ,"use_butterflypart_1"
  ,"use_butterflypart_2"
  ,"use_butterflypart_3"
  ,"get_butterfly"
  ,"use_butterfly"
  ,"get_pearl"
  ,"use_pearl"
  ,"get_tongs" 
  ,"use_tongs"
  ,"get_sausage"
  ,"use_sausage"
  ,"use_coins_2"
  ,"get_newspaper"
  ,"get_wrappeditem"  
  ,"clk_wrappeditem_1"
  ,"clk_wrappeditem_2"
  ,"clk_wrappeditem_3"
  ,"get_catamulet"
  ,"use_catamulet"
  ,"get_fork"
  ,"use_pliers2"
  ,"get_twotinedfork"
  ,"use_twotinedfork"
  ,"get_doordowel_2"
  ,"see_yard_atropos"
  ,"use_newspaper"
  ,"use_lighter2"
  ,"win_darkness"
  ,"see_darkness_atropos"
  ,"clk_hook"
  ,"use_doordowel_2"
  ,"win_basemententrace"

  ,"opn_basement"
  ,"get_pruners"
  ,"get_hand_2"
  ,"get_mushroomsmold"
  ,"use_pruners"
  ,"get_hand_1"
  ,"use_hand_2"
  ,"get_cuckoo"
  ,"get_plasticscrew"
  ,"use_mushroomsmold"
  ,"use_plasticscrew"
  ,"clk_gas"
  ,"get_toymushroom"
  ,"use_toymushroom"
  ,"win_sandbox"
  ,"get_bell_2"
  ,"get_switchroomkey"
  ,"use_switchroomkey"
  ,"clk_key"
  ,"clk_handle_2"

  ,"opn_switchroom"
  ,"get_hammer2"
  ,"use_hammer2"
  ,"get_toggleswitch_1"
  ,"get_bucket"
  ,"use_bucket"
  ,"get_sandbucket"
  ,"use_sandbucket"
  ,"get_burntbag"
  ,"get_toggleswitch_2"
  ,"use_toggleswitch_1"
  ,"use_toggleswitch_2"
  ,"win_onsafedoor"
  ,"clk_safedoor"
  ,"get_file2"
  ,"get_bell_3"
  ,"use_file2"
  ,"opn_inbasement"
  ,"win_inbasement"
  ,"clk_oldchest"
  ,"get_knife"
  ,"get_ambereye_1"
  ,"use_bell_1"
  ,"use_bell_2"
  ,"use_bell_3"
  ,"win_icecreamvendor"
  ,"get_ambereye_2"
  ,"use_knife"
  ,"get_fuse_2"
  ,"get_electricplug"
  ,"use_ambereye_1"
  ,"use_ambereye_2"
  ,"get_switchroomplan"
  ,"clk_switchroomplan"
  ,"get_plan"
  ,"use_plan"
  ,"clk_cap"
  ,"use_rubbergloves"
  ,"use_insulatingtape_2"
  ,"clk_electricplug"
  ,"use_electricplug"
  ,"clk_fuse"
  ,"use_fuse_2"
  ,"win_repair"
  ,"get_morphobject_2_1"
  ,"get_morphobject_2_2"
  ,"get_morphobject_2_3"
  ,"get_morphobject_2_4"
  ,"get_morphobject_2_5"
  ,"get_morphobject_2_6"
  ,"get_collect2_2_1"
  ,"get_collect2_2_2"
  ,"get_collect2_2_3"
  ,"get_collect2_2_4"
  };

  game.relations = {};
  
  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      --"rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;  

end;

function private.TutorialSetParams()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function() end;
    
    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );

    end;

      ng_global.progress[ "std" ][ "see_tutorial" ].state.pages = {

      [ "tutorial_page_1" ] = { shown = 0, noskip = true, posx = 512, posy = 200, arrows = {} } , -- �������� ��������? 

      [ "tutorial_page_2" ] = { shown = 0, noskip = false, posx = 512, posy = 170, arrows = { 
                                                                              { pos_x = 230, pos_y = 200, ang =  2.0 }
                                                                            } },   -- �� �����

      [ "tutorial_page_3" ] = { shown = 0, noskip = false, posx = 512, posy = 330, arrows = { 
                                                                              { pos_x = 120, pos_y = 0, ang =  1.57, target = "obj_int_button_info" }
                                                                            } },   -- ������ ���� � ��
      [ "tutorial_page_4" ] = { shown = 0, noskip = false, posx = 512, posy = 330, arrows = { 
                                                                              { pos_x = 120, pos_y = 0, ang =  1.57,  target = "obj_int_button_reset" },
                                                                              { pos_x = 100, pos_y = -50, ang = -4,  target = "int_button_skip_impl" }
                                                                            } },   -- ������ ���� � ��
      [ "tutorial_page_5" ] = { shown = 0, noskip = false, posx = 600, posy = 320, arrows = { 
                                                                              { pos_x = -100, pos_y = -2, ang = -1.57, target = "obj_int_button_" }
                                                                            } },   -- ���� � ������ ���� � ���� ��� �������� ��������.
      [ "tutorial_page_6" ] = { shown = 0, noskip = false, posx = 600, posy = 350, arrows = { 
                                                                              { pos_x = -100, pos_y = 80, ang = -1.57, target = "obj_int_button_" }
                                                                            } },   -- ���� �� ������ � ������ �����.
      [ "tutorial_page_7" ] = { shown = 0, noskip = false, posx = 600, posy = 350, arrows = { 
                                                                              { pos_x = -100, pos_y = 176, ang = -1.57, target = "obj_int_button_" }
                                                                            } },   -- ������ ����� ���� ����.
      [ "tutorial_page_8" ] = { shown = 0, noskip = false, posx = 700, posy = 200, arrows = { 
                                                                              { pos_x = 850, pos_y = 400, ang = -2.3 }
                                                                            } },  -- 
      [ "tutorial_page_9" ] = { shown = 0, noskip = false, posx = 550, posy = 300, arrows = { 
                                                                              { pos_x = 800, pos_y = 250, ang = -1.2 }
                                                                            } },  -- ������� � �� ������ �����.
      [ "tutorial_page_10" ] = { shown = 0, noskip = fase, posx = 650, posy = 400, arrows = { 
                                                                              { pos_x = 50, pos_y = -50, ang =  2.14, target = "spr_deerhead_familyring"}
                                                                            } },   -- ������ �� ������.
      [ "tutorial_page_11" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                              { pos_x = 512, pos_y = 600, ang = 3.14 }
                                                                              --{ pos_x = 40, pos_y = 200, ang =  0.5 }
                                                                            } },   -- ������ �� ���������
      [ "tutorial_page_12" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 200, pos_y = 200, ang =  2.14 }
                                                                            } },   
      [ "tutorial_page_13" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 200, pos_y = 250, ang =  2.14 }
                                                                            } },   -- ������ �� ����� � �������
      [ "tutorial_page_14" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                              { pos_x = 512, pos_y = 600, ang = 3.14 }
                                                                            } },   -- ����� ��� ��������
      [ "tutorial_page_15" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                              { pos_x = 820, pos_y = 650, ang = 3.14 }
                                                                            } },   -- ���������� ��������
      [ "tutorial_page_16" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 450, pos_y = 360, ang =  2.3 }
                                                                            } },   -- 
      [ "tutorial_page_17" ] = { shown = 0, noskip = false, posx = 300, posy = 400, arrows = { 
                                                                              { pos_x = 130, pos_y = 0, ang = 2.3, target = "int_button_hint_impl" }
                                                                            } },   -- �� ����

      [ "tutorial_page_18" ] = { shown = 0, noskip = false, posx = 512, posy = 350, arrows = { 
                                                                              { pos_x = 100, pos_y = 0, ang =  1.6, target = "spr_focus_arrow_left" }
                                                                            } },   -- ������� �� �������
      --[ "tutorial_page_19" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
      --                                                                        { pos_x = 100, pos_y = 0, ang =  1.72, target = "spr_focus_arrow_right" },
      --                                                                        { pos_x = 100, pos_y = 0, ang =  1.72, target = "spr_focus_arrow_left" }
      --                                                                      } },   -- ???????? ?? ??????? 
      [ "tutorial_page_19" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                                    { pos_x = 512, pos_y = 600, ang = 3.14 }
                                                                                  } },   -- ��_����������
      [ "tutorial_page_20" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                                    { pos_x = 512, pos_y = 600, ang = 3.14 }
                                                                                  } },   -- ��_������ ������
      [ "tutorial_page_22" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                                    { pos_x = 0, pos_y = -80, ang = -3.14, target = "hub_int_inventory_messagebox" }
                                                                                  } },   -- ������� �����������
      [ "tutorial_page_23" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                                    { pos_x = 0, pos_y = -80, ang = -3.14, target = "hub_int_inventory_brokenfishingrod" }
                                                                                  } },   -- ������� �����������
      [ "tutorial_page_21" ] = { shown = 0, noskip = false, posx = 250, posy = 300, arrows = { 
                                                                              { pos_x = 500, pos_y = 350, ang = -1.5 }
                                                                              } },
      [ "tutorial_page_30" ] = { shown = 0, noskip = false, posx = 620, posy = 380, input = false, arrows = { 
                                                                              { pos_x = 0, pos_y = -90, ang = 3.14, target = "int_itempanel_impl" }, 
                                                                              { pos_x = 260, pos_y = 400, ang = 2.2 }  
                                                                            } },   -- ��_������ ������
      [ "tutorial_page_31" ] = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "int_itempanel_impl" },  
                                                                              { pos_x = 80, pos_y = -180, ang = -2.2, target = "int_itempanel_impl" }  
                                                                            } },                                                                                                                   
   };
    --end;
  end;

end;
--***********************************************************************************************************************************
--***********************************************************************************************************************************