-- name=levelext

function public.Start ( param )

  int.WidgetAdd( InterfaceWidget_Pause, 1800 );

  int.WidgetAdd( InterfaceWidget_BtnMenu, 12 );
  int.WidgetAdd( InterfaceWidget_BtnGuide, 10 );

  int.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  int.WidgetAdd( InterfaceWidget_BtnSkip, 9 );
  int.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  int.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --int.WidgetAdd( InterfaceWidget_TaskHeader );
  int.WidgetAdd( InterfaceWidget_Inventory, 21 );
  int.WidgetAdd( InterfaceWidget_TaskPanel, 22 );
  int.WidgetAdd( InterfaceWidget_ItemPanel, 22 );

  int.WidgetAdd( InterfaceWidget_Effects, 23 );

  int.WidgetAdd( InterfaceWidget_BtnMap, 13 );

  int.WidgetAdd( InterfaceWidget_DialogHo );

  int.ButtonLockAdd();

  int.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  int.WidgetAdd( InterfaceWidget_Popup, 31 );

  int.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  int.WidgetAdd( InterfaceWidget_Dialog );

  int.WidgetAdd( InterfaceWidget_DialogVideo, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogStory, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogCharacter, 1491 );

  int.WidgetAdd( InterfaceWidget_StrategyGuide );
  int.WidgetAdd( InterfaceWidget_Window );

  int.WidgetAdd( InterfaceWidget_Tutorial );
  int.WidgetAdd( InterfaceWidget_Map, 24  );
  int.PanelNotificationAdd();
  int.DeployInvAdd(9);
  int.DialogHintAdd( 10 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );
  int.InitMiniho( 18 );

  --
  private.Init();
  ModLoad( "assets/levels/levelext/mod_levelext_inv" );
  levelext_inv.Init();
  --

  interface.AchievementsAdd( 10 );
  int.MorphingAdd( 10 );
  int.CollectiblesAdd( 10 );
  int.Collectibles2Add( 22 );

  common.LevelLoad( "levelext", "ext", "rm_nearcar", param, private.menu_moduls );

  private.TutorialSetParams(); 
  interface.KeyUpdate(); 
  int.UpdateTask( 4 );  

end;

function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_nearcar"
    ,"rm_farm"
    ,"rm_cemetery"
    ,"rm_livingroomext"
    ,"rm_kitchenext"
    ,"rm_basementext"
    ,"rm_plane"
    ,"rm_stewardessroom"
    ,"rm_flightdeck"
    ,"mg_mgbook"
    ,"mg_mgstatue"
    ,"mg_lulling"
    ,"mg_mgfate"
    ,"ho_hoscrypt"
    ,"ho_house"
    ,"ho_hofridge"
    ,"ho_hocabinet"
  };

  game.progress_names =
  {
   "beg_levelext"
  ,"opn_nearcar"
  ,"dlg_nearcar_atropos_1"
  ,"see_maniac"
  ,"get_carvedhandle"
  ,"get_amuletcrypt_1"
  ,"use_carvedhandle"
  ,"get_chisel"
  ,"use_chisel"
  ,"get_spring_1"--континент_1
  ,"get_bone_1"
  
  ,"opn_farm"
  ,"use_bone_1"
  ,"get_amuletskull_1"
  ,"get_prunerpart_1"
  ,"get_button4"
  ,"use_button4"
  ,"clk_button4"
  ,"get_rivet"
  ,"get_tweezersext"
  ,"get_prunerpart_2"
  ,"use_tweezersext"
  ,"get_coinext"
  ,"get_grindstoneext"--точило
  ,"use_prunerpart_2"
  ,"use_rivet"--винтик
  ,"use_coinext"
  ,"use_grindstoneext"
  ,"get_prunerext"
  ,"use_prunerext"
  ,"win_gate"
  ,"get_amuletskull_2"
  ,"get_demonstatuette"
  ,"get_angelstatuette"
  ,"use_demonstatuette"
  ,"use_angelstatuette"
  ,"get_amuletskull_3"
  ,"get_basrelief_3"
  ,"use_amuletskull"
  ,"opn_mgbook"
  ,"win_mgbook"
  ,"get_book"
  ,"clk_book_1"
  ,"get_lens"
  ,"get_amuletspider"
  ,"use_amuletspider"
  ,"get_birdext_1"
  ,"get_carlever"
  ,"use_carlever"
  ,"clk_carlever"
  ,"get_amuletcrypt_2"
  ,"get_amuletgate_1"
  ,"use_amuletcrypt_1"
  ,"use_amuletcrypt_2"
  ,"opn_hoscrypt"
  ,"win_hoscrypt"
  ,"use_amuletgate_1"
  ,"use_amuletgate_2"
  
  ,"opn_cemetery"
  ,"get_pieceofiron"
  ,"use_pieceofiron"
  ,"get_shovelblade"
  ,"get_nippersext"
  ,"use_nippersext"
  ,"get_acidext"
  ,"get_stoneext"
  ,"get_nailsext"
  ,"use_acidext"
  ,"get_bowl_1"
  ,"get_saw"
  ,"use_saw"
  ,"get_stick"
  ,"use_stick"
  ,"use_nailsext"
  ,"use_stoneext_1"
  ,"get_shovelext"
  ,"use_shovelext"
  ,"get_basrelief_1"
  ,"get_balletdancer"
  ,"use_balletdancer"
  ,"get_yin"
  ,"get_basrelief_2"
  ,"use_basrelief"
  ,"win_zzbasrelief"
  ,"get_amuletgrave"
  ,"use_amuletgrave"
  ,"get_bone_2"
  ,"get_portrait_1"
  ,"get_skeletonkey"
  ,"use_bone_2"
  ,"get_portrait_2"
  ,"use_skeletonkey"
  ,"clk_skeletonkey"
  ,"get_dimgem"
  ,"get_amuletbook_1"
  ,"use_dimgem"
  ,"get_yang"
  ,"get_bluegem"
  ,"use_yin"
  ,"use_yang"
  ,"get_recipeext"
  ,"get_portrait_3"
  ,"use_portrait"
  ,"win_mgstatue"
  ,"get_brokenlantern"
  ,"clk_brokenlantern"
  ,"use_bluegem"
  ,"use_lens"
  ,"get_blacklantern"
  ,"use_blacklantern"
  ,"win_mirrors"
  ,"see_maniac_destruction"
  ,"dlg_nearcar_atropos_2"
  
  ,"opn_livingroomext"
  ,"get_pliersext"
  ,"use_pliersext"
  ,"get_amulethorror_1"
  ,"get_deskhandleext"
  ,"use_deskhandleext"
  ,"get_amuletbook_2"
  ,"get_blade"
  ,"use_blade"
  ,"get_amulethorror_2"
  ,"use_amulethorror_1"
  ,"use_amulethorror_2"
  ,"opn_house"
  ,"win_house"
  ,"use_amuletbook_1"
  ,"use_amuletbook_2"
  ,"clk_book_2"
  ,"get_amuletfire_2"
  ,"use_amuletfire_1"
  ,"use_amuletfire_2"
  
  ,"opn_kitchenext"
  ,"get_tongsext"
  ,"use_tongsext"
  ,"get_heart"
  ,"use_heart"
  ,"get_bowl_2"
  ,"use_bowl_1"
  ,"use_bowl_2"
  ,"win_windowext"
  ,"get_plane_1"
  ,"get_themis"
  ,"use_themis"
  ,"get_poisons"
  ,"use_poisons"
  ,"win_recipeext"
  ,"get_herbicide"
  ,"use_herbicide"
  ,"get_tombstonepart_1"
  ,"get_roomkeyext"
  ,"use_roomkeyext"
  ,"clk_roomkeyext"
  
  ,"opn_basementext"
  ,"get_brushext"
  ,"use_brushext"
  ,"get_amuletviolin"
  ,"use_amuletviolin"
  ,"get_buttonext_1"
  ,"get_trebleclef"
  ,"get_phoenixfeather_1"
  ,"use_trebleclef"
  ,"get_tuningforkext"
  ,"use_tuningforkext"
  ,"get_paints"
  ,"use_paints"
  ,"win_picture"
  ,"get_bronzering"
  ,"get_phoenixfeather_2"
  ,"get_fileext"
  ,"use_fileext_1"
  ,"get_chain"
  ,"use_fileext_2"
  ,"get_hookext"
  ,"use_chain"
  ,"get_chainwithhook"
  ,"use_chainwithhook"
  ,"clk_chain"
  ,"use_bronzering"
  ,"clk_chest"
  ,"get_spring_2"--континент_2
  ,"get_safehandle"
  ,"use_safehandle"
  ,"clk_safehandle"
  ,"get_phoenixfeather_3"
  ,"use_phoenixfeather"
  ,"win_phoenix"
  ,"get_bells"
  ,"use_bells"
  ,"clk_bells"
  ,"get_flute"
  ,"use_flute"
  ,"win_lulling"
  ,"dlg_kitchenext_atropos_3"
  
  ,"opn_plane"
  ,"get_screwdriverext"
  ,"use_screwdriverext_1"
  ,"get_dog"
  ,"use_dog"
  ,"get_handle4"
  ,"use_handle4"
  ,"get_scissorsext"
  ,"use_scissorsext"
  ,"get_plane_2"
  ,"use_plane"
  ,"get_stewardesskey"
  ,"use_stewardesskey"
  ,"clk_stewardesskey"
  
  ,"opn_stewardessroom"
  ,"get_magnet"
  ,"use_magnet"
  ,"get_spring_3"--континент_3
  ,"use_spring_1"
  ,"use_spring_2"
  ,"use_spring_3"
  ,"get_buttonext_2"
  ,"get_tombstonebasis"
  ,"get_glueext"
  ,"use_buttonext_1"
  ,"use_buttonext_2"
  ,"win_fridge"
  ,"get_tombstonepart_2"
  ,"use_tombstonepart_1"
  ,"use_tombstonepart_2"
  ,"use_glueext"
  ,"get_tombstone"
  ,"use_tombstone"
  ,"get_stewardessbadge"
  ,"use_stewardessbadge"
  ,"opn_hocabinet"
  ,"win_hocabinet"
  ,"use_sparekey"
  ,"clk_sparekey"
  
  ,"opn_flightdeck"
  ,"use_screwdriverext_2"
  ,"get_batteryext_1"
  ,"get_phonenumber_1"
  ,"use_phonenumber_1"
  ,"get_caduceus_1"
  ,"get_swissknife"
  ,"clk_swissknife_1"
  ,"clk_swissknife_2"  
  ,"get_corkscrewext"
  ,"get_batteryext_2"
  ,"use_corkscrewext"
  ,"get_caduceus_2"
  ,"use_caduceus_1"
  ,"use_caduceus_2"
  ,"get_gloveext"
  ,"get_bandage"
  ,"use_gloveext"
  ,"use_bandage"
  ,"get_radiobutton"
  ,"use_radiobutton"
  ,"clk_radiobutton"
  ,"get_phonenumber_2"
  ,"use_phonenumber_2"
  ,"get_birdext_2"
  ,"use_birdext_1"
  ,"use_birdext_2"
  ,"get_brokenflashlight"
  ,"clk_open"
  ,"get_wrenchext"
  ,"use_wrenchext"
  ,"get_bulbext"
  ,"use_bulbext"
  ,"use_batteryext"
  ,"clk_close"
  ,"clk_button"
  ,"get_flashlight"
  ,"use_flashlight"
  ,"clk_button_fridge"
  ,"opn_hofridge"
  ,"win_hofridge"
  ,"use_amuletwatch"
  ,"clk_steeringwheel"
  ,"dlg_flightdeck_atropos_4"
  ,"opn_mgfate"
  ,"win_mgfate"

  ,"get_collect2_4_1"
  ,"get_collect2_4_2"
  ,"get_collect2_4_3"
  ,"get_collect2_4_4"
  ,"get_morphobject_4_1"
  ,"get_morphobject_4_2"
  ,"get_morphobject_4_3"
  ,"get_morphobject_4_4"
  ,"get_morphobject_4_5"
  ,"get_morphobject_4_6"
  ,"get_morphobject_4_7"
  ,"get_morphobject_4_8"
  ,"get_morphobject_4_9"
  };

  game.relations = {};

  private.menu_moduls = {
    "rm_credits",
    "rm_collectibles",
    "rm_achievements"
  };

end;

function private.TutorialSetParams()

  if not ng_global.progress[ "ext" ][ "see_tutorial" ] then

    ng_global.progress[ "ext" ][ "see_tutorial" ] = {};
    ng_global.progress[ "ext" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "ext" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "ext" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "ext" ][ "see_tutorial" ].state.no = 0;
    ng_global.progress[ "ext" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "ext" ][ "see_tutorial" ].func = function() end;
    
    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );

    end;

    ng_global.progress[ "ext" ][ "see_tutorial" ].state.pages = {

      [ "tutorial_page_23" ] = { shown = 0, noskip = false, posx = 512, posy = 330, input = true, next = "tutorial_page_24", arrows = { 
                                                                              { pos_x = -70, pos_y = 50, ang = -1.57, target = "obj_mgfate_timer" },
                                                                              } }, -- MG fate tutorial 1
      [ "tutorial_page_24" ] = { shown = 0, noskip = false, posx = 512, posy = 330, input = true, next = "tutorial_page_25", arrows = { 
                                                                              { pos_x = 50, pos_y = -70, ang = 2.5, target = "obj_mgfate_life" },
                                                                              } }, -- MG fate tutorial 2
      [ "tutorial_page_25" ] = { shown = 0, noskip = false, posx = 512, posy = 330, input = true, next = "tutorial_page_26", arrows = { 
                                                                              { pos_x = 0, pos_y = -160, ang = 3.14, target = "obj_mgfate_hand_grays" },
                                                                              } }, -- MG fate tutorial 3
      [ "tutorial_page_26" ] = { shown = 0, noskip = false, posx = 512, posy = 330, input = true, next = "tutorial_page_27", arrows = { 
                                                                              { pos_x = 0, pos_y = -160, ang = 3.14, target = "obj_mgfate_hand_grays" },
                                                                              } }, -- MG fate tutorial 4
      --[ "tutorial_page_26" ] = { shown = 0, noskip = false, posx = 512, posy = 200, input = true, next = "tutorial_page_27", arrows = { 
      --                                                                        { pos_x = 100, pos_y = 20, ang = 1.57, target = "obj_mgfate_field" },
      --                                                                        } }, -- MG fate tutorial 4
      [ "tutorial_page_27" ] = { shown = 0, noskip = false, posx = 512, posy = 330, input = true, next = "tutorial_page_28", arrows = { 
                                                                              { pos_x = 0, pos_y = -50, ang = -3.14, target = "obj_mgfate_hand_atropos" },
                                                                              } }, -- MG fate tutorial 5
      --[ "tutorial_page_27" ] = { shown = 0, noskip = false, posx = 512, posy = 430, input = true, next = "tutorial_page_28", arrows = { 
      --                                                                        { pos_x = 100, pos_y = -145, ang = 1.57, target = "obj_mgfate_field" },
      --                                                                        } }, -- MG fate tutorial 5
      [ "tutorial_page_28" ] = { shown = 0, noskip = false, posx = 512, posy = 330, input = true, next = "tutorial_page_29", arrows = { 
                                                                              { pos_x = 100, pos_y = 85, ang = 1.57, target = "obj_mgfate_library" },
                                                                              } }, -- MG fate tutorial 6
      [ "tutorial_page_29" ] = { shown = 0, noskip = false, posx = 512, posy = 330, input = true, arrows = { 
                                                                              { pos_x = -70, pos_y = -205, ang = -1.57, target = "obj_mgfate_timer" },
                                                                              } }, -- MG fate tutorial 7
    };

  end;
  
end;
--***********************************************************************************************************************************
--***********************************************************************************************************************************