-- name=rm_moregames
--******************************************************************************************
function public.Init()

  ObjAttach( "rm_moregames", "rooms_hub" );

  ObjMultiSet( {

    { "btn_moregames_buttons_gt1", 
       {
         event_mdown =  function () private.ChangeURL( "1" ); end,
         event_menter = function () private.ButtonMouseEnter( "gt1" ); end,
         event_mleave = function () private.ButtonMouseLeave( "gt1" ); end 
       } 
    },
    { "btn_moregames_buttons_gt2",
      {
        event_mdown =  function () private.ChangeURL( "2" ); end,
        event_menter = function () private.ButtonMouseEnter( "gt2" ); end,
        event_mleave = function () private.ButtonMouseLeave( "gt2" ); end
      }
    },
    { "btn_moregames_buttons_gt3", 
      {
        event_mdown =  function () private.ChangeURL( "3" ); end,
        event_menter = function () private.ButtonMouseEnter( "gt3" ); end,
        event_mleave = function () private.ButtonMouseLeave( "gt3" ); end
      } 
    },
    { "btn_moregames_buttons_gt4", 
      {
        event_mdown =  function () private.ChangeURL( "4" ); end,
        event_menter = function () private.ButtonMouseEnter( "gt4" ); end,
        event_mleave = function () private.ButtonMouseLeave( "gt4" ); end
      } 
    },
    { "btn_moregames_buttons_gt5", 
      {
        event_mdown =  function () private.ChangeURL( "5" ); end,
        event_menter = function () private.ButtonMouseEnter( "gt5" ); end,
        event_mleave = function () private.ButtonMouseLeave( "gt5" ); end
      } 
    },
    { "btn_moregames_buttons_gt6",
      {
        event_mdown =  function () private.ChangeURL( "6" ); end,
        event_menter = function () private.ButtonMouseEnter( "gt6" ); end,
        event_mleave = function () private.ButtonMouseLeave( "gt6" ); end
      }
    },
    { "btn_moregames_buttons_gt7",
      {
        event_mdown =  function () private.ChangeURL( "7" ); end,
        event_menter = function () private.ButtonMouseEnter( "gt7" ); end,
        event_mleave = function () private.ButtonMouseLeave( "gt7" ); end
      }
    },
    { "btn_moregames_buttons_gt8",
      {
        event_mdown =  function () private.ChangeURL( "8" ); end,
        event_menter = function () private.ButtonMouseEnter( "gt8" ); end,
        event_mleave = function () private.ButtonMouseLeave( "gt8" ); end
      }
    },
    { "btn_moregames_buttons_to_menu",
      {
        event_mdown =  function () cmn.PlayAudio( "sfx", "audio/aud_click_menu" ); cmn.GotoRoom( "rm_menu" ); end,
        event_menter = function () private.ButtonMouseEnter( "to_menu" ); end,
        event_mleave = function () private.ButtonMouseLeave( "to_menu" ); end
      }
    }

  } );

  ----------------------------------------------------------------------------------------
  private.Link = 
  {
    -- games_1 
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/13636/mac/grim-tales-the-bride-collectors-edition/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/14020/mac/grim-tales-the-bride/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/13638/grim-tales-the-bride-collectors-edition/index.html",
      win_se = "http://www.bigfishgames.com/download-games/14022/grim-tales-the-bride/index.html"
    },
    -- games_2 
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/16127/mac/grim-tales-the-legacy-collectors-edition/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/16753/mac/grim-tales-the-legacy/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/15206/grim-tales-the-legacy-collectors-edition/index.html",
      win_se = "http://www.bigfishgames.com/download-games/16142/grim-tales-the-legacy/index.html"
    },
    -- games_3 
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/18677/mac/grim-tales-the-wishes-collectors-edition/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/19076/mac/grim-tales-the-wishes/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/18240/grim-tales-the-wishes-collectors-edition/index.html",
      win_se = "http://www.bigfishgames.com/download-games/18738/grim-tales-the-wishes/index.html"
    },
    -- games_4 
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/20851/mac/grim-tales-the-stone-queen-ce/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/21304/mac/grim-tales-the-stone-queen/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/20850/grim-tales-the-stone-queen-ce/index.html",
      win_se = "http://www.bigfishgames.com/download-games/21300/grim-tales-the-stone-queen/index.html"
    },
    -- games_5
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/23813/mac/grim-tales-bloody-mary-collectors-edition/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/25040/mac/grim-tales-bloody-mary/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/23812/grim-tales-bloody-mary-collectors-edition/index.html",
      win_se = "http://www.bigfishgames.com/download-games/24427/grim-tales-bloody-mary/index.html"
    },
    -- games_6
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/26784/mac/grim-tales-the-vengeance-ce/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/27068/mac/grim-tales-the-vengeance/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/26785/grim-tales-the-vengeance-ce/index.html",
      win_se = "http://www.bigfishgames.com/download-games/27067/grim-tales-the-vengeance/index.html"
    },
    -- games_7
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/28137/mac/grim-tales-color-of-fright-collectors-edition/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/28435/mac/grim-tales-color-of-fright/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/28136/grim-tales-color-of-fright-collectors-edition/index.html",
      win_se = "http://www.bigfishgames.com/download-games/28436/grim-tales-color-of-fright/index.html"
    },
    -- games_8
    { 
      mac_ce = "http://www.bigfishgames.com/games/11154/grim-tales-the-final-suspect-ce/?mac",
      mac_se = "http://www.bigfishgames.com/games/8598/grim-tales-the-final-suspect/?mac",
      win_ce = "http://www.bigfishgames.com/games/11154/grim-tales-the-final-suspect-ce/?pc",
      win_se = "http://www.bigfishgames.com/games/8598/grim-tales-the-final-suspect/?pc"
    }
  }

  private.InitAnimations();

end;
--******************************************************************************************
function public.PreOpen()
  
  if IsCollectorsEdition() then

    ObjSet( "obj_moregames_ce", { visible = 1 } );

  end;  
  
end;
--******************************************************************************************
function public.Open()

end;
--******************************************************************************************
function private.ChangeURL( but_name )
  
  local link = "";
  local mas_name = "Link";
  local platform = GetPlatform();
 
  local num_games = tonumber( string.sub( but_name, string.len( but_name ) ,string.len( but_name ) ) );

  if ( IsCollectorsEdition() ) then
    
    if ( platform == "mac" ) then
      
      link = private[ mas_name ][ num_games ][ "mac_ce" ];

    else
      
      link = private[ mas_name ][ num_games ][ "win_ce" ];
  
    end;

  else

    if ( platform == "mac" ) then
      
      link = private[ mas_name ][ num_games ][ "mac_se" ];      

    else
      
      link = private[ mas_name ][ num_games ][ "win_se" ];      
    
    end;

  end;

  OpenBrowser( link );

end;
--******************************************************************************************
function private.ButtonMouseEnter ( but_name )

  cmn.PlayAudio( "sfx", "audio/aud_guidance" );
  cmn.SetCursor( CURSOR_HAND );

  local obj = "pfx_moregames_buttons_"..but_name.."_focus";

  if ( ( GetPerformanceMode() == 1 ) or
       ( not ObjGet( "obj" ) ) ) then

      obj = "spr_moregames_buttons_"..but_name.."_focus";

  end;  

  local alp = ObjGet( obj ).alp;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

end;
--******************************************************************************************
function private.ButtonMouseLeave ( but_name )

  cmn.SetCursor( CURSOR_DEFAULT );

  local obj = "pfx_moregames_buttons_"..but_name.."_focus";

  if ( ( GetPerformanceMode() == 1 ) or
       ( not ObjGet( "obj" ) ) ) then

      obj = "spr_moregames_buttons_"..but_name.."_focus";

  end;  

  local alp = ObjGet( obj ).alp;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************
function private.InitAnimations()

  ObjAnimate( "obj_moregames_clouds_1", "pos_x", 1, 0, "", 
  { 
    0.0, 0, 0,
    120.5, 0, -1366
  } );
  ObjAnimate( "obj_moregames_clouds_2", "pos_x", 1, 0, "", 
  { 
    0.0, 0, 0,
    130.0, 0, -1422
  } );
  ObjAnimate( "obj_moregames_clouds_3", "pos_x", 1, 0, "", 
  { 
    0.0, 0, 0,
    140.0, 0, -1194
  } );
  ObjAnimate( "spr_moregames_add_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.5,
    3.0, 0, 1
  } );

end;
--******************************************************************************************