-- name=int_dialog_ho
--******************************************************************************************
function public.Init( pos_z )

  interface.LoadImplementation( "dialog_ho" );
  ObjAttach( "int_dialog_ho", interface.originhub );
  ObjSet( "int_dialog_ho", { pos_z = pos_z } );
  private.event_anim_end = {};
  private.item_object_name = nil;

end;
--******************************************************************************************
function public.Destroy()

end;
--******************************************************************************************
function public.MouseDown()

  local ho_name = common.GetObjectName( GetCurrentRoom() );
  local obj = "spr_"..ho_name.."_win_note";

  if ( ObjGet( obj ) ) then

    private.GetNote();

  end;

  public.Hide();

  local room = GetCurrentRoom();

  if ( room ~= "ho_investigatorsdesk2" and room ~= "ho_crashreport" ) then

    MsgSend( Event_DialogHo_Hide, {} );

  else

    private.GetMap();

  end;

end;
--******************************************************************************************
function public.EventAnimEnd( event_id )

  local event_params = private.event_anim_end[ event_id ];

------------------------------------------------------------------------------------
  if ( event_id == "show" ) then

    --ObjSet( "obj_int_dialog_ho_exit", { event_mdown = public.MouseDown } );

    ObjSet( "int_dialog_ho_impl", { input = true } );
    int.Lock( false );

  elseif ( event_id == "hide" ) then

    ObjSet( "int_dialog_ho_impl", { active = false, visible = false } );
    ObjSet( "int_dialog_ho",      { active = false, visible = false, input = false } );
    int.Lock( false );

  end;
------------------------------------------------------------------------------------
end;
--******************************************************************************************
function public.Show( item )

  private.item_object_name = item;

  ObjAttach( private.item_object_name, "obj_int_dialog_ho" );

  ObjSet( private.item_object_name,
  {
    active  = true,
    visible = true,
    input   = false,
    --pos_x   = 0,
    pos_y   = 60
  } );

  ObjSet( "int_dialog_ho",      { active = true, visible = true, input = true } );
  ObjSet( "int_dialog_ho_impl", { active = true, visible = true, input = false } );

  local event_id = "show";
  private.event_anim_end[ event_id ] = {};
  int_dialog_ho_impl.ShowAnim( event_id );

end;
--******************************************************************************************
function public.Hide()

  --ObjSet( "obj_int_dialog_ho_exit", { event_mdown = "" } );
  ObjSet( "int_dialog_ho_impl", { input = false } );

--  local obj_pos = GetObjPosByObj( private.item_object_name );
--
--  ObjSet( private.item_object_name, { pos_x = obj_pos[ 1 ], pos_y = obj_pos[ 2 ] } );
--
--  ObjDetach( private.item_object_name );
--
  local event_id = "hide";
  private.event_anim_end[ event_id ] = {};
  int_dialog_ho_impl.HideAnim( event_id );

end;
--******************************************************************************************
function private.GetNote ( )

  local func_end = function ()

    ng_global.task_current = "task_1";
    interface.KeyUpdate(); 

  end;

 local ho_name = common.GetObjectName( GetCurrentRoom() );

 local fly_obj_name2 = "spr_"..ho_name.."_win";
 local fly_obj_name = "spr_"..ho_name.."_win_note";

  ObjAttach( fly_obj_name, InterfaceWidget_Top_Name );

  local item_game_pos = GetObjPosByObj( object_name );

  local posx = ObjGet( fly_obj_name ).pos_x;
  local posx2 = ObjGet( fly_obj_name2 ).pos_x;
  local posy = ObjGet( fly_obj_name ).pos_y;
  local posy2 = ObjGet( fly_obj_name2 ).pos_y;

  local posy3 = ObjGet( "obj_int_dialog_ho_root" ).pos_y;

  ObjSet( fly_obj_name,
  {
    input      = 0,
    pos_x      = 512+posx+posx2,
    pos_y      = 384+posy+posy2+posy3
  } );

  local pos_y_inv = ObjGet( "int_inventory_impl" ).pos_y;
  local pos_y_btn_task = ObjGet( "obj_int_inventory_task" ).pos_y;

  ObjAnimate( fly_obj_name, "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, ObjGet( fly_obj_name ).pos_x, ObjGet( fly_obj_name ).pos_y,
      1.0, 0, ( 512-251 ), ( pos_y_inv+pos_y_btn_task ) 
    });

  ObjAnimate( fly_obj_name, "scale_xy", 0, 0, "", 
    { 
      0.0, 0, ObjGet( fly_obj_name ).scale_x, ObjGet( fly_obj_name ).scale_y,
      1.0, 0, 0.5, 0.5
    });

  ObjAnimate( fly_obj_name, "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.75, 0, 1,
      0.9, 0, 0
    });

end;
--*********************************************************************************************************************
function private.GetMap ()

 local ho_name = common.GetObjectName( GetCurrentRoom() );

 local fly_obj_name = "spr_"..ho_name.."_win";

  local func_end = function ()

    if ( IsCollectorsEdition() or IsSurveyEdition() ) then
      common_impl.PassingHoWin();
    end;
    cmn.CallEventHandler( "win_"..ho_name, GetCurrentRoom() );
    common.GotoRoom(  game.relations[ GetCurrentRoom() ].exitroom );

  end;
  ObjAttach( fly_obj_name, InterfaceWidget_Top_Name );

  local item_game_pos = GetObjPosByObj( object_name );

  ObjSet( fly_obj_name,
  {
    input      = 0,
    pos_x      = 512,
    pos_y      = 384
  } );

  ObjAnimate( fly_obj_name, "pos_xy", 0, 0, "", 
    { 
      0.0, 0, ObjGet( fly_obj_name ).pos_x, ObjGet( fly_obj_name ).pos_y,
      1.0, 0, ( 512+590 ), (384+300) 
    });

  ObjAnimate( fly_obj_name, "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.5, 0, 1,
      0.9, 0, 0
    });

  ObjAnimate( "int_button_map_impl", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.7, 0, 0,
      1.0, 0, 1
    });


end;
--*********************************************************************************************************************